/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var J=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/path","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/event","vs/base/common/types","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/environment/common/environment","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/telemetry/common/telemetry","vs/base/common/uuid","vs/platform/product/common/productService","os","vs/platform/files/common/watcher","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/stream","vs/base/parts/ipc/common/ipc","child_process","vs/platform/instantiation/common/descriptors","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/node/zip","vs/base/common/decorators","vs/base/common/extpath","fs","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/base/common/assert","vs/base/common/json","vs/base/common/processes","vs/base/common/skipList","vs/base/common/console","vs/base/common/marshalling","vs/base/common/labels","vs/base/node/decoder","vs/base/node/extpath","vs/base/node/powershell","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/map","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/node/spdlogLog","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/localizations/node/localizations","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","path","vs/platform/environment/node/argvHelper","vs/base/node/watcher","vs/base/common/iterator","graceful-fs","crypto","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],Q=function(x){for(var i=[],T=0,P=x.length;T<P;T++)i[T]=J[x[T]];return i};define(J[56],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ok=void 0;function T(P,b){if(!P)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}i.ok=T}),define(J[46],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.throttle=i.debounce=i.memoize=i.createDecorator=void 0;function T(R){return(w,l,v)=>{let E=null,C=null;if(typeof v.value=="function"?(E="value",C=v.value):typeof v.get=="function"&&(E="get",C=v.get),!C)throw new Error("not supported");v[E]=R(C,l)}}i.createDecorator=T;function P(R,w,l){let v=null,E=null;if(typeof l.value=="function"?(v="value",E=l.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(v="get",E=l.get),!E)throw new Error("not supported");const C=`$memoize$${w}`;l[v]=function(...c){return this.hasOwnProperty(C)||Object.defineProperty(this,C,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,c)}),this[C]}}i.memoize=P;function b(R,w,l){return T((v,E)=>{const C=`$debounce$${E}`,c=`$debounce$result$${E}`;return function(...y){this[c]||(this[c]=l?l():void 0),clearTimeout(this[C]),w&&(this[c]=w(this[c],...y),y=[this[c]]),this[C]=setTimeout(()=>{v.apply(this,y),this[c]=l?l():void 0},R)}})}i.debounce=b;function D(R,w,l){return T((v,E)=>{const C=`$throttle$timer$${E}`,c=`$throttle$result$${E}`,y=`$throttle$lastRun$${E}`,u=`$throttle$pending$${E}`;return function(...d){if(this[c]||(this[c]=l?l():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),w&&(this[c]=w(this[c],...d)),this[u])return;const g=this[y]+R;g<=Date.now()?(this[y]=Date.now(),v.apply(this,[this[c]]),this[c]=l?l():void 0):(this[u]=!0,this[C]=setTimeout(()=>{this[u]=!1,this[y]=Date.now(),v.apply(this,[this[c]]),this[c]=l?l():void 0},g-Date.now()))}})}i.throttle=D}),define(J[57],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getNodeType=i.stripComments=i.visit=i.findNodeAtOffset=i.contains=i.getNodeValue=i.getNodePath=i.findNodeAtLocation=i.parseTree=i.parse=i.getLocation=i.createScanner=i.ParseOptions=i.ParseErrorCode=i.SyntaxKind=i.ScanError=void 0;var T;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(T=i.ScanError||(i.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=i.SyntaxKind||(i.SyntaxKind={}));var b;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(b=i.ParseErrorCode||(i.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=i.ParseOptions||(i.ParseOptions={}));function R(t,s=!1){let e=0,n=t.length,r="",h=0,p=16,L=0;function I(ie){let pe=0,V=0;for(;pe<ie;){const B=t.charCodeAt(e);if(B>=48&&B<=57)V=V*16+B-48;else if(B>=65&&B<=70)V=V*16+B-65+10;else if(B>=97&&B<=102)V=V*16+B-97+10;else break;e++,pe++}return pe<ie&&(V=-1),V}function O(ie){e=ie,r="",h=0,p=16,L=0}function N(){const ie=e;if(t.charCodeAt(e)===48)e++;else for(e++;e<t.length&&v(t.charCodeAt(e));)e++;if(e<t.length&&t.charCodeAt(e)===46)if(e++,e<t.length&&v(t.charCodeAt(e)))for(e++;e<t.length&&v(t.charCodeAt(e));)e++;else return L=3,t.substring(ie,e);let pe=e;if(e<t.length&&(t.charCodeAt(e)===69||t.charCodeAt(e)===101))if(e++,(e<t.length&&t.charCodeAt(e)===43||t.charCodeAt(e)===45)&&e++,e<t.length&&v(t.charCodeAt(e))){for(e++;e<t.length&&v(t.charCodeAt(e));)e++;pe=e}else L=3;return t.substring(ie,pe)}function K(){let ie="",pe=e;for(;;){if(e>=n){ie+=t.substring(pe,e),L=2;break}const V=t.charCodeAt(e);if(V===34){ie+=t.substring(pe,e),e++;break}if(V===92){if(ie+=t.substring(pe,e),e++,e>=n){L=2;break}switch(t.charCodeAt(e++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const ne=I(4);ne>=0?ie+=String.fromCharCode(ne):L=4;break;default:L=5}pe=e;continue}if(V>=0&&V<=31)if(l(V)){ie+=t.substring(pe,e),L=2;break}else L=6;e++}return ie}function te(){if(r="",L=0,h=e,e>=n)return h=n,p=17;let ie=t.charCodeAt(e);if(w(ie)){do e++,r+=String.fromCharCode(ie),ie=t.charCodeAt(e);while(w(ie));return p=15}if(l(ie))return e++,r+=String.fromCharCode(ie),ie===13&&t.charCodeAt(e)===10&&(e++,r+=`
`),p=14;switch(ie){case 123:return e++,p=1;case 125:return e++,p=2;case 91:return e++,p=3;case 93:return e++,p=4;case 58:return e++,p=6;case 44:return e++,p=5;case 34:return e++,r=K(),p=10;case 47:const pe=e-1;if(t.charCodeAt(e+1)===47){for(e+=2;e<n&&!l(t.charCodeAt(e));)e++;return r=t.substring(pe,e),p=12}if(t.charCodeAt(e+1)===42){e+=2;const V=n-1;let B=!1;for(;e<V;){if(t.charCodeAt(e)===42&&t.charCodeAt(e+1)===47){e+=2,B=!0;break}e++}return B||(e++,L=1),r=t.substring(pe,e),p=13}return r+=String.fromCharCode(ie),e++,p=16;case 45:if(r+=String.fromCharCode(ie),e++,e===n||!v(t.charCodeAt(e)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=N(),p=11;default:for(;e<n&&ge(ie);)e++,ie=t.charCodeAt(e);if(h!==e){switch(r=t.substring(h,e),r){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return r+=String.fromCharCode(ie),e++,p=16}}function ge(ie){if(w(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let ie;do ie=te();while(ie>=12&&ie<=15);return ie}return{setPosition:O,getPosition:()=>e,scan:s?ce:te,getToken:()=>p,getTokenValue:()=>r,getTokenOffset:()=>h,getTokenLength:()=>e-h,getTokenError:()=>L}}i.createScanner=R;function w(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function l(t){return t===10||t===13||t===8232||t===8233}function v(t){return t>=48&&t<=57}var E;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(E||(E={}));function C(t,s){const e=[],n=new Object;let r;const h={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function L(I,O,N,K){h.value=I,h.offset=O,h.length=N,h.type=K,h.colonOffset=void 0,r=h}try{f(t,{onObjectBegin:(I,O)=>{if(s<=I)throw n;r=void 0,p=s>I,e.push("")},onObjectProperty:(I,O,N)=>{if(s<O||(L(I,O,N,"property"),e[e.length-1]=I,s<=O+N))throw n},onObjectEnd:(I,O)=>{if(s<=I)throw n;r=void 0,e.pop()},onArrayBegin:(I,O)=>{if(s<=I)throw n;r=void 0,e.push(0)},onArrayEnd:(I,O)=>{if(s<=I)throw n;r=void 0,e.pop()},onLiteralValue:(I,O,N)=>{if(s<O||(L(I,O,N,a(I)),s<=O+N))throw n},onSeparator:(I,O,N)=>{if(s<=O)throw n;if(I===":"&&r&&r.type==="property")r.colonOffset=O,p=!1,r=void 0;else if(I===","){const K=e[e.length-1];typeof K=="number"?e[e.length-1]=K+1:(p=!0,e[e.length-1]=""),r=void 0}}})}catch(I){if(I!==n)throw I}return{path:e,previousNode:r,isAtPropertyKey:p,matches:I=>{let O=0;for(let N=0;O<I.length&&N<e.length;N++)if(I[O]===e[N]||I[O]==="*")O++;else if(I[O]!=="**")return!1;return O===I.length}}}i.getLocation=C;function c(t,s=[],e=D.DEFAULT){let n=null,r=[];const h=[];function p(I){Array.isArray(r)?r.push(I):n!==null&&(r[n]=I)}return f(t,{onObjectBegin:()=>{const I={};p(I),h.push(r),r=I,n=null},onObjectProperty:I=>{n=I},onObjectEnd:()=>{r=h.pop()},onArrayBegin:()=>{const I=[];p(I),h.push(r),r=I,n=null},onArrayEnd:()=>{r=h.pop()},onLiteralValue:p,onError:(I,O,N)=>{s.push({error:I,offset:O,length:N})}},e),r[0]}i.parse=c;function y(t,s=[],e=D.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(I){n.type==="property"&&(n.length=I-n.offset,n=n.parent)}function h(I){return n.children.push(I),I}f(t,{onObjectBegin:I=>{n=h({type:"object",offset:I,length:-1,parent:n,children:[]})},onObjectProperty:(I,O,N)=>{n=h({type:"property",offset:O,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:I,offset:O,length:N,parent:n})},onObjectEnd:(I,O)=>{n.length=I+O-n.offset,n=n.parent,r(I+O)},onArrayBegin:(I,O)=>{n=h({type:"array",offset:I,length:-1,parent:n,children:[]})},onArrayEnd:(I,O)=>{n.length=I+O-n.offset,n=n.parent,r(I+O)},onLiteralValue:(I,O,N)=>{h({type:a(I),offset:O,length:N,parent:n,value:I}),r(O+N)},onSeparator:(I,O,N)=>{n.type==="property"&&(I===":"?n.colonOffset=O:I===","&&r(O))},onError:(I,O,N)=>{s.push({error:I,offset:O,length:N})}},e);const L=n.children[0];return L&&delete L.parent,L}i.parseTree=y;function u(t,s){if(!t)return;let e=t;for(let n of s)if(typeof n=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let r=!1;for(const h of e.children)if(Array.isArray(h.children)&&h.children[0].value===n){e=h.children[1],r=!0;break}if(!r)return}else{const r=n;if(e.type!=="array"||r<0||!Array.isArray(e.children)||r>=e.children.length)return;e=e.children[r]}return e}i.findNodeAtLocation=u;function d(t){if(!t.parent||!t.parent.children)return[];const s=d(t.parent);if(t.parent.type==="property"){const e=t.parent.children[0].value;s.push(e)}else if(t.parent.type==="array"){const e=t.parent.children.indexOf(t);e!==-1&&s.push(e)}return s}i.getNodePath=d;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":const s=Object.create(null);for(let e of t.children){const n=e.children[1];n&&(s[e.children[0].value]=g(n))}return s;case"null":case"string":case"number":case"boolean":return t.value;default:return}}i.getNodeValue=g;function m(t,s,e=!1){return s>=t.offset&&s<t.offset+t.length||e&&s===t.offset+t.length}i.contains=m;function S(t,s,e=!1){if(m(t,s,e)){const n=t.children;if(Array.isArray(n))for(let r=0;r<n.length&&n[r].offset<=s;r++){const h=S(n[r],s,e);if(h)return h}return t}}i.findNodeAtOffset=S;function f(t,s,e=D.DEFAULT){const n=R(t,!1);function r(H){return H?()=>H(n.getTokenOffset(),n.getTokenLength()):()=>!0}function h(H){return H?Z=>H(Z,n.getTokenOffset(),n.getTokenLength()):()=>!0}const p=r(s.onObjectBegin),L=h(s.onObjectProperty),I=r(s.onObjectEnd),O=r(s.onArrayBegin),N=r(s.onArrayEnd),K=h(s.onLiteralValue),te=h(s.onSeparator),ge=r(s.onComment),ce=h(s.onError),ie=e&&e.disallowComments,pe=e&&e.allowTrailingComma;function V(){for(;;){const H=n.scan();switch(n.getTokenError()){case 4:B(14);break;case 5:B(15);break;case 3:B(13);break;case 1:ie||B(11);break;case 2:B(12);break;case 6:B(16);break}switch(H){case 12:case 13:ie?B(10):ge();break;case 16:B(1);break;case 15:case 14:break;default:return H}}}function B(H,Z=[],_=[]){if(ce(H),Z.length+_.length>0){let ae=n.getToken();for(;ae!==17;){if(Z.indexOf(ae)!==-1){V();break}else if(_.indexOf(ae)!==-1)break;ae=V()}}}function ne(H){const Z=n.getTokenValue();return H?K(Z):L(Z),V(),!0}function M(){switch(n.getToken()){case 11:let H=0;try{H=JSON.parse(n.getTokenValue()),typeof H!="number"&&(B(2),H=0)}catch(Z){B(2)}K(H);break;case 7:K(null);break;case 8:K(!0);break;case 9:K(!1);break;default:return!1}return V(),!0}function k(){return n.getToken()!==10?(B(3,[],[2,5]),!1):(ne(!1),n.getToken()===6?(te(":"),V(),ee()||B(4,[],[2,5])):B(5,[],[2,5]),!0)}function j(){p(),V();let H=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(H||B(4,[],[]),te(","),V(),n.getToken()===2&&pe)break}else H&&B(6,[],[]);k()||B(4,[],[2,5]),H=!0}return I(),n.getToken()!==2?B(7,[2],[]):V(),!0}function G(){O(),V();let H=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(H||B(4,[],[]),te(","),V(),n.getToken()===4&&pe)break}else H&&B(6,[],[]);ee()||B(4,[],[4,5]),H=!0}return N(),n.getToken()!==4?B(8,[4],[]):V(),!0}function ee(){switch(n.getToken()){case 3:return G();case 1:return j();case 10:return ne(!0);default:return M()}}return V(),n.getToken()===17?e.allowEmptyContent?!0:(B(4,[],[]),!1):ee()?(n.getToken()!==17&&B(9,[],[]),!0):(B(4,[],[]),!1)}i.visit=f;function o(t,s){let e=R(t),n=[],r,h=0,p;do switch(p=e.getPosition(),r=e.scan(),r){case 12:case 13:case 17:h!==p&&n.push(t.substring(h,p)),s!==void 0&&n.push(e.getTokenValue().replace(/[^\r\n]/g,s)),h=e.getPosition();break}while(r!==17);return n.join("")}i.stripComments=o;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}i.getNodeType=a}),function(){function x(b){const D=[];typeof b=="number"&&D.push("code/timeOrigin",b);function R(l){D.push(l,Date.now())}function w(){const l=[];for(let v=0;v<D.length;v+=2)l.push({name:D[v],startTime:D[v+1]});return l}return{mark:R,getMarks:w}}function i(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const R of performance.getEntriesByType("mark"))D.push({name:R.name,startTime:Math.round(b+R.startTime)});return D}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function T(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=i()),b.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return T(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=T(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=T(P))}(),define(J[58],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.sanitizeProcessEnvironment=i.TerminateResponseCode=i.Source=void 0;var T;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(T=i.Source||(i.Source={}));var P;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(P=i.TerminateResponseCode||(i.TerminateResponseCode={}));function b(D,...R){const w=R.reduce((E,C)=>(E[C]=!0,E),{}),l=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(E=>!w[E]).forEach(E=>{for(let C=0;C<l.length;C++)if(E.search(l[C])!==-1){delete D[E];break}})}i.sanitizeProcessEnvironment=b}),function(x,i){if(typeof exports=="object"&&typeof module=="object")module.exports=i();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],i);else{var T=i();for(var P in T)(typeof exports=="object"?exports:x)[P]=T[P]}}(typeof self!="undefined"?self:this,function(){return function(x){var i={};function T(P){if(i[P])return i[P].exports;var b=i[P]={i:P,l:!1,exports:{}};return x[P].call(b.exports,b,b.exports,T),b.l=!0,b.exports}return T.m=x,T.c=i,T.d=function(P,b,D){T.o(P,b)||Object.defineProperty(P,b,{enumerable:!0,get:D})},T.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},T.t=function(P,b){if(1&b&&(P=T(P)),8&b||4&b&&typeof P=="object"&&P&&P.__esModule)return P;var D=Object.create(null);if(T.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:P}),2&b&&typeof P!="string")for(var R in P)T.d(D,R,function(w){return P[w]}.bind(null,R));return D},T.n=function(P){var b=P&&P.__esModule?function(){return P.default}:function(){return P};return T.d(b,"a",b),b},T.o=function(P,b){return Object.prototype.hasOwnProperty.call(P,b)},T.p="",T(T.s=0)}([function(x,i,T){(function(P){var b;i=x.exports=_,b=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},i.SEMVER_SPEC_VERSION="2.0.0";var D=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,w=i.re=[],l=i.src=[],v=0,E=v++;l[E]="0|[1-9]\\d*";var C=v++;l[C]="[0-9]+";var c=v++;l[c]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=v++;l[y]="("+l[E]+")\\.("+l[E]+")\\.("+l[E]+")";var u=v++;l[u]="("+l[C]+")\\.("+l[C]+")\\.("+l[C]+")";var d=v++;l[d]="(?:"+l[E]+"|"+l[c]+")";var g=v++;l[g]="(?:"+l[C]+"|"+l[c]+")";var m=v++;l[m]="(?:-("+l[d]+"(?:\\."+l[d]+")*))";var S=v++;l[S]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var f=v++;l[f]="[0-9A-Za-z-]+";var o=v++;l[o]="(?:\\+("+l[f]+"(?:\\."+l[f]+")*))";var a=v++,t="v?"+l[y]+l[m]+"?"+l[o]+"?";l[a]="^"+t+"$";var s="[v=\\s]*"+l[u]+l[S]+"?"+l[o]+"?",e=v++;l[e]="^"+s+"$";var n=v++;l[n]="((?:<|>)?=?)";var r=v++;l[r]=l[C]+"|x|X|\\*";var h=v++;l[h]=l[E]+"|x|X|\\*";var p=v++;l[p]="[v=\\s]*("+l[h]+")(?:\\.("+l[h]+")(?:\\.("+l[h]+")(?:"+l[m]+")?"+l[o]+"?)?)?";var L=v++;l[L]="[v=\\s]*("+l[r]+")(?:\\.("+l[r]+")(?:\\.("+l[r]+")(?:"+l[S]+")?"+l[o]+"?)?)?";var I=v++;l[I]="^"+l[n]+"\\s*"+l[p]+"$";var O=v++;l[O]="^"+l[n]+"\\s*"+l[L]+"$";var N=v++;l[N]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var K=v++;l[K]="(?:~>?)";var te=v++;l[te]="(\\s*)"+l[K]+"\\s+",w[te]=new RegExp(l[te],"g");var ge=v++;l[ge]="^"+l[K]+l[p]+"$";var ce=v++;l[ce]="^"+l[K]+l[L]+"$";var ie=v++;l[ie]="(?:\\^)";var pe=v++;l[pe]="(\\s*)"+l[ie]+"\\s+",w[pe]=new RegExp(l[pe],"g");var V=v++;l[V]="^"+l[ie]+l[p]+"$";var B=v++;l[B]="^"+l[ie]+l[L]+"$";var ne=v++;l[ne]="^"+l[n]+"\\s*("+s+")$|^$";var M=v++;l[M]="^"+l[n]+"\\s*("+t+")$|^$";var k=v++;l[k]="(\\s*)"+l[n]+"\\s*("+s+"|"+l[p]+")",w[k]=new RegExp(l[k],"g");var j=v++;l[j]="^\\s*("+l[p]+")\\s+-\\s+("+l[p]+")\\s*$";var G=v++;l[G]="^\\s*("+l[L]+")\\s+-\\s+("+l[L]+")\\s*$";var ee=v++;l[ee]="(<|>)?=?\\s*\\*";for(var H=0;H<35;H++)b(H,l[H]),w[H]||(w[H]=new RegExp(l[H]));function Z(F,z){if(F instanceof _)return F;if(typeof F!="string"||F.length>D||!(z?w[e]:w[a]).test(F))return null;try{return new _(F,z)}catch($){return null}}function _(F,z){if(F instanceof _){if(F.loose===z)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof _))return new _(F,z);b("SemVer",F,z),this.loose=z;var $=F.trim().match(z?w[e]:w[a]);if(!$)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+$[1],this.minor=+$[2],this.patch=+$[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");$[4]?this.prerelease=$[4].split(".").map(function(le){if(/^[0-9]+$/.test(le)){var me=+le;if(me>=0&&me<R)return me}return le}):this.prerelease=[],this.build=$[5]?$[5].split("."):[],this.format()}i.parse=Z,i.valid=function(F,z){var $=Z(F,z);return $?$.version:null},i.clean=function(F,z){var $=Z(F.trim().replace(/^[=v]+/,""),z);return $?$.version:null},i.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(F){return b("SemVer.compare",this.version,this.loose,F),F instanceof _||(F=new _(F,this.loose)),this.compareMain(F)||this.comparePre(F)},_.prototype.compareMain=function(F){return F instanceof _||(F=new _(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},_.prototype.comparePre=function(F){if(F instanceof _||(F=new _(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var z=0;do{var $=this.prerelease[z],le=F.prerelease[z];if(b("prerelease compare",z,$,le),$===void 0&&le===void 0)return 0;if(le===void 0)return 1;if($===void 0)return-1;if($!==le)return U($,le)}while(++z)},_.prototype.inc=function(F,z){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",z);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",z);break;case"prepatch":this.prerelease.length=0,this.inc("patch",z),this.inc("pre",z);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",z),this.inc("pre",z);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $=this.prerelease.length;--$>=0;)typeof this.prerelease[$]=="number"&&(this.prerelease[$]++,$=-2);$===-1&&this.prerelease.push(0)}z&&(this.prerelease[0]===z?isNaN(this.prerelease[1])&&(this.prerelease=[z,0]):this.prerelease=[z,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},i.inc=function(F,z,$,le){typeof $=="string"&&(le=$,$=void 0);try{return new _(F,$).inc(z,le).version}catch(me){return null}},i.diff=function(F,z){if(Y(F,z))return null;var $=Z(F),le=Z(z);if($.prerelease.length||le.prerelease.length){for(var me in $)if((me==="major"||me==="minor"||me==="patch")&&$[me]!==le[me])return"pre"+me;return"prerelease"}for(var me in $)if((me==="major"||me==="minor"||me==="patch")&&$[me]!==le[me])return me},i.compareIdentifiers=U;var ae=/^[0-9]+$/;function U(F,z){var $=ae.test(F),le=ae.test(z);return $&&le&&(F=+F,z=+z),$&&!le?-1:le&&!$?1:F<z?-1:F>z?1:0}function A(F,z,$){return new _(F,$).compare(new _(z,$))}function q(F,z,$){return A(F,z,$)>0}function W(F,z,$){return A(F,z,$)<0}function Y(F,z,$){return A(F,z,$)===0}function X(F,z,$){return A(F,z,$)!==0}function de(F,z,$){return A(F,z,$)>=0}function fe(F,z,$){return A(F,z,$)<=0}function ue(F,z,$,le){var me;switch(z){case"===":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),me=F===$;break;case"!==":typeof F=="object"&&(F=F.version),typeof $=="object"&&($=$.version),me=F!==$;break;case"":case"=":case"==":me=Y(F,$,le);break;case"!=":me=X(F,$,le);break;case">":me=q(F,$,le);break;case">=":me=de(F,$,le);break;case"<":me=W(F,$,le);break;case"<=":me=fe(F,$,le);break;default:throw new TypeError("Invalid operator: "+z)}return me}function re(F,z){if(F instanceof re){if(F.loose===z)return F;F=F.value}if(!(this instanceof re))return new re(F,z);b("comparator",F,z),this.loose=z,this.parse(F),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}i.rcompareIdentifiers=function(F,z){return U(z,F)},i.major=function(F,z){return new _(F,z).major},i.minor=function(F,z){return new _(F,z).minor},i.patch=function(F,z){return new _(F,z).patch},i.compare=A,i.compareLoose=function(F,z){return A(F,z,!0)},i.rcompare=function(F,z,$){return A(z,F,$)},i.sort=function(F,z){return F.sort(function($,le){return i.compare($,le,z)})},i.rsort=function(F,z){return F.sort(function($,le){return i.rcompare($,le,z)})},i.gt=q,i.lt=W,i.eq=Y,i.neq=X,i.gte=de,i.lte=fe,i.cmp=ue,i.Comparator=re;var ye={};function oe(F,z){if(F instanceof oe)return F.loose===z?F:new oe(F.raw,z);if(F instanceof re)return new oe(F.value,z);if(!(this instanceof oe))return new oe(F,z);if(this.loose=z,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function($){return this.parseRange($.trim())},this).filter(function($){return $.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function he(F){return!F||F.toLowerCase()==="x"||F==="*"}function Ce(F,z,$,le,me,Re,Se,ke,Pe,Oe,Me,De,Te){return((z=he($)?"":he(le)?">="+$+".0.0":he(me)?">="+$+"."+le+".0":">="+z)+" "+(ke=he(Pe)?"":he(Oe)?"<"+(+Pe+1)+".0.0":he(Me)?"<"+Pe+"."+(+Oe+1)+".0":De?"<="+Pe+"."+Oe+"."+Me+"-"+De:"<="+ke)).trim()}function xe(F,z){for(var $=0;$<F.length;$++)if(!F[$].test(z))return!1;if(z.prerelease.length){for($=0;$<F.length;$++)if(b(F[$].semver),F[$].semver!==ye&&F[$].semver.prerelease.length>0){var le=F[$].semver;if(le.major===z.major&&le.minor===z.minor&&le.patch===z.patch)return!0}return!1}return!0}function Ae(F,z,$){try{z=new oe(z,$)}catch(le){return!1}return z.test(F)}function je(F,z,$,le){var me,Re,Se,ke,Pe;switch(F=new _(F,le),z=new oe(z,le),$){case">":me=q,Re=fe,Se=W,ke=">",Pe=">=";break;case"<":me=W,Re=de,Se=q,ke="<",Pe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ae(F,z,le))return!1;for(var Oe=0;Oe<z.set.length;++Oe){var Me=z.set[Oe],De=null,Te=null;if(Me.forEach(function(Fe){Fe.semver===ye&&(Fe=new re(">=0.0.0")),De=De||Fe,Te=Te||Fe,me(Fe.semver,De.semver,le)?De=Fe:Se(Fe.semver,Te.semver,le)&&(Te=Fe)}),De.operator===ke||De.operator===Pe||(!Te.operator||Te.operator===ke)&&Re(F,Te.semver)||Te.operator===Pe&&Se(F,Te.semver))return!1}return!0}re.prototype.parse=function(F){var z=this.loose?w[ne]:w[M],$=F.match(z);if(!$)throw new TypeError("Invalid comparator: "+F);this.operator=$[1],this.operator==="="&&(this.operator=""),$[2]?this.semver=new _($[2],this.loose):this.semver=ye},re.prototype.toString=function(){return this.value},re.prototype.test=function(F){return b("Comparator.test",F,this.loose),this.semver===ye||(typeof F=="string"&&(F=new _(F,this.loose)),ue(F,this.operator,this.semver,this.loose))},re.prototype.intersects=function(F,z){if(!(F instanceof re))throw new TypeError("a Comparator is required");var $;if(this.operator==="")return $=new oe(F.value,z),Ae(this.value,$,z);if(F.operator==="")return $=new oe(this.value,z),Ae(F.semver,$,z);var le=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Re=this.semver.version===F.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),ke=ue(this.semver,"<",F.semver,z)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),Pe=ue(this.semver,">",F.semver,z)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return le||me||Re&&Se||ke||Pe},i.Range=oe,oe.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},oe.prototype.toString=function(){return this.range},oe.prototype.parseRange=function(F){var z=this.loose;F=F.trim(),b("range",F,z);var $=z?w[G]:w[j];F=F.replace($,Ce),b("hyphen replace",F),F=F.replace(w[k],"$1$2$3"),b("comparator trim",F,w[k]),F=(F=(F=F.replace(w[te],"$1~")).replace(w[pe],"$1^")).split(/\s+/).join(" ");var le=z?w[ne]:w[M],me=F.split(" ").map(function(Re){return function(Se,ke){return b("comp",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(Me){return function(De,Te){b("caret",De,Te);var Fe=Te?w[B]:w[V];return De.replace(Fe,function(Ne,Ee,we,be,Ie){var Le;return b("caret",De,Ne,Ee,we,be,Ie),he(Ee)?Le="":he(we)?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":he(be)?Le=Ee==="0"?">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+".0 <"+(+Ee+1)+".0.0":Ie?(b("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+Ie+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+Ie+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+Ie+" <"+(+Ee+1)+".0.0"):(b("no pr"),Le=Ee==="0"?we==="0"?">="+Ee+"."+we+"."+be+" <"+Ee+"."+we+"."+(+be+1):">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0":">="+Ee+"."+we+"."+be+" <"+(+Ee+1)+".0.0"),b("caret return",Le),Le})}(Me,Oe)}).join(" ")}(Se,ke),b("caret",Se),Se=function(Pe,Oe){return Pe.trim().split(/\s+/).map(function(Me){return function(De,Te){var Fe=Te?w[ce]:w[ge];return De.replace(Fe,function(Ne,Ee,we,be,Ie){var Le;return b("tilde",De,Ne,Ee,we,be,Ie),he(Ee)?Le="":he(we)?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":he(be)?Le=">="+Ee+"."+we+".0 <"+Ee+"."+(+we+1)+".0":Ie?(b("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+Ee+"."+we+"."+be+Ie+" <"+Ee+"."+(+we+1)+".0"):Le=">="+Ee+"."+we+"."+be+" <"+Ee+"."+(+we+1)+".0",b("tilde return",Le),Le})}(Me,Oe)}).join(" ")}(Se,ke),b("tildes",Se),Se=function(Pe,Oe){return b("replaceXRanges",Pe,Oe),Pe.split(/\s+/).map(function(Me){return function(De,Te){De=De.trim();var Fe=Te?w[O]:w[I];return De.replace(Fe,function(Ne,Ee,we,be,Ie,Le){b("xRange",De,Ne,Ee,we,be,Ie,Le);var We=he(we),ze=We||he(be),Ve=ze||he(Ie);return Ee==="="&&Ve&&(Ee=""),We?Ne=Ee===">"||Ee==="<"?"<0.0.0":"*":Ee&&Ve?(ze&&(be=0),Ve&&(Ie=0),Ee===">"?(Ee=">=",ze?(we=+we+1,be=0,Ie=0):Ve&&(be=+be+1,Ie=0)):Ee==="<="&&(Ee="<",ze?we=+we+1:be=+be+1),Ne=Ee+we+"."+be+"."+Ie):ze?Ne=">="+we+".0.0 <"+(+we+1)+".0.0":Ve&&(Ne=">="+we+"."+be+".0 <"+we+"."+(+be+1)+".0"),b("xRange return",Ne),Ne})}(Me,Oe)}).join(" ")}(Se,ke),b("xrange",Se),Se=function(Pe,Oe){return b("replaceStars",Pe,Oe),Pe.trim().replace(w[ee],"")}(Se,ke),b("stars",Se),Se}(Re,z)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Re){return!!Re.match(le)})),me=me.map(function(Re){return new re(Re,z)})},oe.prototype.intersects=function(F,z){if(!(F instanceof oe))throw new TypeError("a Range is required");return this.set.some(function($){return $.every(function(le){return F.set.some(function(me){return me.every(function(Re){return le.intersects(Re,z)})})})})},i.toComparators=function(F,z){return new oe(F,z).set.map(function($){return $.map(function(le){return le.value}).join(" ").trim().split(" ")})},oe.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new _(F,this.loose));for(var z=0;z<this.set.length;z++)if(xe(this.set[z],F))return!0;return!1},i.satisfies=Ae,i.maxSatisfying=function(F,z,$){var le=null,me=null;try{var Re=new oe(z,$)}catch(Se){return null}return F.forEach(function(Se){Re.test(Se)&&(le&&me.compare(Se)!==-1||(me=new _(le=Se,$)))}),le},i.minSatisfying=function(F,z,$){var le=null,me=null;try{var Re=new oe(z,$)}catch(Se){return null}return F.forEach(function(Se){Re.test(Se)&&(le&&me.compare(Se)!==1||(me=new _(le=Se,$)))}),le},i.validRange=function(F,z){try{return new oe(F,z).range||"*"}catch($){return null}},i.ltr=function(F,z,$){return je(F,z,"<",$)},i.gtr=function(F,z,$){return je(F,z,">",$)},i.outside=je,i.prerelease=function(F,z){var $=Z(F,z);return $&&$.prerelease.length?$.prerelease:null},i.intersects=function(F,z,$){return F=new oe(F,$),z=new oe(z,$),F.intersects(z)},i.coerce=function(F){if(F instanceof _)return F;if(typeof F!="string")return null;var z=F.match(w[N]);return z==null?null:Z((z[1]||"0")+"."+(z[2]||"0")+"."+(z[3]||"0"))}}).call(this,T(1))},function(x,i){var T,P,b=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function w(g){if(T===setTimeout)return setTimeout(g,0);if((T===D||!T)&&setTimeout)return T=setTimeout,setTimeout(g,0);try{return T(g,0)}catch(m){try{return T.call(null,g,0)}catch(S){return T.call(this,g,0)}}}(function(){try{T=typeof setTimeout=="function"?setTimeout:D}catch(g){T=D}try{P=typeof clearTimeout=="function"?clearTimeout:R}catch(g){P=R}})();var l,v=[],E=!1,C=-1;function c(){E&&l&&(E=!1,l.length?v=l.concat(v):C=-1,v.length&&y())}function y(){if(!E){var g=w(c);E=!0;for(var m=v.length;m;){for(l=v,v=[];++C<m;)l&&l[C].run();C=-1,m=v.length}l=null,E=!1,function(S){if(P===clearTimeout)return clearTimeout(S);if((P===R||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(S);try{P(S)}catch(f){try{return P.call(null,S)}catch(o){return P.call(this,S)}}}(g)}}function u(g,m){this.fun=g,this.array=m}function d(){}b.nextTick=function(g){var m=new Array(arguments.length-1);if(arguments.length>1)for(var S=1;S<arguments.length;S++)m[S-1]=arguments[S];v.push(new u(g,m)),v.length!==1||E||w(y)},u.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=d,b.addListener=d,b.once=d,b.off=d,b.removeListener=d,b.removeAllListeners=d,b.emit=d,b.prependListener=d,b.prependOnceListener=d,b.listeners=function(g){return[]},b.binding=function(g){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(g){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(J[59],Q([0,1]),function(x,i){"use strict";var T;Object.defineProperty(i,"__esModule",{value:!0}),i.SkipList=void 0;class P{constructor(w,l,v){this.level=w,this.key=l,this.value=v,this.forward=[]}}const b=void 0;class D{constructor(w,l=2**16){this.comparator=w,this[T]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(l)|0),this._header=new P(this._maxLevel,b,b)}get size(){return this._size}clear(){this._header=new P(this._maxLevel,b,b)}has(w){return Boolean(D._search(this,w,this.comparator))}get(w){return D._search(this,w,this.comparator)?.value}set(w,l){return D._insert(this,w,l,this.comparator)&&(this._size+=1),this}delete(w){const l=D._delete(this,w,this.comparator);return l&&(this._size-=1),l}forEach(w,l){let v=this._header.forward[0];for(;v;)w.call(l,v.value,v.key,this),v=v.forward[0]}[(T=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let w=this._header.forward[0];for(;w;)yield[w.key,w.value],w=w.forward[0]}*keys(){let w=this._header.forward[0];for(;w;)yield w.key,w=w.forward[0]}*values(){let w=this._header.forward[0];for(;w;)yield w.value,w=w.forward[0]}toString(){let w="[SkipList]:",l=this._header.forward[0];for(;l;)w+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return w}static _search(w,l,v){let E=w._header;for(let C=w._level-1;C>=0;C--)for(;E.forward[C]&&v(E.forward[C].key,l)<0;)E=E.forward[C];if(E=E.forward[0],E&&v(E.key,l)===0)return E}static _insert(w,l,v,E){let C=[],c=w._header;for(let y=w._level-1;y>=0;y--){for(;c.forward[y]&&E(c.forward[y].key,l)<0;)c=c.forward[y];C[y]=c}if(c=c.forward[0],c&&E(c.key,l)===0)return c.value=v,!1;{let y=D._randomLevel(w);if(y>w._level){for(let u=w._level;u<y;u++)C[u]=w._header;w._level=y}c=new P(y,l,v);for(let u=0;u<y;u++)c.forward[u]=C[u].forward[u],C[u].forward[u]=c;return!0}}static _randomLevel(w,l=.5){let v=1;for(;Math.random()<l&&v<w._maxLevel;)v+=1;return v}static _delete(w,l,v){let E=[],C=w._header;for(let c=w._level-1;c>=0;c--){for(;C.forward[c]&&v(C.forward[c].key,l)<0;)C=C.forward[c];E[c]=C}if(C=C.forward[0],!C||v(C.key,l)!==0)return!1;for(let c=0;c<w._level&&E[c].forward[c]===C;c++)E[c].forward[c]=C.forward[c];for(;w._level>0&&w._header.forward[w._level-1]===b;)w._level-=1;return!0}}i.SkipList=D}),define(J[38],Q([0,1,7,2]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedStream=i.prefixedReadable=i.transform=i.toReadable=i.emptyStream=i.toStream=i.peekStream=i.listenStream=i.consumeStream=i.peekReadable=i.consumeReadable=i.newWriteableStream=i.isReadableBufferedStream=i.isReadableStream=void 0;function b(f){const o=f;return o?[o.on,o.pause,o.resume,o.destroy].every(a=>typeof a=="function"):!1}i.isReadableStream=b;function D(f){const o=f;return o?b(o.stream)&&Array.isArray(o.buffer)&&typeof o.ended=="boolean":!1}i.isReadableBufferedStream=D;function R(f,o){return new w(f,o)}i.newWriteableStream=R;class w{constructor(o,a){this.reducer=o,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(o){if(!this.state.destroyed){if(this.state.flowing)this.emitData(o);else if(this.buffer.data.push(o),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(a=>this.pendingWritePromises.push(a))}}error(o){this.state.destroyed||(this.state.flowing?this.emitError(o):this.buffer.error.push(o))}end(o){this.state.destroyed||(typeof o!="undefined"&&this.write(o),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(o){this.listeners.data.slice(0).forEach(a=>a(o))}emitError(o){this.listeners.error.length===0?(0,T.onUnexpectedError)(o):this.listeners.error.slice(0).forEach(a=>a(o))}emitEnd(){this.listeners.end.slice(0).forEach(o=>o())}on(o,a){if(!this.state.destroyed)switch(o){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(o,a){if(this.state.destroyed)return;let t;switch(o){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const s=t.indexOf(a);s>=0&&t.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const o=this.reducer(this.buffer.data);this.emitData(o),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const o of this.buffer.error)this.emitError(o);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function l(f,o){const a=[];let t;for(;(t=f.read())!==null;)a.push(t);return o(a)}i.consumeReadable=l;function v(f,o,a){const t=[];let s;for(;(s=f.read())!==null&&t.length<a;)t.push(s);return s===null&&t.length>0?o(t):{read:()=>{if(t.length>0)return t.shift();if(typeof s!="undefined"){const e=s;return s=void 0,e}return f.read()}}}i.peekReadable=v;function E(f,o){return new Promise((a,t)=>{const s=[];C(f,{onData:e=>{o&&s.push(e)},onError:e=>{o?t(e):a(void 0)},onEnd:()=>{a(o?o(s):void 0)}})})}i.consumeStream=E;function C(f,o){f.on("error",a=>o.onError(a)),f.on("end",()=>o.onEnd()),f.on("data",a=>o.onData(a))}i.listenStream=C;function c(f,o){return new Promise((a,t)=>{const s=new P.DisposableStore,e=[],n=p=>{if(e.push(p),e.length>o)return s.dispose(),f.pause(),a({stream:f,buffer:e,ended:!1})},r=p=>t(p),h=()=>a({stream:f,buffer:e,ended:!0});s.add((0,P.toDisposable)(()=>f.removeListener("error",r))),f.on("error",r),s.add((0,P.toDisposable)(()=>f.removeListener("end",h))),f.on("end",h),s.add((0,P.toDisposable)(()=>f.removeListener("data",n))),f.on("data",n)})}i.peekStream=c;function y(f,o){const a=R(o);return a.end(f),a}i.toStream=y;function u(){const f=R(()=>{throw new Error("not supported")});return f.end(),f}i.emptyStream=u;function d(f){let o=!1;return{read:()=>o?null:(o=!0,f)}}i.toReadable=d;function g(f,o,a){const t=R(a);return C(f,{onData:s=>t.write(o.data(s)),onError:s=>t.error(o.error?o.error(s):s),onEnd:()=>t.end()}),t}i.transform=g;function m(f,o,a){let t=!1;return{read:()=>{const s=o.read();return t?s:(t=!0,s!==null?a([f,s]):f)}}}i.prefixedReadable=m;function S(f,o,a){let t=!1;const s=R(a);return C(o,{onData:e=>t?s.write(e):(t=!0,s.write(a([f,e]))),onError:e=>s.error(e),onEnd:()=>{t||(t=!0,s.write(f)),s.end()}}),s}i.prefixedStream=S}),define(J[17],Q([0,1,38]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.prefixedBufferStream=i.prefixedBufferReadable=i.newWriteableBufferStream=i.streamToBufferReadableStream=i.bufferToStream=i.bufferedStreamToBuffer=i.streamToBuffer=i.bufferToReadable=i.readableToBuffer=i.writeUInt8=i.readUInt8=i.writeUInt32LE=i.readUInt32LE=i.writeUInt32BE=i.readUInt32BE=i.writeUInt16LE=i.readUInt16LE=i.VSBuffer=void 0;const P=typeof Buffer!="undefined";let b,D;class R{constructor(n){this.buffer=n,this.byteLength=this.buffer.byteLength}static alloc(n){return P?new R(Buffer.allocUnsafe(n)):new R(new Uint8Array(n))}static wrap(n){return P&&!Buffer.isBuffer(n)&&(n=Buffer.from(n.buffer,n.byteOffset,n.byteLength)),new R(n)}static fromString(n,r){return!(r?.dontUseNodeBuffer||!1)&&P?new R(Buffer.from(n)):(b||(b=new TextEncoder),new R(b.encode(n)))}static fromByteArray(n){const r=R.alloc(n.length);for(let h=0,p=n.length;h<p;h++)r.buffer[h]=n[h];return r}static concat(n,r){if(typeof r=="undefined"){r=0;for(let L=0,I=n.length;L<I;L++)r+=n[L].byteLength}const h=R.alloc(r);let p=0;for(let L=0,I=n.length;L<I;L++){const O=n[L];h.set(O,p),p+=O.byteLength}return h}clone(){const n=R.alloc(this.byteLength);return n.set(this),n}toString(){return P?this.buffer.toString():(D||(D=new TextDecoder),D.decode(this.buffer))}slice(n,r){return new R(this.buffer.subarray(n,r))}set(n,r){if(n instanceof R)this.buffer.set(n.buffer,r);else if(n instanceof Uint8Array)this.buffer.set(n,r);else if(n instanceof ArrayBuffer)this.buffer.set(new Uint8Array(n),r);else if(ArrayBuffer.isView(n))this.buffer.set(new Uint8Array(n.buffer,n.byteOffset,n.byteLength),r);else throw new Error("Unkown argument 'array'")}readUInt32BE(n){return v(this.buffer,n)}writeUInt32BE(n,r){E(this.buffer,n,r)}readUInt32LE(n){return C(this.buffer,n)}writeUInt32LE(n,r){c(this.buffer,n,r)}readUInt8(n){return y(this.buffer,n)}writeUInt8(n,r){u(this.buffer,n,r)}}i.VSBuffer=R;function w(e,n){return e[n+0]<<0>>>0|e[n+1]<<8>>>0}i.readUInt16LE=w;function l(e,n,r){e[r+0]=n&255,n=n>>>8,e[r+1]=n&255}i.writeUInt16LE=l;function v(e,n){return e[n]*2**24+e[n+1]*2**16+e[n+2]*2**8+e[n+3]}i.readUInt32BE=v;function E(e,n,r){e[r+3]=n,n=n>>>8,e[r+2]=n,n=n>>>8,e[r+1]=n,n=n>>>8,e[r]=n}i.writeUInt32BE=E;function C(e,n){return e[n+0]<<0>>>0|e[n+1]<<8>>>0|e[n+2]<<16>>>0|e[n+3]<<24>>>0}i.readUInt32LE=C;function c(e,n,r){e[r+0]=n&255,n=n>>>8,e[r+1]=n&255,n=n>>>8,e[r+2]=n&255,n=n>>>8,e[r+3]=n&255}i.writeUInt32LE=c;function y(e,n){return e[n]}i.readUInt8=y;function u(e,n,r){e[r]=n}i.writeUInt8=u;function d(e){return T.consumeReadable(e,n=>R.concat(n))}i.readableToBuffer=d;function g(e){return T.toReadable(e)}i.bufferToReadable=g;function m(e){return T.consumeStream(e,n=>R.concat(n))}i.streamToBuffer=m;async function S(e){return e.ended?R.concat(e.buffer):R.concat([...e.buffer,await m(e.stream)])}i.bufferedStreamToBuffer=S;function f(e){return T.toStream(e,n=>R.concat(n))}i.bufferToStream=f;function o(e){return T.transform(e,{data:n=>typeof n=="string"?R.fromString(n):R.wrap(n)},n=>R.concat(n))}i.streamToBufferReadableStream=o;function a(e){return T.newWriteableStream(n=>R.concat(n),e)}i.newWriteableBufferStream=a;function t(e,n){return T.prefixedReadable(e,n,r=>R.concat(r))}i.prefixedBufferReadable=t;function s(e,n){return T.prefixedStream(e,n,r=>R.concat(r))}i.prefixedBufferStream=s}),define(J[21],Q([0,1,11]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.filter=i.getCaseInsensitive=i.distinct=i.getOrDefault=i.safeStringify=i.equals=i.mixin=i.cloneAndChange=i.deepFreeze=i.deepClone=void 0;function P(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const g=Array.isArray(d)?[]:{};return Object.keys(d).forEach(m=>{d[m]&&typeof d[m]=="object"?g[m]=P(d[m]):g[m]=d[m]}),g}i.deepClone=P;function b(d){if(!d||typeof d!="object")return d;const g=[d];for(;g.length>0;){const m=g.shift();Object.freeze(m);for(const S in m)if(D.call(m,S)){const f=m[S];typeof f=="object"&&!Object.isFrozen(f)&&g.push(f)}}return d}i.deepFreeze=b;const D=Object.prototype.hasOwnProperty;function R(d,g){return w(d,g,new Set)}i.cloneAndChange=R;function w(d,g,m){if((0,T.isUndefinedOrNull)(d))return d;const S=g(d);if(typeof S!="undefined")return S;if((0,T.isArray)(d)){const f=[];for(const o of d)f.push(w(o,g,m));return f}if((0,T.isObject)(d)){if(m.has(d))throw new Error("Cannot clone recursive data-structure");m.add(d);const f={};for(let o in d)D.call(d,o)&&(f[o]=w(d[o],g,m));return m.delete(d),f}return d}function l(d,g,m=!0){return(0,T.isObject)(d)?((0,T.isObject)(g)&&Object.keys(g).forEach(S=>{S in d?m&&((0,T.isObject)(d[S])&&(0,T.isObject)(g[S])?l(d[S],g[S],m):d[S]=g[S]):d[S]=g[S]}),d):g}i.mixin=l;function v(d,g){if(d===g)return!0;if(d==null||g===null||g===void 0||typeof d!=typeof g||typeof d!="object"||Array.isArray(d)!==Array.isArray(g))return!1;let m,S;if(Array.isArray(d)){if(d.length!==g.length)return!1;for(m=0;m<d.length;m++)if(!v(d[m],g[m]))return!1}else{const f=[];for(S in d)f.push(S);f.sort();const o=[];for(S in g)o.push(S);if(o.sort(),!v(f,o))return!1;for(m=0;m<f.length;m++)if(!v(d[f[m]],g[f[m]]))return!1}return!0}i.equals=v;function E(d){const g=new Set;return JSON.stringify(d,(m,S)=>{if((0,T.isObject)(S)||Array.isArray(S)){if(g.has(S))return"[Circular]";g.add(S)}return S})}i.safeStringify=E;function C(d,g,m){const S=g(d);return typeof S=="undefined"?m:S}i.getOrDefault=C;function c(d,g){const m=Object.create(null);return!d||!g||Object.keys(g).forEach(f=>{const o=d[f],a=g[f];v(o,a)||(m[f]=a)}),m}i.distinct=c;function y(d,g){const m=g.toLowerCase(),S=Object.keys(d).find(f=>f.toLowerCase()===m);return S?d[S]:d[g]}i.getCaseInsensitive=y;function u(d,g){const m=Object.create(null);for(const[S,f]of Object.entries(d))g(S,f)&&(m[S]=f);return m}i.filter=u}),define(J[60],Q([0,1,8]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.log=i.getFirstFrame=i.parse=i.isRemoteConsoleLog=void 0;function P(v){const E=v;return E&&typeof E.type=="string"&&typeof E.severity=="string"}i.isRemoteConsoleLog=P;function b(v){const E=[];let C;try{const c=JSON.parse(v.arguments),y=c[c.length-1];y&&y.__$stack&&(c.pop(),C=y.__$stack),E.push(...c)}catch(c){E.push("Unable to log remote console arguments",v.arguments)}return{args:E,stack:C}}i.parse=b;function D(v){if(typeof v!="string")return D(b(v).stack);const E=v;if(E){const C=R(E),c=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(C||"");if(c&&c.length===4)return{uri:T.URI.file(c[1]),line:Number(c[2]),column:Number(c[3])}}}i.getFirstFrame=D;function R(v){if(!v)return v;const E=v.indexOf(`
`);return E===-1?v:v.substring(0,E)}function w(v,E){const{args:C,stack:c}=b(v),y=typeof C[0]=="string"&&C.length===1;let u=R(c);u&&(u=`(${u.trim()})`);let d=[];if(typeof C[0]=="string"?u&&y?d=[`%c[${E}] %c${C[0]} %c${u}`,l("blue"),l(""),l("grey")]:d=[`%c[${E}] %c${C[0]}`,l("blue"),l(""),...C.slice(1)]:d=[`%c[${E}]%`,l("blue"),...C],u&&!y&&d.push(u),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,d)}i.log=w;function l(v){return`color: ${v}`}}),define(J[61],Q([0,1,17,26,8]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.revive=i.MarshalledId=i.parse=i.stringify=void 0;function D(E){return JSON.stringify(E,l)}i.stringify=D;function R(E){let C=JSON.parse(E);return C=v(C),C}i.parse=R;var w;(function(E){E[E.Uri=1]="Uri",E[E.Regexp=2]="Regexp",E[E.ScmResource=3]="ScmResource",E[E.ScmResourceGroup=4]="ScmResourceGroup",E[E.ScmProvider=5]="ScmProvider",E[E.CommentController=6]="CommentController",E[E.CommentThread=7]="CommentThread",E[E.CommentThreadReply=8]="CommentThreadReply",E[E.CommentNode=9]="CommentNode",E[E.CommentThreadNode=10]="CommentThreadNode",E[E.TimelineActionContext=11]="TimelineActionContext",E[E.NotebookCellActionContext=12]="NotebookCellActionContext",E[E.TestItemContext=13]="TestItemContext"})(w=i.MarshalledId||(i.MarshalledId={}));function l(E,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,P.regExpFlags)(C)}:C}function v(E,C=0){if(!E||C>200)return E;if(typeof E=="object"){switch(E.$mid){case 1:return b.URI.revive(E);case 2:return new RegExp(E.source,E.flags)}if(E instanceof T.VSBuffer||E instanceof Uint8Array)return E;if(Array.isArray(E))for(let c=0;c<E.length;++c)E[c]=v(E[c],C+1);else for(const c in E)Object.hasOwnProperty.call(E,c)&&(E[c]=v(E[c],C+1))}return E}i.revive=v}),define(J[62],Q([0,1,47,9,6,12,18,26,8]),function(x,i,T,P,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.splitName=i.unmnemonicLabel=i.mnemonicButtonLabel=i.mnemonicMenuLabel=i.template=i.shorten=i.untildify=i.tildify=i.normalizeDriveLetter=i.getBaseLabel=i.getPathLabel=void 0;function v(n,r,h){if(typeof n=="string"&&(n=l.URI.file(n)),h){const L=h.getWorkspaceFolder(n);if(L){const I=h.getWorkspace().folders.length>1;let O;if((0,R.isEqual)(L.uri,n)?O="":O=(0,R.relativePath)(L.uri,n),I){const N=L.name?L.name:(0,R.basename)(L.uri);O=O?N+" \u2022 "+O:N}return O}}if(n.scheme!==P.Schemas.file&&n.scheme!==P.Schemas.untitled)return n.with({query:null,fragment:null}).toString(!0);if((0,T.hasDriveLetter)(n.fsPath))return(0,b.normalize)(C(n.fsPath));let p=(0,b.normalize)(n.fsPath);return!D.isWindows&&r?.userHome&&(p=y(p,r.userHome.fsPath)),p}i.getPathLabel=v;function E(n){if(!n)return;typeof n=="string"&&(n=l.URI.file(n));const r=(0,R.basename)(n)||(n.scheme===P.Schemas.file?n.fsPath:n.path);return D.isWindows&&(0,T.isRootOrDriveLetter)(r)?C(r):r}i.getBaseLabel=E;function C(n,r){return(0,T.hasDriveLetter)(n,r)?n.charAt(0).toUpperCase()+n.slice(1):n}i.normalizeDriveLetter=C;let c=Object.create(null);function y(n,r){if(D.isWindows||!n||!r)return n;let h=c.original===r?c.normalized:void 0;return h||(h=`${(0,w.rtrim)(r,b.posix.sep)}${b.posix.sep}`,c={original:r,normalized:h}),(D.isLinux?n.startsWith(h):(0,w.startsWithIgnoreCase)(n,h))&&(n=`~/${n.substr(h.length)}`),n}i.tildify=y;function u(n,r){return n.replace(/^~($|\/|\\)/,`${r}$1`)}i.untildify=u;const d="\u2026",g="\\\\",m="~";function S(n,r=b.sep){const h=new Array(n.length);let p=!1;for(let L=0;L<n.length;L++){let I=n[L];if(I===""){h[L]=`.${r}`;continue}if(!I){h[L]=I;continue}p=!0;let O="";I.indexOf(g)===0?(O=I.substr(0,I.indexOf(g)+g.length),I=I.substr(I.indexOf(g)+g.length)):I.indexOf(r)===0?(O=I.substr(0,I.indexOf(r)+r.length),I=I.substr(I.indexOf(r)+r.length)):I.indexOf(m)===0&&(O=I.substr(0,I.indexOf(m)+m.length),I=I.substr(I.indexOf(m)+m.length));const N=I.split(r);for(let K=1;p&&K<=N.length;K++)for(let te=N.length-K;p&&te>=0;te--){p=!1;let ge=N.slice(te,te+K).join(r);for(let ce=0;!p&&ce<n.length;ce++)if(ce!==L&&n[ce]&&n[ce].indexOf(ge)>-1){const ie=te+K===N.length,pe=te>0&&n[ce].indexOf(r)>-1?r+ge:ge,V=n[ce].endsWith(pe);p=!ie||V}if(!p){let ce="";(N[0].endsWith(":")||O!=="")&&(te===1&&(te=0,K++,ge=N[0]+r+ge),te>0&&(ce=N[0]+r),ce=O+ce),te>0&&(ce=ce+d+r),ce=ce+ge,te+K<N.length&&(ce=ce+r+d),h[L]=ce}}p&&(h[L]=I)}return h}i.shorten=S;var f;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function o(n,r=Object.create(null)){const h=[];let p=!1,L="";for(const I of n)if(I==="$"||p&&I==="{")L&&h.push({value:L,type:f.TEXT}),L="",p=!0;else if(I==="}"&&p){const O=r[L];if(typeof O=="string")O.length&&h.push({value:O,type:f.VARIABLE});else if(O){const N=h[h.length-1];(!N||N.type!==f.SEPARATOR)&&h.push({value:O.label,type:f.SEPARATOR})}L="",p=!1}else L+=I;return L&&!p&&h.push({value:L,type:f.TEXT}),h.filter((I,O)=>{if(I.type===f.SEPARATOR){const N=h[O-1],K=h[O+1];return[N,K].every(te=>te&&(te.type===f.VARIABLE||te.type===f.TEXT)&&te.value.length>0)}return!0}).map(I=>I.value).join("")}i.template=o;function a(n,r){return D.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,D.isMacintosh?"&":"&&"):n.replace(/&&|&/g,h=>h==="&"?"&&":"&")}i.mnemonicMenuLabel=a;function t(n,r){return D.isMacintosh||r?n.replace(/\(&&\w\)|&&/g,""):D.isWindows?n.replace(/&&|&/g,h=>h==="&"?"&&":"&"):n.replace(/&&/g,"_")}i.mnemonicButtonLabel=t;function s(n){return n.replace(/&/g,"&&")}i.unmnemonicLabel=s;function e(n){const r=n.indexOf("/")!==-1?b.posix:b.win32,h=r.basename(n),p=r.dirname(n);return h.length?{name:h,parentPath:p}:{name:p,parentPath:""}}i.splitName=e}),define(J[63],Q([0,1,131]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LineDecoder=void 0;class P{constructor(D="utf8"){this.stringDecoder=new T.StringDecoder(D),this.remaining=null}write(D){const R=[],w=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(w.length<1)return R;let l=0,v,E=l;for(;E<w.length;)if(v=w.charCodeAt(E),v===13||v===10){if(R.push(w.substring(l,E)),E++,E<w.length){const C=v;v=w.charCodeAt(E),(C===13&&v===10||C===10&&v===13)&&E++}l=E}else E++;return this.remaining=l<w.length?w.substr(l):null,R}end(){return this.remaining}}i.LineDecoder=P}),define(J[64],Q([0,1,48,6,26,13]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.realpathSync=i.realpath=i.realcaseSync=void 0;function R(E){const C=(0,P.dirname)(E);if(E===C)return E;const c=((0,P.basename)(E)||E).toLowerCase();try{const u=(0,D.readdirSync)(C).filter(d=>d.toLowerCase()===c);if(u.length===1){const d=R(C);if(d)return(0,P.join)(d,u[0])}else if(u.length>1){const d=u.indexOf(c);if(d>=0){const g=R(C);if(g)return(0,P.join)(g,u[d])}}}catch(y){}return null}i.realcaseSync=R;async function w(E){try{return await D.Promises.realpath(E)}catch(C){const c=v(E);return await D.Promises.access(c,T.constants.R_OK),c}}i.realpath=w;function l(E){try{return T.realpathSync(E)}catch(C){const c=v(E);return T.accessSync(c,T.constants.R_OK),c}}i.realpathSync=l;function v(E){return(0,b.rtrim)((0,P.normalize)(E),P.sep)}}),define(J[65],Q([0,1,33,6,13]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getFirstAvailablePowerShellInstallation=i.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,R=/^Microsoft.PowerShell_.*/,w=/^Microsoft.PowerShellPreview_.*/;var l;(function(o){o[o.x64=0]="x64",o[o.x86=1]="x86",o[o.ARM=2]="ARM"})(l||(l={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class C{constructor(a,t,s){this.exePath=a,this.displayName=t,this.knownToExist=s}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await b.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function c({useAlternateBitness:o=!1}={}){return o?v===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:o=!1,findPreview:a=!1}={}){const t=c({useAlternateBitness:o});if(!t)return null;const s=P.join(t,"PowerShell");if(!await b.SymlinkSupport.existsDirectory(s))return null;let e=-1,n=null;for(const p of await b.Promises.readdir(s)){let L=-1;if(a){const O=p.indexOf("-");if(O<0)continue;const N=p.substring(0,O);if(!D.test(N)||p.substring(O+1)!=="preview")continue;L=parseInt(N,10)}else{if(!D.test(p))continue;L=parseInt(p,10)}if(L<=e)continue;const I=P.join(s,p,"pwsh.exe");!await b.SymlinkSupport.existsFile(I)||(n=I,e=L)}if(!n)return null;const r=t.includes("x86")?" (x86)":"",h=a?" Preview":"";return new C(n,`PowerShell${h}${r}`,!0)}async function u({findPreview:o}={}){if(!process.env.LOCALAPPDATA)return null;const a=P.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await b.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:s}=o?{pwshMsixDirRegex:w,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const e of await b.Promises.readdir(a))if(t.test(e)){const n=P.join(a,e,"pwsh.exe");return new C(n,s)}return null}function d(){const o=P.join(T.homedir(),".dotnet","tools","pwsh.exe");return new C(o,".NET Core PowerShell Global Tool")}function g(){const o=P.join(process.env.windir,v===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new C(o,"Windows PowerShell",!0)}async function*m(){let o=await y();o&&(yield o),o=await y({useAlternateBitness:!0}),o&&(yield o),o=await u(),o&&(yield o),o=d(),o&&(yield o),o=await y({findPreview:!0}),o&&(yield o),o=await u({findPreview:!0}),o&&(yield o),o=await y({useAlternateBitness:!0,findPreview:!0}),o&&(yield o),o=g(),o&&(yield o)}async function*S(){for await(const o of m())await o.exists()&&(yield o)}i.enumeratePowerShellInstallations=S;async function f(){for await(const o of S())return o;return null}i.getFirstAvailablePowerShellInstallation=f});var ve=this&&this.__decorate||function(x,i,T,P){var b=arguments.length,D=b<3?i:P===null?P=Object.getOwnPropertyDescriptor(i,T):P,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,i,T,P);else for(var w=x.length-1;w>=0;w--)(R=x[w])&&(D=(b<3?R(D):b>3?R(i,T,D):R(i,T))||D);return b>3&&D&&Object.defineProperty(i,T,D),D};define(J[39],Q([0,1,19,3,17,24,46,7,10,2,61,26,11]),function(x,i,T,P,b,D,R,w,l,v,E,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IPCLogger=i.logWithColors=i.ProxyChannel=i.StaticRouter=i.getNextTickChannel=i.getDelayedChannel=i.IPCClient=i.IPCServer=i.ChannelClient=i.RequestInitiator=i.ChannelServer=i.ResponseType=i.RequestType=void 0;var y;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(y=i.RequestType||(i.RequestType={}));function u(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var d;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(d=i.ResponseType||(i.ResponseType={}));function g(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(m||(m={}));class S{constructor(k){this.buffer=k,this.pos=0}read(k){const j=this.buffer.slice(this.pos,this.pos+k);return this.pos+=j.byteLength,j}}class f{constructor(){this.buffers=[]}get buffer(){return b.VSBuffer.concat(this.buffers)}write(k){this.buffers.push(k)}}var o;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(o||(o={}));function a(M){const k=b.VSBuffer.alloc(4);return k.writeUInt32BE(M,0),k}function t(M){return M.read(4).readUInt32BE(0)}function s(M){const k=b.VSBuffer.alloc(1);return k.writeUInt8(M,0),k}const e={Undefined:s(o.Undefined),String:s(o.String),Buffer:s(o.Buffer),VSBuffer:s(o.VSBuffer),Array:s(o.Array),Object:s(o.Object)},n=typeof Buffer!="undefined";function r(M,k){if(typeof k=="undefined")M.write(e.Undefined);else if(typeof k=="string"){const j=b.VSBuffer.fromString(k);M.write(e.String),M.write(a(j.byteLength)),M.write(j)}else if(n&&Buffer.isBuffer(k)){const j=b.VSBuffer.wrap(k);M.write(e.Buffer),M.write(a(j.byteLength)),M.write(j)}else if(k instanceof b.VSBuffer)M.write(e.VSBuffer),M.write(a(k.byteLength)),M.write(k);else if(Array.isArray(k)){M.write(e.Array),M.write(a(k.length));for(const j of k)r(M,j)}else{const j=b.VSBuffer.fromString(JSON.stringify(k));M.write(e.Object),M.write(a(j.byteLength)),M.write(j)}}function h(M){switch(M.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return M.read(t(M)).toString();case o.Buffer:return M.read(t(M)).buffer;case o.VSBuffer:return M.read(t(M));case o.Array:{const j=t(M),G=[];for(let ee=0;ee<j;ee++)G.push(h(M));return G}case o.Object:return JSON.parse(M.read(t(M)).toString())}}class p{constructor(k,j,G=null,ee=1e3){this.protocol=k,this.ctx=j,this.logger=G,this.timeoutDelay=ee,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(H=>this.onRawMessage(H)),this.sendResponse({type:200})}registerChannel(k,j){this.channels.set(k,j),setTimeout(()=>this.flushPendingRequests(k),0)}sendResponse(k){switch(k.type){case 200:{const j=this.send([k.type]);this.logger&&this.logger.logOutgoing(j,0,1,g(k.type));return}case 201:case 202:case 204:case 203:{const j=this.send([k.type,k.id],k.data);this.logger&&this.logger.logOutgoing(j,k.id,1,g(k.type),k.data);return}}}send(k,j=void 0){const G=new f;return r(G,k),r(G,j),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onRawMessage(k){const j=new S(k),G=h(j),ee=h(j),H=G[0];switch(H){case 100:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ee),this.onPromise({type:H,id:G[1],channelName:G[2],name:G[3],arg:ee});case 102:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}: ${G[2]}.${G[3]}`,ee),this.onEventListen({type:H,id:G[1],channelName:G[2],name:G[3],arg:ee});case 101:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]});case 103:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],1,`${u(H)}`),this.disposeActiveRequest({type:H,id:G[1]})}}onPromise(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const G=new D.CancellationTokenSource;let ee;try{ee=j.call(this.ctx,k.name,k.arg,G.token)}catch(_){ee=Promise.reject(_)}const H=k.id;ee.then(_=>{this.sendResponse({id:H,data:_,type:201}),this.activeRequests.delete(k.id)},_=>{_ instanceof Error?this.sendResponse({id:H,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:H,data:_,type:203}),this.activeRequests.delete(k.id)});const Z=(0,v.toDisposable)(()=>G.cancel());this.activeRequests.set(k.id,Z)}onEventListen(k){const j=this.channels.get(k.channelName);if(!j){this.collectPendingRequest(k);return}const G=k.id,H=j.listen(this.ctx,k.name,k.arg)(Z=>this.sendResponse({id:G,data:Z,type:204}));this.activeRequests.set(k.id,H)}disposeActiveRequest(k){const j=this.activeRequests.get(k.id);j&&(j.dispose(),this.activeRequests.delete(k.id))}collectPendingRequest(k){let j=this.pendingRequests.get(k.channelName);j||(j=[],this.pendingRequests.set(k.channelName,j));const G=setTimeout(()=>{console.error(`Unknown channel: ${k.channelName}`),k.type===100&&this.sendResponse({id:k.id,data:{name:"Unknown channel",message:`Channel name '${k.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);j.push({request:k,timeoutTimer:G})}flushPendingRequests(k){const j=this.pendingRequests.get(k);if(j){for(const G of j)switch(clearTimeout(G.timeoutTimer),G.request.type){case 100:this.onPromise(G.request);break;case 102:this.onEventListen(G.request);break}this.pendingRequests.delete(k)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}i.ChannelServer=p;var L;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(L=i.RequestInitiator||(i.RequestInitiator={}));class I{constructor(k,j=null){this.protocol=k,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new l.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(G=>this.onBuffer(G)),this.logger=j}getChannel(k){const j=this;return{call(G,ee,H){return j.isDisposed?Promise.reject(w.canceled()):j.requestPromise(k,G,ee,H)},listen(G,ee){return j.isDisposed?Promise.reject(w.canceled()):j.requestEvent(k,G,ee)}}}requestPromise(k,j,G,ee=D.CancellationToken.None){const H=this.lastRequestId++,_={id:H,type:100,channelName:k,name:j,arg:G};if(ee.isCancellationRequested)return Promise.reject(w.canceled());let ae;return new Promise((A,q)=>{if(ee.isCancellationRequested)return q(w.canceled());const W=()=>{const fe=ue=>{switch(ue.type){case 201:this.handlers.delete(H),A(ue.data);break;case 202:this.handlers.delete(H);const re=new Error(ue.data.message);re.stack=ue.data.stack,re.name=ue.data.name,q(re);break;case 203:this.handlers.delete(H),q(ue.data);break}};this.handlers.set(H,fe),this.sendRequest(_)};let Y=null;this.state===m.Idle?W():(Y=(0,P.createCancelablePromise)(fe=>this.whenInitialized()),Y.then(()=>{Y=null,W()}));const X=()=>{Y?(Y.cancel(),Y=null):this.sendRequest({id:H,type:101}),q(w.canceled())},de=ee.onCancellationRequested(X);ae=(0,v.combinedDisposable)((0,v.toDisposable)(X),de),this.activeRequests.add(ae)}).finally(()=>{this.activeRequests.delete(ae)})}requestEvent(k,j,G){const ee=this.lastRequestId++,Z={id:ee,type:102,channelName:k,name:j,arg:G};let _=null;const ae=new l.Emitter({onFirstListenerAdd:()=>{_=(0,P.createCancelablePromise)(A=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(ae),this.sendRequest(Z)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(ae),this.sendRequest({id:ee,type:103}))}}),U=A=>ae.fire(A.data);return this.handlers.set(ee,U),ae.event}sendRequest(k){switch(k.type){case 100:case 102:{const j=this.send([k.type,k.id,k.channelName,k.name],k.arg);this.logger&&this.logger.logOutgoing(j,k.id,0,`${u(k.type)}: ${k.channelName}.${k.name}`,k.arg);return}case 101:case 103:{const j=this.send([k.type,k.id]);this.logger&&this.logger.logOutgoing(j,k.id,0,u(k.type));return}}}send(k,j=void 0){const G=new f;return r(G,k),r(G,j),this.sendBuffer(G.buffer)}sendBuffer(k){try{return this.protocol.send(k),k.byteLength}catch(j){return 0}}onBuffer(k){const j=new S(k),G=h(j),ee=h(j),H=G[0];switch(H){case 200:return this.logger&&this.logger.logIncoming(k.byteLength,0,0,g(H)),this.onResponse({type:G[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(k.byteLength,G[1],0,g(H),ee),this.onResponse({type:G[0],id:G[1],data:ee})}}onResponse(k){if(k.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}const j=this.handlers.get(k.id);j&&j(k)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(k=>k.dispose()),this.activeRequests.clear()}}ve([R.memoize],I.prototype,"onDidInitializePromise",null),i.ChannelClient=I;class O{constructor(k){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new l.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new l.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,k(({protocol:j,onDidClientDisconnect:G})=>{l.Event.once(j.onMessage)(H=>{const Z=new S(H),_=h(Z),ae=new p(j,_),U=new I(j);this.channels.forEach((q,W)=>ae.registerChannel(W,q));const A={channelServer:ae,channelClient:U,ctx:_};this._connections.add(A),this._onDidAddConnection.fire(A),G(()=>{ae.dispose(),U.dispose(),this._connections.delete(A),this._onDidRemoveConnection.fire(A)})})})}get connections(){const k=[];return this._connections.forEach(j=>k.push(j)),k}getChannel(k,j){const G=this;return{call(ee,H,Z){let _;if((0,c.isFunction)(j)){let U=(0,T.getRandomElement)(G.connections.filter(j));_=U?Promise.resolve(U):l.Event.toPromise(l.Event.filter(G.onDidAddConnection,j))}else _=j.routeCall(G,ee,H);const ae=_.then(U=>U.channelClient.getChannel(k));return K(ae).call(ee,H,Z)},listen(ee,H){if((0,c.isFunction)(j))return G.getMulticastEvent(k,j,ee,H);const Z=j.routeEvent(G,ee,H).then(_=>_.channelClient.getChannel(k));return K(Z).listen(ee,H)}}}getMulticastEvent(k,j,G,ee){const H=this;let Z=new v.DisposableStore;const _=new l.Emitter({onFirstListenerAdd:()=>{Z=new v.DisposableStore;const ae=new l.EventMultiplexer,U=new Map,A=W=>{const X=W.channelClient.getChannel(k).listen(G,ee),de=ae.add(X);U.set(W,de)},q=W=>{const Y=U.get(W);!Y||(Y.dispose(),U.delete(W))};H.connections.filter(j).forEach(A),l.Event.filter(H.onDidAddConnection,j)(A,void 0,Z),H.onDidRemoveConnection(q,void 0,Z),ae.event(_.fire,_,Z),Z.add(ae)},onLastListenerRemove:()=>{Z.dispose()}});return _.event}registerChannel(k,j){this.channels.set(k,j),this._connections.forEach(G=>{G.channelServer.registerChannel(k,j)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}i.IPCServer=O;class N{constructor(k,j,G=null){const ee=new f;r(ee,j),k.send(ee.buffer),this.channelClient=new I(k,G),this.channelServer=new p(k,j,G)}getChannel(k){return this.channelClient.getChannel(k)}registerChannel(k,j){this.channelServer.registerChannel(k,j)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}i.IPCClient=N;function K(M){return{call(k,j,G){return M.then(ee=>ee.call(k,j,G))},listen(k,j){const G=new l.Relay;return M.then(ee=>G.input=ee.listen(k,j)),G.event}}}i.getDelayedChannel=K;function te(M){let k=!1;return{call(j,G,ee){return k?M.call(j,G,ee):(0,P.timeout)(0).then(()=>k=!0).then(()=>M.call(j,G,ee))},listen(j,G){if(k)return M.listen(j,G);const ee=new l.Relay;return(0,P.timeout)(0).then(()=>k=!0).then(()=>ee.input=M.listen(j,G)),ee.event}}}i.getNextTickChannel=te;class ge{constructor(k){this.fn=k}routeCall(k){return this.route(k)}routeEvent(k){return this.route(k)}async route(k){for(const j of k.connections)if(await Promise.resolve(this.fn(j.ctx)))return Promise.resolve(j);return await l.Event.toPromise(k.onDidAddConnection),await this.route(k)}}i.StaticRouter=ge;var ce;(function(M){function k(H,Z){const _=H,ae=Z&&Z.disableMarshalling,U=new Map;for(const A in _)G(A)&&U.set(A,l.Event.buffer(_[A],!0));return new class{listen(A,q,W){const Y=U.get(q);if(Y)return Y;if(ee(q)){const X=_[q];if(typeof X=="function")return X.call(_,W)}throw new Error(`Event not found: ${q}`)}call(A,q,W){const Y=_[q];if(typeof Y=="function"){if(!ae&&Array.isArray(W))for(let X=0;X<W.length;X++)W[X]=(0,E.revive)(W[X]);return Y.apply(_,W)}throw new Error(`Method not found: ${q}`)}}}M.fromService=k;function j(H,Z){const _=Z&&Z.disableMarshalling;return new Proxy({},{get(ae,U){if(typeof U=="string")return Z?.properties?.has(U)?Z.properties.get(U):ee(U)?function(A){return H.listen(U,A)}:G(U)?H.listen(U):async function(...A){let q;Z&&!(0,c.isUndefinedOrNull)(Z.context)?q=[Z.context,...A]:q=A;const W=await H.call(U,q);return _?W:(0,E.revive)(W)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=j;function G(H){return H[0]==="o"&&H[1]==="n"&&C.isUpperAsciiLetter(H.charCodeAt(2))}function ee(H){return/^onDynamic/.test(H)&&C.isUpperAsciiLetter(H.charCodeAt(9))}})(ce=i.ProxyChannel||(i.ProxyChannel={}));const ie=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function pe(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let k=M.toString();if(k!=="[object Object]")return k}return M}function V(M){return Array.isArray(M)?M.map(pe):pe(M)}function B(M,k,j,G,ee,H,Z){Z=V(Z);const _=ie[ee],ae=_[G%_.length];let U=[`%c[${M}]%c[${String(k).padStart(7," ")}]%c[len: ${String(j).padStart(5," ")}]%c${String(G).padStart(5," ")} - ${H}`,"color: darkgreen","color: grey","color: grey",`color: ${ae}`];/\($/.test(H)?(U=U.concat(Z),U.push(")")):U.push(Z),console.log.apply(console,U)}i.logWithColors=B;class ne{constructor(k,j){this._outgoingPrefix=k,this._incomingPrefix=j,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(k,j,G,ee,H){this._totalOutgoing+=k,B(this._outgoingPrefix,this._totalOutgoing,k,j,G,ee,H)}logIncoming(k,j,G,ee,H){this._totalIncoming+=k,B(this._incomingPrefix,this._totalIncoming,k,j,G,ee,H)}}i.IPCLogger=ne}),define(J[66],Q([0,1,3,10,2,11]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InMemoryStorageDatabase=i.Storage=i.isStorageItemsChangeEvent=i.StorageHint=void 0;var R;(function(C){C[C.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(R=i.StorageHint||(i.StorageHint={}));function w(C){const c=C;return c?.changed instanceof Map||c?.deleted instanceof Set}i.isStorageItemsChangeEvent=w;var l;(function(C){C[C.None=0]="None",C[C.Initialized=1]="Initialized",C[C.Closed=2]="Closed"})(l||(l={}));class v extends b.Disposable{constructor(c,y=Object.create(null)){super();this.database=c,this.options=y,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=l.None,this.cache=new Map,this.flushDelayer=new T.ThrottledDelayer(v.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(c=>this.onDidChangeItemsExternal(c)))}onDidChangeItemsExternal(c){c.changed?.forEach((y,u)=>this.accept(u,y)),c.deleted?.forEach(y=>this.accept(y,void 0))}accept(c,y){if(this.state===l.Closed)return;let u=!1;(0,D.isUndefinedOrNull)(y)?u=this.cache.delete(c):this.cache.get(c)!==y&&(this.cache.set(c,y),u=!0),u&&this._onDidChangeStorage.fire(c)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===l.None&&(this.state=l.Initialized,this.options.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(c,y){const u=this.cache.get(c);return(0,D.isUndefinedOrNull)(u)?y:u}getBoolean(c,y){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?y:u==="true"}getNumber(c,y){const u=this.get(c);return(0,D.isUndefinedOrNull)(u)?y:parseInt(u,10)}async set(c,y){if(this.state===l.Closed)return;if((0,D.isUndefinedOrNull)(y))return this.delete(c);const u=String(y);if(this.cache.get(c)!==u)return this.cache.set(c,u),this.pendingInserts.set(c,u),this.pendingDeletes.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async delete(c){if(!(this.state===l.Closed||!this.cache.delete(c)))return this.pendingDeletes.has(c)||this.pendingDeletes.add(c),this.pendingInserts.delete(c),this._onDidChangeStorage.fire(c),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=l.Closed;try{await this.doFlush(0)}catch(c){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const c={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(c).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(c){if(!!this.hasPending)return this.doFlush(c)}async doFlush(c){return this.flushDelayer.trigger(()=>this.flushPending(),c)}async whenFlushed(){if(!!this.hasPending)return new Promise(c=>this.whenFlushedCallbacks.push(c))}dispose(){this.flushDelayer.dispose(),super.dispose()}}i.Storage=v,v.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(c){c.insert&&c.insert.forEach((y,u)=>this.items.set(u,y)),c.delete&&c.delete.forEach(y=>this.items.delete(y))}async close(){}}i.InMemoryStorageDatabase=E}),define(J[67],Q([4,5]),function(x,i){return x.create("vs/base/common/date",i)}),define(J[68],Q([0,1,67]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toLocalISOString=i.fromNow=void 0;const P=60,b=P*60,D=b*24,R=D*7,w=D*30,l=D*365;function v(C,c){typeof C!="number"&&(C=C.getTime());const y=Math.round((new Date().getTime()-C)/1e3);if(y<-30)return(0,T.localize)(0,null,v(new Date().getTime()+y*1e3,!1));if(y<30)return(0,T.localize)(1,null);let u;return y<P?(u=y,c?u===1?(0,T.localize)(2,null,u):(0,T.localize)(3,null,u):u===1?(0,T.localize)(4,null,u):(0,T.localize)(5,null,u)):y<b?(u=Math.floor(y/P),c?u===1?(0,T.localize)(6,null,u):(0,T.localize)(7,null,u):u===1?(0,T.localize)(8,null,u):(0,T.localize)(9,null,u)):y<D?(u=Math.floor(y/b),c?u===1?(0,T.localize)(10,null,u):(0,T.localize)(11,null,u):u===1?(0,T.localize)(12,null,u):(0,T.localize)(13,null,u)):y<R?(u=Math.floor(y/D),c?u===1?(0,T.localize)(14,null,u):(0,T.localize)(15,null,u):u===1?(0,T.localize)(16,null,u):(0,T.localize)(17,null,u)):y<w?(u=Math.floor(y/R),c?u===1?(0,T.localize)(18,null,u):(0,T.localize)(19,null,u):u===1?(0,T.localize)(20,null,u):(0,T.localize)(21,null,u)):y<l?(u=Math.floor(y/w),c?u===1?(0,T.localize)(22,null,u):(0,T.localize)(23,null,u):u===1?(0,T.localize)(24,null,u):(0,T.localize)(25,null,u)):(u=Math.floor(y/l),c?u===1?(0,T.localize)(26,null,u):(0,T.localize)(27,null,u):u===1?(0,T.localize)(28,null,u):(0,T.localize)(29,null,u))}i.fromNow=v;function E(C){return C.getFullYear()+"-"+String(C.getMonth()+1).padStart(2,"0")+"-"+String(C.getDate()).padStart(2,"0")+"T"+String(C.getHours()).padStart(2,"0")+":"+String(C.getMinutes()).padStart(2,"0")+":"+String(C.getSeconds()).padStart(2,"0")+"."+(C.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}i.toLocalISOString=E}),define(J[69],Q([4,5]),function(x,i){return x.create("vs/base/common/errorMessage",i)}),define(J[27],Q([0,1,19,11,69]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.toErrorMessage=void 0;function D(v,E){return E&&(v.stack||v.stacktrace)?b.localize(0,null,w(v),R(v.stack)||R(v.stacktrace)):w(v)}function R(v){return Array.isArray(v)?v.join(`
`):v}function w(v){return typeof v.code=="string"&&typeof v.errno=="number"&&typeof v.syscall=="string"?b.localize(1,null,v.message):v.message||b.localize(2,null)}function l(v=null,E=!1){if(!v)return b.localize(3,null);if(Array.isArray(v)){const C=T.coalesce(v),c=l(C[0],E);return C.length>1?b.localize(4,null,c,C.length):c}if(P.isString(v))return v;if(v.detail){const C=v.detail;if(C.error)return D(C.error,E);if(C.exception)return D(C.exception,E)}return v.stack?D(v,E):v.message?v.message:b.localize(5,null)}i.toErrorMessage=l}),define(J[70],Q([4,5]),function(x,i){return x.create("vs/base/node/processes",i)}),define(J[49],Q([0,1,40,47,9,21,6,12,28,58,11,63,13,70]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.win32=i.createQueuedSender=i.LineProcess=i.AbstractProcess=i.getWindowsShell=i.removeDangerousEnvVariables=i.TerminateResponseCode=i.Source=void 0,Object.defineProperty(i,"Source",{enumerable:!0,get:function(){return v.Source}}),Object.defineProperty(i,"TerminateResponseCode",{enumerable:!0,get:function(){return v.TerminateResponseCode}});function u(t){switch(t){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function d(t,s){if(w.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};s&&(e.cwd=s);const n=T.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise(r=>{n.once("error",h=>{r({success:!1,error:h})}),n.once("exit",(h,p)=>{r(h===0?{success:!0}:{success:!1,code:h!==null?h:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?u(e.status):1})}else if(w.isLinux||w.isMacintosh)try{const e=b.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(n=>{T.execFile(e,[t.pid.toString()],{encoding:"utf8",shell:!0},(r,h,p)=>{n(r?{success:!1,error:r}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}function g(t){!t||(delete t.DEBUG,w.isMacintosh&&delete t.DYLD_LIBRARY_PATH,w.isLinux&&delete t.LD_PRELOAD)}i.removeDangerousEnvVariables=g;function m(t=l.env){return t.comspec||"cmd.exe"}i.getWindowsShell=m;class S{constructor(s,e,n,r){if(e!==void 0&&n!==void 0&&r!==void 0)this.cmd=s,this.args=e,this.shell=n,this.options=r;else{const h=s;this.cmd=h.command,this.shell=h.isShellCommand,this.args=h.args.slice(0),this.options=h.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const h=Object.create(null);Object.keys(l.env).forEach(p=>{h[p]=l.env[p]}),Object.keys(this.options.env).forEach(p=>{h[p]=this.options.env[p]}),this.options.env=h}}getSanitizedCommand(){let s=this.cmd.toLowerCase();const e=s.lastIndexOf(R.sep);return e!==-1&&(s=s.substring(e+1)),S.WellKnowCommands[s]?s:"other"}start(s){return w.isWindows&&(this.options&&this.options.cwd&&P.isUNC(this.options.cwd)||!this.options&&P.isUNC(l.cwd()))?Promise.reject(new Error(y.localize(0,null))):this.useExec().then(e=>{let n,r;const h=new Promise((p,L)=>{n=p,r=L});if(e){let p=this.cmd;this.args&&(p=p+" "+this.args.join(" ")),this.childProcess=T.exec(p,this.options,(L,I,O)=>{this.childProcess=null;const N=L;N&&N.killed?r({killed:this.terminateRequested,stdout:I.toString(),stderr:O.toString()}):this.handleExec(n,s,L,I,O)})}else{let p=null;const L=I=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(I,n,s,r);const O={terminated:this.terminateRequested};E.isNumber(I)&&(O.cmdCode=I),n(O)};if(this.shell&&w.isWindows){const I=D.deepClone(this.options);I.windowsVerbatimArguments=!0,I.detached=!1;let O=!1,N=!1;const K=[];let te=this.ensureQuotes(this.cmd);K.push(te.value),O=te.quoted,this.args&&this.args.forEach(ce=>{te=this.ensureQuotes(ce),K.push(te.value),N=N&&te.quoted});const ge=["/s","/c"];O?N?ge.push('"'+K.join(" ")+'"'):K.length>1?ge.push('"'+K[0]+'" '+K.slice(1).join(" ")):ge.push('"'+K[0]+'"'):ge.push(K.join(" ")),p=T.spawn(m(),ge,I)}else this.cmd&&(p=T.spawn(this.cmd,this.args,this.options));p&&(this.childProcess=p,this.childProcessPromise=Promise.resolve(p),this.pidResolve&&(this.pidResolve(E.isNumber(p.pid)?p.pid:-1),this.pidResolve=void 0),p.on("error",I=>{this.childProcess=null,r({terminated:this.terminateRequested,error:I})}),p.pid&&(this.childProcess.on("close",L),this.handleSpawn(p,n,s,r,!0)))}return h})}handleClose(s,e,n,r){}ensureQuotes(s){return S.regexp.test(s)?{value:'"'+s+'"',quoted:!0}:{value:s,quoted:s.length>0&&s[0]==='"'&&s[s.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(s=>s.pid,s=>-1):new Promise(s=>{this.pidResolve=s})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(s=>(this.terminateRequested=!0,d(s,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),s=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(s=>{if(!this.shell||!w.isWindows)return s(!1);const e=T.spawn(m(),["/s","/c"]);e.on("error",n=>s(!0)),e.on("exit",n=>s(!1))})}}i.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class f extends S{constructor(s,e,n,r){super(s,e,n,r);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(s,e,n,r,h){[r,h].forEach((p,L)=>{const I=new C.LineDecoder;I.write(p).forEach(K=>{e({line:K,source:L===0?0:1})});const N=I.end();N&&e({line:N,source:L===0?0:1})}),s({terminated:this.terminateRequested,error:n})}handleSpawn(s,e,n,r,h){const p=new C.LineDecoder,L=new C.LineDecoder;s.stdout.on("data",I=>{p.write(I).forEach(N=>n({line:N,source:0}))}),s.stderr.on("data",I=>{L.write(I).forEach(N=>n({line:N,source:1}))}),this.stdoutLineDecoder=p,this.stderrLineDecoder=L}handleClose(s,e,n,r){const h=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;h&&n({line:h,source:0});const p=this.stderrLineDecoder?this.stderrLineDecoder.end():null;p&&n({line:p,source:1})}}i.LineProcess=f;function o(t){let s=[],e=!1;const n=function(r){if(e){s.push(r);return}(!t.send(r,p=>{if(p&&console.error(p),e=!1,s.length>0){const L=s.slice(0);s=[],L.forEach(I=>n(I))}})||w.isWindows)&&(e=!0)};return{send:n}}i.createQueuedSender=o;var a;(function(t){async function s(e,n,r){if(R.isAbsolute(e))return e;if(n===void 0&&(n=l.cwd()),R.dirname(e)!=="."||(r===void 0&&E.isString(l.env.PATH)&&(r=l.env.PATH.split(R.delimiter)),r===void 0||r.length===0))return R.join(n,e);async function p(L){if(await c.Promises.exists(L)){let I;try{I=await c.Promises.stat(L)}catch(O){O.message.startsWith("EACCES")&&(I=await c.Promises.lstat(L))}return I?!I.isDirectory():!1}return!1}for(let L of r){let I;if(R.isAbsolute(L)?I=R.join(L,e):I=R.join(n,L,e),await p(I))return I;let O=I+".com";if(await p(O)||(O=I+".exe",await p(O)))return O}return R.join(n,e)}t.findExecutable=s})(a=i.win32||(i.win32={}))}),define(J[71],Q([0,1,33,12,65,49]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSystemShellSync=i.getSystemShell=void 0;async function R(y,u){return y===1?P.isWindows?C():D.getWindowsShell(u):v(y,u)}i.getSystemShell=R;function w(y,u){return y===1?P.isWindows?c(u):D.getWindowsShell(u):v(y,u)}i.getSystemShellSync=w;let l=null;function v(y,u){if(P.isLinux&&y===2||P.isMacintosh&&y===3)return"/bin/bash";if(!l){let d;if(P.isWindows)d="/bin/bash";else{if(d=u.SHELL,!d)try{d=(0,T.userInfo)().shell}catch(g){}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}l=d}return l}let E=null;async function C(){return E||(E=(await(0,b.getFirstAvailablePowerShellInstallation)()).exePath),E}function c(y){if(E)return E;const u=P.isWindows&&parseFloat((0,T.release)())>=10,d=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),g=`${y.windir}\\${d?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return u?g:D.getWindowsShell(y)}}),define(J[50],Q([0,1,40,3,17,24,60,7,10,2,21,49,39]),function(x,i,T,P,b,D,R,w,l,v,E,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Client=i.Server=void 0;class y extends c.ChannelServer{constructor(g){super({send:m=>{try{process.send&&process.send(m.buffer.toString("base64"))}catch(S){}},onMessage:l.Event.fromNodeEventEmitter(process,"message",m=>b.VSBuffer.wrap(Buffer.from(m,"base64")))},g);process.once("disconnect",()=>this.dispose())}}i.Server=y;class u{constructor(g,m){this.modulePath=g,this.options=m,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new l.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const S=m&&m.timeout?m.timeout:6e4;this.disposeDelayer=new P.Delayer(S),this.child=null,this._client=null}getChannel(g){const m=this;return{call(S,f,o){return m.requestPromise(g,S,f,o)},listen(S,f){return m.requestEvent(g,S,f)}}}requestPromise(g,m,S,f=D.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(f.isCancellationRequested)return Promise.reject(w.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(g),a=(0,P.createCancelablePromise)(e=>o.call(m,S,e)),t=f.onCancellationRequested(()=>a.cancel()),s=(0,v.toDisposable)(()=>a.cancel());return this.activeRequests.add(s),a.finally(()=>{t.dispose(),this.activeRequests.delete(s),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),a}requestEvent(g,m,S){if(!this.disposeDelayer)return l.Event.None;this.disposeDelayer.cancel();let f;const o=new l.Emitter({onFirstListenerAdd:()=>{f=this.getCachedChannel(g).listen(m,S)(o.fire,o),this.activeRequests.add(f)},onLastListenerRemove:()=>{this.activeRequests.delete(f),f.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const g=this.options&&this.options.args?this.options.args:[],m=Object.create(null);m.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(m.env={...m.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(m.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(m.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(m.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),m.execArgv===void 0&&(m.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n))),(0,C.removeDangerousEnvVariables)(m.env),this.child=(0,T.fork)(this.modulePath,g,m);const S=new l.Emitter;l.Event.fromNodeEventEmitter(this.child,"message",n=>n)(n=>{if((0,R.isRemoteConsoleLog)(n)){(0,R.log)(n,`IPC Library: ${this.options.serverName}`);return}S.fire(b.VSBuffer.wrap(Buffer.from(n,"base64")))});const o=this.options.useQueue?(0,C.createQueuedSender)(this.child):this.child,a=n=>this.child&&this.child.connected&&o.send(n.buffer.toString("base64")),t=S.event,s={send:a,onMessage:t};this._client=new c.ChannelClient(s);const e=()=>this.disposeClient();process.once("exit",e),this.child.on("error",n=>console.warn('IPC "'+this.options.serverName+'" errored with '+n)),this.child.on("exit",(n,r)=>{process.removeListener("exit",e),this.activeRequests.forEach(h=>(0,v.dispose)(h)),this.activeRequests.clear(),n!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+n+" and signal "+r),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:n,signal:r})})}return this._client}getCachedChannel(g){let m=this.channels.get(g);return m||(m=this.client.getChannel(g),this.channels.set(g,m)),m}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}i.Client=u}),define(J[72],Q([4,5]),function(x,i){return x.create("vs/base/node/zip",i)}),define(J[73],Q([4,5]),function(x,i){return x.create("vs/platform/configuration/common/configurationRegistry",i)}),define(J[74],Q([4,5]),function(x,i){return x.create("vs/platform/environment/node/shellEnv",i)}),define(J[75],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",i)}),define(J[76],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagement",i)}),define(J[77],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",i)}),define(J[78],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementService",i)}),define(J[79],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",i)}),define(J[80],Q([4,5]),function(x,i){return x.create("vs/platform/extensionManagement/node/extensionsScanner",i)}),define(J[81],Q([4,5]),function(x,i){return x.create("vs/platform/extensions/common/extensionValidator",i)}),define(J[82],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/fileService",i)}),define(J[83],Q([4,5]),function(x,i){return x.create("vs/platform/files/common/io",i)}),define(J[84],Q([4,5]),function(x,i){return x.create("vs/platform/files/node/diskFileSystemProvider",i)}),define(J[85],Q([4,5]),function(x,i){return x.create("vs/platform/request/common/request",i)}),define(J[86],Q([4,5]),function(x,i){return x.create("vs/platform/telemetry/common/telemetryService",i)}),define(J[87],Q([0,1,68,46,9,6,28,18,8]),function(x,i,T,P,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.parsePtyHostPort=i.parseSearchPort=i.parseExtensionHostPort=i.AbstractNativeEnvironmentService=void 0;class v{constructor(d,g,m){this._args=d,this.paths=g,this.productService=m}get appRoot(){return(0,D.dirname)(b.FileAccess.asFileUri("",x).fsPath)}get userHome(){return l.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return l.URI.file((0,D.join)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.paths.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,w.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,T.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,D.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return l.URI.file((0,D.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,w.joinPath)(l.URI.file((0,D.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return l.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return l.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,w.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=R.env.VSCODE_PORTABLE;return d?l.URI.file((0,D.join)(d,"argv.json")):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,w.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,D.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,D.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,D.resolve)(d):(0,D.normalize)((0,D.join)(b.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const d=this.args["extensions-download-dir"];return d?(0,D.resolve)(d):(0,D.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,D.resolve)(d);const g=R.env.VSCODE_EXTENSIONS;if(g)return g;const m=R.env.VSCODE_PORTABLE;return m?(0,D.join)(m,"extensions"):(0,w.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(g=>/^[^:/?#]+?:\/\//.test(g)?l.URI.parse(g):l.URI.file((0,D.normalize)(g)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?l.URI.parse(d):l.URI.file((0,D.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,w.joinPath)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return l.URI.file((0,D.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ve([P.memoize],v.prototype,"appRoot",null),ve([P.memoize],v.prototype,"userHome",null),ve([P.memoize],v.prototype,"userDataPath",null),ve([P.memoize],v.prototype,"appSettingsHome",null),ve([P.memoize],v.prototype,"tmpDir",null),ve([P.memoize],v.prototype,"cacheHome",null),ve([P.memoize],v.prototype,"userRoamingDataHome",null),ve([P.memoize],v.prototype,"settingsResource",null),ve([P.memoize],v.prototype,"userDataSyncHome",null),ve([P.memoize],v.prototype,"userDataSyncLogResource",null),ve([P.memoize],v.prototype,"sync",null),ve([P.memoize],v.prototype,"machineSettingsResource",null),ve([P.memoize],v.prototype,"globalStorageHome",null),ve([P.memoize],v.prototype,"workspaceStorageHome",null),ve([P.memoize],v.prototype,"keybindingsResource",null),ve([P.memoize],v.prototype,"keyboardLayoutResource",null),ve([P.memoize],v.prototype,"argvResource",null),ve([P.memoize],v.prototype,"snippetsHome",null),ve([P.memoize],v.prototype,"isExtensionDevelopment",null),ve([P.memoize],v.prototype,"untitledWorkspacesHome",null),ve([P.memoize],v.prototype,"installSourcePath",null),ve([P.memoize],v.prototype,"builtinExtensionsPath",null),ve([P.memoize],v.prototype,"extensionsPath",null),ve([P.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ve([P.memoize],v.prototype,"extensionDevelopmentKind",null),ve([P.memoize],v.prototype,"extensionTestsLocationURI",null),ve([P.memoize],v.prototype,"debugExtensionHost",null),ve([P.memoize],v.prototype,"serviceMachineIdResource",null),ve([P.memoize],v.prototype,"telemetryLogResource",null),ve([P.memoize],v.prototype,"disableWorkspaceTrust",null),i.AbstractNativeEnvironmentService=v;function E(u,d){return y(u["inspect-extensions"],u["inspect-brk-extensions"],5870,d,u.debugId,u.extensionEnvironment)}i.parseExtensionHostPort=E;function C(u,d){return y(u["inspect-search"],u["inspect-brk-search"],5876,d,u.extensionEnvironment)}i.parseSearchPort=C;function c(u,d){return y(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,d,u.extensionEnvironment)}i.parsePtyHostPort=c;function y(u,d,g,m,S,f){const a=Number(d||u)||(m?null:g),t=a?Boolean(!!d):!1;let s;if(f)try{s=JSON.parse(f)}catch{}return{port:a,break:t,debugId:S,env:s}}}),function(){"use strict";function x(i,T,P,b){function D(w){const l=R(w),v=[l];return i.isAbsolute(l)||v.unshift(b),i.resolve(...v)}function R(w){const l=process.env.VSCODE_PORTABLE;if(l)return i.join(l,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return i.join(v,P);const E=w["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const C=process.env.USERPROFILE;if(typeof C!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=i.join(C,"AppData","Roaming")}break;case"darwin":v=i.join(T.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||i.join(T.homedir(),".config");break;default:throw new Error("Platform not supported")}return i.join(v,P)}return{getUserDataPath:D}}if(typeof define=="function")define(J[88],Q([0,132,33,9,18,28]),function(i,T,P,b,D,R){const w=D.dirname(b.FileAccess.asFileUri("",i)),l=i.__$__nodeRequire(D.joinPath(w,"package.json").fsPath);return x(T,P,l.name,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const i=require("../../../../../package.json"),T=require("path"),P=require("os");module.exports=x(T,P,i.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(J[89],Q([0,1,33,87,88]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.NativeEnvironmentService=void 0;class D extends P.AbstractNativeEnvironmentService{constructor(w,l){super(w,{homeDir:(0,T.homedir)(),tmpDir:(0,T.tmpdir)(),userDataDir:(0,b.getUserDataPath)(w)},l)}}i.NativeEnvironmentService=D}),define(J[90],Q([0,1,21]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function b(D,R){const w=l=>{if(typeof l!="string")return;const v=P.exec(l);if(!v)return;const E=R[v[1]]??l;return typeof E=="string"?E:typeof E.message=="string"?E.message:l};return(0,T.cloneAndChange)(D,w)}i.localizeManifest=b}),define(J[51],Q([0,1,81]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isEngineValid=i.isValidExtensionVersion=i.isValidVersion=i.normalizeVersion=i.parseVersion=i.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function D(c){return c=c.trim(),c==="*"||P.test(c)}i.isValidVersionStr=D;function R(c){if(!D(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let y=c.match(P);return y?{hasCaret:y[1]==="^",hasGreaterEquals:y[1]===">=",majorBase:y[2]==="x"?0:parseInt(y[2],10),majorMustEqual:y[2]!=="x",minorBase:y[4]==="x"?0:parseInt(y[4],10),minorMustEqual:y[4]!=="x",patchBase:y[6]==="x"?0:parseInt(y[6],10),patchMustEqual:y[6]!=="x",preRelease:y[8]||null}:null}i.parseVersion=R;function w(c){if(!c)return null;let y=c.majorBase,u=c.majorMustEqual,d=c.minorBase,g=c.minorMustEqual,m=c.patchBase,S=c.patchMustEqual;c.hasCaret&&(y===0||(g=!1),S=!1);let f=0;if(c.preRelease){const o=b.exec(c.preRelease);if(o){const[,a,t,s]=o;f=Date.UTC(Number(a),Number(t)-1,Number(s))}}return{majorBase:y,majorMustEqual:u,minorBase:d,minorMustEqual:g,patchBase:m,patchMustEqual:S,isMinimum:c.hasGreaterEquals,notBefore:f}}i.normalizeVersion=w;function l(c,y,u){let d;typeof c=="string"?d=w(R(c)):d=c;let g;y instanceof Date?g=y.getTime():typeof y=="string"&&(g=new Date(y).getTime());let m;if(typeof u=="string"?m=w(R(u)):m=u,!d||!m)return!1;let S=d.majorBase,f=d.minorBase,o=d.patchBase,a=m.majorBase,t=m.minorBase,s=m.patchBase,e=m.notBefore,n=m.majorMustEqual,r=m.minorMustEqual,h=m.patchMustEqual;return m.isMinimum?S>a?!0:S<a?!1:f>t?!0:f<t||g&&g<e?!1:o>=s:(S===1&&a===0&&(!n||!r||!h)&&(a=1,t=0,s=0,n=!0,r=!1,h=!1),S<a?!1:S>a?!n:f<t?!1:f>t?!r:o<s?!1:o>s?!h:!(g&&g<e))}i.isValidVersion=l;function v(c,y,u,d){return u.isBuiltin||typeof u.main=="undefined"?!0:C(c,y,u.engines.vscode,d)}i.isValidExtensionVersion=v;function E(c,y,u){return c==="*"||C(y,u,c)}i.isEngineValid=E;function C(c,y,u,d=[]){let g=w(R(u));if(!g)return d.push(T.localize(0,null,u)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return d.push(T.localize(1,null,u)),!1}else if(!g.majorMustEqual)return d.push(T.localize(2,null,u)),!1;return l(c,y,g)?!0:(d.push(T.localize(3,null,c,u)),!1)}}),define(J[41],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SyncDescriptor=void 0;class T{constructor(b,D=[],R=!1){this.ctor=b,this.staticArguments=D,this.supportsDelayedInstantiation=R}}i.SyncDescriptor=T}),define(J[91],Q([0,1,41]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getSingletonServiceDescriptors=i.registerSingleton=void 0;const P=[];function b(R,w,l){w instanceof T.SyncDescriptor||(w=new T.SyncDescriptor(w,[],l)),P.push([R,w])}i.registerSingleton=b;function D(){return P}i.getSingletonServiceDescriptors=D}),define(J[92],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Graph=i.Node=void 0;class T{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}i.Node=T;class P{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let R of this._nodes.values())R.outgoing.size===0&&D.push(R);return D}insertEdge(D,R){const w=this.lookupOrInsertNode(D),l=this.lookupOrInsertNode(R);w.outgoing.set(this._hashFn(R),l),l.incoming.set(this._hashFn(D),w)}removeNode(D){const R=this._hashFn(D);this._nodes.delete(R);for(let w of this._nodes.values())w.outgoing.delete(R),w.incoming.delete(R)}lookupOrInsertNode(D){const R=this._hashFn(D);let w=this._nodes.get(R);return w||(w=new T(D),this._nodes.set(R,w)),w}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[R,w]of this._nodes)D.push(`${R}, (incoming)[${[...w.incoming.keys()].join(", ")}], (outgoing)[${[...w.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,R]of this._nodes){const w=new Set([D]),l=this._findCycle(R,w);if(l)return l}}_findCycle(D,R){for(let[w,l]of D.outgoing){if(R.has(w))return[...R,w].join(" -> ");R.add(w);const v=this._findCycle(l,R);if(v)return v;R.delete(w)}}}i.Graph=P}),define(J[25],Q([0,1,11,8,14]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getMigratedSettingValue=i.merge=i.getConfigurationValue=i.removeFromValueTree=i.addToValueTree=i.toValuesTree=i.ConfigurationTargetToString=i.ConfigurationTarget=i.isConfigurationUpdateOverrides=i.isConfigurationOverrides=i.IConfigurationService=void 0,i.IConfigurationService=(0,b.createDecorator)("configurationService");function D(g){return g&&typeof g=="object"&&(!g.overrideIdentifier||typeof g.overrideIdentifier=="string")&&(!g.resource||g.resource instanceof P.URI)}i.isConfigurationOverrides=D;function R(g){return g&&typeof g=="object"&&(!g.overrideIdentifiers||T.isArray(g.overrideIdentifiers))&&!g.overrideIdentifier&&(!g.resource||g.resource instanceof P.URI)}i.isConfigurationUpdateOverrides=R;var w;(function(g){g[g.USER=1]="USER",g[g.USER_LOCAL=2]="USER_LOCAL",g[g.USER_REMOTE=3]="USER_REMOTE",g[g.WORKSPACE=4]="WORKSPACE",g[g.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",g[g.DEFAULT=6]="DEFAULT",g[g.MEMORY=7]="MEMORY"})(w=i.ConfigurationTarget||(i.ConfigurationTarget={}));function l(g){switch(g){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}i.ConfigurationTargetToString=l;function v(g,m){const S=Object.create(null);for(let f in g)E(S,f,g[f],m);return S}i.toValuesTree=v;function E(g,m,S,f){const o=m.split("."),a=o.pop();let t=g;for(let s=0;s<o.length;s++){let e=o[s],n=t[e];switch(typeof n){case"undefined":n=t[e]=Object.create(null);break;case"object":break;default:f(`Ignoring ${m} as ${o.slice(0,s+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[a]=S}catch(s){f(`Ignoring ${m} as ${o.join(".")} is ${JSON.stringify(t)}`)}else f(`Ignoring ${m} as ${o.join(".")} is ${JSON.stringify(t)}`)}i.addToValueTree=E;function C(g,m){const S=m.split(".");c(g,S)}i.removeFromValueTree=C;function c(g,m){const S=m.shift();if(m.length===0){delete g[S];return}if(Object.keys(g).indexOf(S)!==-1){const f=g[S];typeof f=="object"&&!Array.isArray(f)&&(c(f,m),Object.keys(f).length===0&&delete g[S])}}function y(g,m,S){function f(t,s){let e=t;for(const n of s){if(typeof e!="object"||e===null)return;e=e[n]}return e}const o=m.split("."),a=f(g,o);return typeof a=="undefined"?S:a}i.getConfigurationValue=y;function u(g,m,S){Object.keys(m).forEach(f=>{f!=="__proto__"&&(f in g?T.isObject(g[f])&&T.isObject(m[f])?u(g[f],m[f],S):S&&(g[f]=m[f]):g[f]=m[f])})}i.merge=u;function d(g,m,S){const f=g.inspect(m),o=g.inspect(S);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof o.userValue!="undefined"||typeof o.workspaceValue!="undefined"||typeof o.workspaceFolderValue!="undefined"?o.value:f.defaultValue}i.getMigratedSettingValue=d}),define(J[52],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IDownloadService=void 0,i.IDownloadService=(0,T.createDecorator)("downloadService")}),define(J[20],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.INativeEnvironmentService=i.IEnvironmentService=void 0,i.IEnvironmentService=(0,T.createDecorator)("environmentService"),i.INativeEnvironmentService=(0,T.refineServiceDecorator)(i.IEnvironmentService)}),define(J[22],Q([0,1,9,76,14]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IExtensionManagementCLIService=i.PreferencesLocalizedLabel=i.PreferencesLabel=i.ExtensionsChannelId=i.ExtensionsLocalizedLabel=i.ExtensionsLabel=i.DefaultIconPath=i.IExtensionTipsService=i.IGlobalExtensionEnablementService=i.ENABLED_EXTENSIONS_STORAGE_PATH=i.DISABLED_EXTENSIONS_STORAGE_PATH=i.IExtensionManagementService=i.ExtensionManagementError=i.ExtensionManagementErrorCode=i.IExtensionGalleryService=i.InstallOperation=i.StatisticType=i.SortOrder=i.SortBy=i.isIExtensionIdentifier=i.getFallbackTargetPlarforms=i.isTargetPlatformCompatible=i.isNotWebExtensionInWebTargetPlatform=i.getTargetPlatform=i.toTargetPlatform=i.TargetPlatformToString=i.TargetPlatform=i.WEB_EXTENSION_TAG=i.EXTENSION_IDENTIFIER_REGEX=i.EXTENSION_IDENTIFIER_PATTERN=void 0,i.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",i.EXTENSION_IDENTIFIER_REGEX=new RegExp(i.EXTENSION_IDENTIFIER_PATTERN),i.WEB_EXTENSION_TAG="__web_extension";var D;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(D=i.TargetPlatform||(i.TargetPlatform={}));function R(f){switch(f){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}i.TargetPlatformToString=R;function w(f){switch(f){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}i.toTargetPlatform=w;function l(f,o){switch(f){case 3:return o==="x64"?"win32-x64":o==="ia32"?"win32-ia32":o==="arm64"?"win32-arm64":"unknown";case 2:return o==="x64"?"linux-x64":o==="arm64"?"linux-arm64":o==="arm"?"linux-armhf":"unknown";case"alpine":return o==="x64"?"alpine-x64":o==="arm64"?"alpine-arm64":"unknown";case 1:return o==="x64"?"darwin-x64":o==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}i.getTargetPlatform=l;function v(f,o){return o==="web"&&!f.includes("web")}i.isNotWebExtensionInWebTargetPlatform=v;function E(f,o,a){return v(o,a)?!1:f==="undefined"||f==="universal"?!0:f==="unknown"?!1:f===a?!0:C(a).includes(f)}i.isTargetPlatformCompatible=E;function C(f){switch(f){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}i.getFallbackTargetPlarforms=C;function c(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}i.isIExtensionIdentifier=c;var y;(function(f){f[f.NoneOrRelevance=0]="NoneOrRelevance",f[f.LastUpdatedDate=1]="LastUpdatedDate",f[f.Title=2]="Title",f[f.PublisherName=3]="PublisherName",f[f.InstallCount=4]="InstallCount",f[f.PublishedDate=10]="PublishedDate",f[f.AverageRating=6]="AverageRating",f[f.WeightedRating=12]="WeightedRating"})(y=i.SortBy||(i.SortBy={}));var u;(function(f){f[f.Default=0]="Default",f[f.Ascending=1]="Ascending",f[f.Descending=2]="Descending"})(u=i.SortOrder||(i.SortOrder={}));var d;(function(f){f.Install="install",f.Uninstall="uninstall"})(d=i.StatisticType||(i.StatisticType={}));var g;(function(f){f[f.None=0]="None",f[f.Install=1]="Install",f[f.Update=2]="Update"})(g=i.InstallOperation||(i.InstallOperation={})),i.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(f){f.Unsupported="Unsupported",f.Malicious="Malicious",f.Incompatible="Incompatible",f.IncompatiblePreRelease="IncompatiblePreRelease",f.IncompatibleTargetPlatform="IncompatibleTargetPlatform",f.Invalid="Invalid",f.Download="Download",f.Extract="Extract",f.Delete="Delete",f.Rename="Rename",f.CorruptZip="CorruptZip",f.IncompleteZip="IncompleteZip",f.Internal="Internal"})(m=i.ExtensionManagementErrorCode||(i.ExtensionManagementErrorCode={}));class S extends Error{constructor(o,a){super(o);this.code=a,this.name=a}}i.ExtensionManagementError=S,i.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),i.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",i.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",i.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),i.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),i.DefaultIconPath=T.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),i.ExtensionsLabel=(0,P.localize)(0,null),i.ExtensionsLocalizedLabel={value:i.ExtensionsLabel,original:"Extensions"},i.ExtensionsChannelId="extensions",i.PreferencesLabel=(0,P.localize)(1,null),i.PreferencesLocalizedLabel={value:i.PreferencesLabel,original:"Preferences"},i.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService")}),define(J[93],Q([0,1,40,6,74,24,27,7,12,31,71,133,3]),function(x,i,T,P,b,D,R,w,l,v,E,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveShellEnv=void 0;const y=1e4;let u;async function d(m,S,f){return S["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,C.isLaunchedFromCli)(f)&&!S["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,C.isLaunchedFromCli)(f)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),u||(u=c.Promises.withAsyncBody(async(o,a)=>{const t=new D.CancellationTokenSource,s=setTimeout(()=>{t.dispose(!0),a(new Error((0,b.localize)(0,null)))},y);try{o(await g(m,t.token))}catch(e){!(0,w.isPromiseCanceledError)(e)&&!t.token.isCancellationRequested?a(new Error((0,b.localize)(1,null,(0,R.toErrorMessage)(e)))):o({})}finally{clearTimeout(s),t.dispose()}})),u)}i.resolveShellEnv=d;async function g(m,S){const f=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",f);const o=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",o);const a=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(a+"(.*)"+a),s={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",s);const e=await(0,E.getSystemShell)(l.OS,s);return m.trace("getUnixShellEnvironment#shell",e),new Promise((n,r)=>{if(S.isCancellationRequested)return r((0,w.canceled)());const h=(0,P.basename)(e);let p,L;const I=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(h)?(p=`& '${process.execPath}' ${I} -p '''${a}'' + JSON.stringify(process.env) + ''${a}'''`,L=["-Login","-Command"]):(p=`'${process.execPath}' ${I} -p '"${a}" + JSON.stringify(process.env) + "${a}"'`,h==="tcsh"?L=["-ic"]:L=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(L),p);const O=(0,T.spawn)(e,[...L,p],{detached:!0,stdio:["ignore","pipe","pipe"],env:s});S.onCancellationRequested(()=>(O.kill(),r((0,w.canceled)()))),O.on("error",te=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)(te)),r(te)});const N=[];O.stdout.on("data",te=>N.push(te));const K=[];O.stderr.on("data",te=>K.push(te)),O.on("close",(te,ge)=>{const ce=Buffer.concat(N).toString("utf8");m.trace("getUnixShellEnvironment#raw",ce);const ie=Buffer.concat(K).toString("utf8");if(ie.trim()&&m.trace("getUnixShellEnvironment#stderr",ie),te||ge)return r(new Error((0,b.localize)(2,null,te,ge)));const pe=t.exec(ce),V=pe?pe[1]:"{}";try{const B=JSON.parse(V);f?B.ELECTRON_RUN_AS_NODE=f:delete B.ELECTRON_RUN_AS_NODE,o?B.ELECTRON_NO_ATTACH_CONSOLE=o:delete B.ELECTRON_NO_ATTACH_CONSOLE,delete B.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",B),n(B)}catch(B){m.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(B)),r(B)}})})}}),define(J[53],Q([0,1,17,7,83,16]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.readFileIntoStream=void 0;async function R(E,C,c,y,u,d){let g;try{await w(E,C,c,y,u,d)}catch(m){g=m}finally{g&&u.errorTransformer&&(g=u.errorTransformer(g)),typeof g!="undefined"&&c.error(g),c.end()}}i.readFileIntoStream=R;async function w(E,C,c,y,u,d){l(d);const g=await E.open(C,{create:!1});try{l(d);let m=0,S=0,f=u&&typeof u.length=="number"?u.length:void 0,o=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),a=u&&typeof u.position=="number"?u.position:0,t=0;do S=await E.read(g,a,o.buffer,t,o.byteLength-t),a+=S,t+=S,m+=S,typeof f=="number"&&(f-=S),t===o.byteLength&&(await c.write(y(o)),o=T.VSBuffer.alloc(Math.min(u.bufferSize,typeof f=="number"?f:u.bufferSize)),t=0);while(S>0&&(typeof f!="number"||f>0)&&l(d)&&v(m,u));if(t>0){let s=t;typeof f=="number"&&(s=Math.min(t,f)),c.write(y(o.slice(0,s)))}}catch(m){throw(0,D.ensureFileSystemProviderError)(m)}finally{await E.close(g)}}function l(E){if(E.isCancellationRequested)throw(0,P.canceled)();return!0}function v(E,C){if(C?.limits){if(typeof C.limits.memory=="number"&&E>C.limits.memory)throw(0,D.createFileSystemProviderError)((0,b.localize)(0,null),D.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof C.limits.size=="number"&&E>C.limits.size)throw(0,D.createFileSystemProviderError)((0,b.localize)(1,null),D.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(J[34],Q([0,1,2,12,8,16]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.coalesceEvents=i.toFileChanges=i.WatcherService=i.AbstractWatcherService=void 0;class R extends T.Disposable{constructor(c,y,u){super();this.onFileChanges=c,this.onLogMessage=y,this.verboseLogging=u,this.serviceDisposables=this._register(new T.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const c=new T.DisposableStore;this.serviceDisposables.value=c,this.service=this.createService(c),this.service.setVerboseLogging(this.verboseLogging),c.add(this.service.onDidChangeFile(y=>this.onFileChanges(y))),c.add(this.service.onDidLogMessage(y=>this.onLogMessage(y))),c.add(this.service.onDidError(y=>this.onError(y)))}onError(c){this.restartCounter<R.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${c}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${c}`)}restart(c){this.restartCounter++,this.init(),this.watch(c)}async watch(c){this.requests=c,await this.service?.watch(c)}async setVerboseLogging(c){this.verboseLogging=c,await this.service?.setVerboseLogging(c)}error(c){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${c}`})}dispose(){return this.service=void 0,super.dispose()}}i.AbstractWatcherService=R,R.MAX_RESTARTS=5;class w extends T.Disposable{}i.WatcherService=w;function l(C){return C.map(c=>({type:c.type,resource:b.URI.file(c.path)}))}i.toFileChanges=l;function v(C){const c=new E;for(const y of C)c.processEvent(y);return c.coalesce()}i.coalesceEvents=v;class E{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(c){return P.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const y=this.mapPathToChange.get(this.toKey(c));let u=!1;if(y){const d=y.type,g=c.type;y.path!==c.path&&c.type===2?u=!0:d===1&&g===2?(this.mapPathToChange.delete(this.toKey(c)),this.coalesced.delete(y)):d===2&&g===1?y.type=0:d===1&&g===0||(y.type=g)}else u=!0;u&&(this.coalesced.add(c),this.mapPathToChange.set(this.toKey(c),c))}coalesce(){const c=[],y=[];return Array.from(this.coalesced).filter(u=>u.type!==2?(c.push(u),!1):!0).sort((u,d)=>u.path.length-d.path.length).filter(u=>y.some(d=>(0,D.isParent)(u.path,d,!P.isLinux))?!1:(y.push(u.path),!0)).concat(c)}}}),define(J[94],Q([0,1,3,2,6,64,13,134,34]),function(x,i,T,P,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class v extends P.Disposable{constructor(C,c,y,u){super();this.path=C,this.onDidFilesChange=c,this.onLogMessage=y,this.verboseLogging=u,this.fileChangesDelayer=this._register(new T.ThrottledDelayer(w.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(C){this.verboseLogging=C}async startWatching(){try{const{stat:C,symbolicLink:c}=await R.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let y=this.path;if(c)try{y=await(0,D.realpath)(y)}catch(u){if(this.onError(u),c.dangling)return}C.isDirectory()?this._register((0,w.watchFolder)(y,(u,d)=>{this.onFileChange({type:u==="changed"?0:u==="added"?1:2,path:(0,b.join)(this.path,(0,b.basename)(d))})},u=>this.onError(u))):this._register((0,w.watchFile)(y,u=>{this.onFileChange({type:u==="changed"?0:2,path:this.path})},u=>this.onError(u)))}catch(C){C.code!=="ENOENT"&&this.onError(C)}}onFileChange(C){this.fileChangesBuffer.push(C),this.verboseLogging&&this.onVerbose(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),this.fileChangesDelayer.trigger(async()=>{const c=this.fileChangesBuffer;this.fileChangesBuffer=[];const y=(0,l.coalesceEvents)(c);if(this.verboseLogging)for(const u of y)this.onVerbose(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);y.length>0&&this.onDidFilesChange(y)})}onError(C){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${C}`})}onVerbose(C){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=v}),define(J[95],Q([0,1,9,39,50,34]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class R extends D.WatcherService{constructor(l,v,E){super();this.onDidFilesChange=l,this.onLogMessage=v,this.verboseLogging=E,this.isDisposed=!1,this.startWatching()}startWatching(){const l=this._register(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this.service=P.ProxyChannel.toService((0,P.getNextTickChannel)(l.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(v=>!this.isDisposed&&this.onDidFilesChange(v))),this._register(this.service.onDidLogMessage(v=>this.onLogMessage(v)))}async setVerboseLogging(l){this.verboseLogging=l,this.isDisposed||await this.service?.setVerboseLogging(l)}error(l){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${l}`})}async watch(l){this.isDisposed||await this.service?.watch(l)}dispose(){this.isDisposed=!0,super.dispose()}}i.FileWatcher=R}),define(J[96],Q([0,1,9,39,50,34]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileWatcher=void 0;class R extends D.AbstractWatcherService{constructor(l,v,E){super(l,v,E);this.init()}createService(l){const v=l.add(new b.Client(T.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(v.onDidProcessExit(({code:E,signal:C})=>this.onError(`terminated by itself with code ${E}, signal: ${C}`))),P.ProxyChannel.toService((0,P.getNextTickChannel)(v.getChannel("watcher")))}}i.FileWatcher=R}),define(J[54],Q([0,1]),function(x,i){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ServiceCollection=void 0;class T{constructor(...b){this._entries=new Map;for(let[D,R]of b)this.set(D,R)}set(b,D){const R=this._entries.get(b);return this._entries.set(b,D),R}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}i.ServiceCollection=T}),define(J[97],Q([0,1,3,7,41,92,14,54]),function(x,i,T,P,b,D,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.InstantiationService=void 0;const l=!1;class v extends Error{constructor(u){super("cyclic dependency between services");this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class E{constructor(u=new w.ServiceCollection,d=!1,g){this._activeInstantiations=new Set,this._services=u,this._strict=d,this._parent=g,this._services.set(R.IInstantiationService,this)}createChild(u){return new E(u,this._strict,this)}invokeFunction(u,...d){let g=c.traceInvocation(u),m=!1;try{return u({get:f=>{if(m)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(f,g);if(!o)throw new Error(`[invokeFunction] unknown service '${f}'`);return o}},...d)}finally{m=!0,g.stop()}}createInstance(u,...d){let g,m;return u instanceof b.SyncDescriptor?(g=c.traceCreation(u.ctor),m=this._createInstance(u.ctor,u.staticArguments.concat(d),g)):(g=c.traceCreation(u),m=this._createInstance(u,d,g)),g.stop(),m}_createInstance(u,d=[],g){let m=R._util.getServiceDependencies(u).sort((o,a)=>o.index-a.index),S=[];for(const o of m){let a=this._getOrCreateServiceInstance(o.id,g);if(!a&&this._strict&&!o.optional)throw new Error(`[createInstance] ${u.name} depends on UNKNOWN service ${o.id}.`);S.push(a)}let f=m.length>0?m[0].index:d.length;if(d.length!==f){console.warn(`[createInstance] First service dependency of ${u.name} at position ${f+1} conflicts with ${d.length} static arguments`);let o=f-d.length;o>0?d=d.concat(new Array(o)):d=d.slice(0,f)}return new u(...[...d,...S])}_setServiceInstance(u,d){if(this._services.get(u)instanceof b.SyncDescriptor)this._services.set(u,d);else if(this._parent)this._parent._setServiceInstance(u,d);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(u){let d=this._services.get(u);return!d&&this._parent?this._parent._getServiceInstanceOrDescriptor(u):d}_getOrCreateServiceInstance(u,d){let g=this._getServiceInstanceOrDescriptor(u);return g instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(u,g,d.branch(u,!0)):(d.branch(u,!1),g)}_safeCreateAndCacheServiceInstance(u,d,g){if(this._activeInstantiations.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this._activeInstantiations.add(u);try{return this._createAndCacheServiceInstance(u,d,g)}finally{this._activeInstantiations.delete(u)}}_createAndCacheServiceInstance(u,d,g){const m=new D.Graph(o=>o.id.toString());let S=0;const f=[{id:u,desc:d,_trace:g}];for(;f.length;){const o=f.pop();if(m.lookupOrInsertNode(o),S++>1e3)throw new v(m);for(let a of R._util.getServiceDependencies(o.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${u} depends on ${a.id} which is NOT registered.`),t instanceof b.SyncDescriptor){const s={id:a.id,desc:t,_trace:o._trace.branch(a.id,!0)};m.insertEdge(o,s),f.push(s)}}}for(;;){const o=m.roots();if(o.length===0){if(!m.isEmpty())throw new v(m);break}for(const{data:a}of o){if(this._getServiceInstanceOrDescriptor(a.id)instanceof b.SyncDescriptor){const s=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,s)}m.removeNode(a)}}return this._getServiceInstanceOrDescriptor(u)}_createServiceInstanceWithOwner(u,d,g=[],m,S){if(this._services.get(u)instanceof b.SyncDescriptor)return this._createServiceInstance(d,g,m,S);if(this._parent)return this._parent._createServiceInstanceWithOwner(u,d,g,m,S);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}_createServiceInstance(u,d=[],g,m){if(g){const S=new T.IdleValue(()=>this._createInstance(u,d,m));return new Proxy(Object.create(null),{get(f,o){if(o in f)return f[o];let a=S.value,t=a[o];return typeof t!="function"||(t=t.bind(a),f[o]=t),t},set(f,o,a){return S.value[o]=a,!0}})}else return this._createInstance(u,d,m)}}i.InstantiationService=E;var C;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(C||(C={}));class c{constructor(u,d){this.type=u,this.name=d,this._start=Date.now(),this._dep=[]}static traceInvocation(u){return l?new c(1,u.name||u.toString().substring(0,42).replace(/\n/g,"")):c._None}static traceCreation(u){return l?new c(0,u.name):c._None}branch(u,d){let g=new c(2,u.toString());return this._dep.push([u,d,g]),g}stop(){let u=Date.now()-this._start;c._totals+=u;let d=!1;function g(S,f){let o=[],a=new Array(S+1).join("	");for(const[t,s,e]of f._dep)if(s&&e){d=!0,o.push(`${a}CREATES -> ${t}`);let n=g(S+1,e);n&&o.push(n)}else o.push(`${a}uses -> ${t}`);return o.join(`
`)}let m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${c._totals.toFixed(2)}ms)`];(u>2||d)&&console.log(m.join(`
`))}}c._None=new class extends c{constructor(){super(-1,null)}stop(){}branch(){return this}},c._totals=0}),define(J[55],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isValidLocalization=i.ILocalizationsService=void 0,i.ILocalizationsService=(0,T.createDecorator)("localizationsService");function P(b){if(typeof b.languageId!="string"||!Array.isArray(b.translations)||b.translations.length===0)return!1;for(const D of b.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(b.languageName&&typeof b.languageName!="string"||b.localizedLanguageName&&typeof b.localizedLanguageName!="string")}i.isValidLocalization=P}),define(J[15],Q([0,1,27,10,2,12,14]),function(x,i,T,P,b,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LogLevelToString=i.parseLogLevel=i.getLogLevel=i.NullLogService=i.AbstractLoggerService=i.LogService=i.MultiplexLogService=i.AdapterLogger=i.ConsoleLogger=i.ConsoleMainLogger=i.AbstractMessageLogger=i.AbstractLogger=i.format=i.log=i.DEFAULT_LOG_LEVEL=i.LogLevel=i.ILoggerService=i.ILogService=void 0,i.ILogService=(0,R.createDecorator)("logService"),i.ILoggerService=(0,R.createDecorator)("loggerService");function w(){return new Date().toISOString()}var l;(function(s){s[s.Trace=0]="Trace",s[s.Debug=1]="Debug",s[s.Info=2]="Info",s[s.Warning=3]="Warning",s[s.Error=4]="Error",s[s.Critical=5]="Critical",s[s.Off=6]="Off"})(l=i.LogLevel||(i.LogLevel={})),i.DEFAULT_LOG_LEVEL=l.Info;function v(s,e,n){switch(e){case l.Trace:s.trace(n);break;case l.Debug:s.debug(n);break;case l.Info:s.info(n);break;case l.Warning:s.warn(n);break;case l.Error:s.error(n);break;case l.Critical:s.critical(n);break;default:throw new Error("Invalid log level")}}i.log=v;function E(s){let e="";for(let n=0;n<s.length;n++){let r=s[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(h){}e+=(n>0?" ":"")+r}return e}i.format=E;class C extends b.Disposable{constructor(){super(...arguments);this.level=i.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new P.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}i.AbstractLogger=C;class c extends C{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...n){this.checkLogLevel(l.Trace)&&this.log(l.Trace,E([e,...n]))}debug(e,...n){this.checkLogLevel(l.Debug)&&this.log(l.Debug,E([e,...n]))}info(e,...n){this.checkLogLevel(l.Info)&&this.log(l.Info,E([e,...n]))}warn(e,...n){this.checkLogLevel(l.Warning)&&this.log(l.Warning,E([e,...n]))}error(e,...n){if(this.checkLogLevel(l.Error))if(e instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=e.stack,this.log(l.Error,E(r))}else this.log(l.Error,E([e,...n]))}critical(e,...n){this.checkLogLevel(l.Critical)&&this.log(l.Critical,E([e,...n]))}flush(){}}i.AbstractMessageLogger=c;class y extends C{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!D.isWindows}trace(e,...n){this.getLevel()<=l.Trace&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}debug(e,...n){this.getLevel()<=l.Debug&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}info(e,...n){this.getLevel()<=l.Info&&(this.useColors?console.log(`[90m[main ${w()}][0m`,e,...n):console.log(`[main ${w()}]`,e,...n))}warn(e,...n){this.getLevel()<=l.Warning&&(this.useColors?console.warn(`[93m[main ${w()}][0m`,e,...n):console.warn(`[main ${w()}]`,e,...n))}error(e,...n){this.getLevel()<=l.Error&&(this.useColors?console.error(`[91m[main ${w()}][0m`,e,...n):console.error(`[main ${w()}]`,e,...n))}critical(e,...n){this.getLevel()<=l.Critical&&(this.useColors?console.error(`[90m[main ${w()}][0m`,e,...n):console.error(`[main ${w()}]`,e,...n))}dispose(){}flush(){}}i.ConsoleMainLogger=y;class u extends C{constructor(e=i.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...n){this.getLevel()<=l.Trace&&console.log("%cTRACE","color: #888",e,...n)}debug(e,...n){this.getLevel()<=l.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...n)}info(e,...n){this.getLevel()<=l.Info&&console.log("%c INFO","color: #33f",e,...n)}warn(e,...n){this.getLevel()<=l.Warning&&console.log("%c WARN","color: #993",e,...n)}error(e,...n){this.getLevel()<=l.Error&&console.log("%c  ERR","color: #f33",e,...n)}critical(e,...n){this.getLevel()<=l.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...n)}dispose(){}flush(){}}i.ConsoleLogger=u;class d extends C{constructor(e,n=i.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(n)}trace(e,...n){this.getLevel()<=l.Trace&&this.adapter.log(l.Trace,[this.extractMessage(e),...n])}debug(e,...n){this.getLevel()<=l.Debug&&this.adapter.log(l.Debug,[this.extractMessage(e),...n])}info(e,...n){this.getLevel()<=l.Info&&this.adapter.log(l.Info,[this.extractMessage(e),...n])}warn(e,...n){this.getLevel()<=l.Warning&&this.adapter.log(l.Warning,[this.extractMessage(e),...n])}error(e,...n){this.getLevel()<=l.Error&&this.adapter.log(l.Error,[this.extractMessage(e),...n])}critical(e,...n){this.getLevel()<=l.Critical&&this.adapter.log(l.Critical,[this.extractMessage(e),...n])}extractMessage(e){return typeof e=="string"?e:(0,T.toErrorMessage)(e,this.getLevel()<=l.Trace)}dispose(){}flush(){}}i.AdapterLogger=d;class g extends C{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const n of this.logServices)n.setLevel(e);super.setLevel(e)}trace(e,...n){for(const r of this.logServices)r.trace(e,...n)}debug(e,...n){for(const r of this.logServices)r.debug(e,...n)}info(e,...n){for(const r of this.logServices)r.info(e,...n)}warn(e,...n){for(const r of this.logServices)r.warn(e,...n)}error(e,...n){for(const r of this.logServices)r.error(e,...n)}critical(e,...n){for(const r of this.logServices)r.critical(e,...n)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}i.MultiplexLogService=g;class m extends b.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...n){this.logger.trace(e,...n)}debug(e,...n){this.logger.debug(e,...n)}info(e,...n){this.logger.info(e,...n)}warn(e,...n){this.logger.warn(e,...n)}error(e,...n){this.logger.error(e,...n)}critical(e,...n){this.logger.critical(e,...n)}flush(){this.logger.flush()}}i.LogService=m;class S extends b.Disposable{constructor(e,n){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(n(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(h=>h.setLevel(r))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,n){let r=this.loggers.get(e.toString());return r||(r=this.doCreateLogger(e,n?.always?l.Trace:this.logLevel,n),this.loggers.set(e.toString(),r),n?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}i.AbstractLoggerService=S;class f{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(e){}getLevel(){return l.Info}trace(e,...n){}debug(e,...n){}info(e,...n){}warn(e,...n){}error(e,...n){}critical(e,...n){}dispose(){}flush(){}}i.NullLogService=f;function o(s){if(s.verbose)return l.Trace;if(typeof s.logLevel=="string"){const e=a(s.logLevel.toLowerCase());if(e!==void 0)return e}return i.DEFAULT_LOG_LEVEL}i.getLogLevel=o;function a(s){switch(s){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Critical;case"off":return l.Off}}i.parseLogLevel=a;function t(s){switch(s){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Critical:return"critical";case l.Off:return"off"}}i.LogLevelToString=t});var se=this&&this.__param||function(x,i){return function(T,P){i(T,P,x)}};define(J[98],Q([0,1,40,3,27,10,2,9,6,13,20,15]),function(x,i,T,P,b,D,R,w,l,v,E,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsLifecycle=void 0;let c=class extends R.Disposable{constructor(u,d){super();this.environmentService=u,this.logService=d,this.processesLimiter=new P.Limiter(5)}async postUninstall(u){const d=this.parseScript(u,"uninstall");return d&&(this.logService.info(u.identifier.id,u.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(d.script,"uninstall",d.args,!0,u).then(()=>this.logService.info(u.identifier.id,u.manifest.version,"Finished running post uninstall script"),g=>this.logService.error(u.identifier.id,u.manifest.version,`Failed to run post uninstall script: ${g}`)))),v.Promises.rm(this.getExtensionStoragePath(u)).then(void 0,g=>this.logService.error("Error while removing extension storage path",g))}parseScript(u,d){const g=`vscode:${d}`;if(u.location.scheme===w.Schemas.file&&u.manifest&&u.manifest.scripts&&typeof u.manifest.scripts[g]=="string"){const m=u.manifest.scripts[g].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(u.identifier.id,u.manifest.version,`${g} should be a node script`),null):{script:(0,l.join)(u.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(u,d,g,m,S){return new Promise((f,o)=>{const a=this.start(u,d,g,S);let t;const s=e=>{t&&(clearTimeout(t),t=null),e?o(e):f(void 0)};a.on("error",e=>{s((0,b.toErrorMessage)(e)||"Unknown")}),a.on("exit",(e,n)=>{s(e?`post-${d} process exited with code ${e}`:void 0)}),m&&(t=setTimeout(()=>{t=null,a.kill(),o("timed out")},5e3))})}start(u,d,g,m){const S={silent:!0,execArgv:void 0},f=(0,T.fork)(u,[`--type=extension-post-${d}`,...g],S);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const o=D.Event.fromNodeEventEmitter(f.stdout,"data"),a=D.Event.fromNodeEventEmitter(f.stderr,"data");o(e=>this.logService.info(m.identifier.id,m.manifest.version,`post-${d}`,e)),a(e=>this.logService.error(m.identifier.id,m.manifest.version,`post-${d}`,e));const t=D.Event.any(D.Event.map(o,e=>({data:`%c${e}`,format:[""]})),D.Event.map(a,e=>({data:`%c${e}`,format:["color: red"]})));return D.Event.debounce(t,(e,n)=>e?{data:e.data+n.data,format:[...e.format,...n.format]}:{data:n.data,format:n.format},100)(e=>{console.group(m.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),f}getExtensionStoragePath(u){return(0,l.join)(this.environmentService.globalStorageHome.fsPath,u.identifier.id.toLowerCase())}};c=ve([se(0,E.IEnvironmentService),se(1,C.ILogService)],c),i.ExtensionsLifecycle=c}),define(J[99],Q([0,1,19,3,7,10,2,6,34,15]),function(x,i,T,P,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractDiskFileSystemProvider=void 0;class E extends R.Disposable{constructor(c){super();this.logService=c,this._onDidErrorOccur=this._register(new D.Emitter),this.onDidErrorOccur=this._onDidErrorOccur.event,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new P.ThrottledDelayer(0))}watch(c,y){return y.recursive?this.watchRecursive(c,y):this.watchNonRecursive(c)}watchRecursive(c,y){const u={path:this.toFilePath(c),excludes:y.excludes},d=(0,T.insert)(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),(0,R.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(()=>this.doRefreshRecursiveWatchers()).catch(c=>(0,b.onUnexpectedError)(c))}doRefreshRecursiveWatchers(){return this.recursiveWatcher||(this.recursiveWatcher=this._register(this.createRecursiveWatcher(c=>this._onDidChangeFile.fire((0,l.toFileChanges)(c)),c=>this.onWatcherLogMessage(c),this.logService.getLevel()===v.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)}))),this.doWatch(this.recursiveWatcher,this.recursiveFoldersToWatch)}doWatch(c,y){return c.watch(y)}watchNonRecursive(c){const y=this.createNonRecursiveWatcher(this.toFilePath(c),d=>this._onDidChangeFile.fire((0,l.toFileChanges)(d)),d=>this.onWatcherLogMessage(d),this.logService.getLevel()===v.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{y.setVerboseLogging(this.logService.getLevel()===v.LogLevel.Trace)});return(0,R.combinedDisposable)(y,u)}onWatcherLogMessage(c){c.type==="error"&&this._onDidErrorOccur.fire(c.message),this.logService[c.type](c.message)}toFilePath(c){return(0,w.normalize)(c.fsPath)}}i.AbstractDiskFileSystemProvider=E}),define(J[100],Q([0,1,19,3,17,24,10,135,2,101,9,102,18,38,82,16,53,15]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d,g,m){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.FileService=void 0;let S=class Ue extends l.Disposable{constructor(o){super();this.logService=o,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new R.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new R.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new R.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new R.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new R.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new P.ThrottledWorker(Ue.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ue.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ue.FILE_EVENTS_THROTTLING.coolDownDelay,a=>this._onDidFilesChange.fire(new d.FileChangesEvent(a,!0)))),this.watchedResources=v.TernarySearchTree.forUris(a=>{const t=this.getProvider(a.scheme);return t?!this.isPathCaseSensitive(t):!1}),this.writeQueue=this._register(new P.ResourceQueue)}registerProvider(o,a){if(this.provider.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,C.mark)(`code/registerFilesystem/${o}`),this.provider.set(o,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:o,provider:a});const t=new l.DisposableStore;return t.add(a.onDidChangeFile(s=>this.onDidChangeFile(s,this.isPathCaseSensitive(a)))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:o}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(s=>this._onError.fire(new Error(s)))),(0,l.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:o,provider:a}),this.provider.delete(o),(0,l.dispose)(t)})}getProvider(o){return this.provider.get(o)}async activateProvider(o){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:o,join(t){a.push(t)}}),!this.provider.has(o)&&await P.Promises.settled(a)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.provider.has(o.scheme)}hasCapability(o,a){const t=this.provider.get(o.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([o,a])=>({scheme:o,capabilities:a.capabilities}))}async withProvider(o){if(!(0,c.isAbsolutePath)(o))throw new d.FileOperationError((0,u.localize)(0,null,this.resourceForError(o)),8);await this.activateProvider(o.scheme);const a=this.provider.get(o.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=(0,u.localize)(1,null,o.toString()),t}return a}async withReadProvider(o){const a=await this.withProvider(o);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a)||(0,d.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(o){const a=await this.withProvider(o);if((0,d.hasOpenReadWriteCloseCapability)(a)||(0,d.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,a){try{return await this.doResolveFile(o,a)}catch(t){throw(0,d.toFileSystemProviderErrorCode)(t)===d.FileSystemProviderErrorCode.FileNotFound?new d.FileOperationError((0,u.localize)(2,null,this.resourceForError(o)),1):(0,d.ensureFileSystemProviderError)(t)}}async doResolveFile(o,a){const t=await this.withProvider(o),s=this.isPathCaseSensitive(t),e=a?.resolveTo,n=a?.resolveSingleChildDescendants,r=a?.resolveMetadata,h=await t.stat(o);let p;return this.toFileStat(t,o,h,void 0,!!r,(L,I)=>(p||(p=v.TernarySearchTree.forUris(()=>!s),p.set(o,!0),e&&p.fill(!0,e)),p.get(L.resource)||p.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&n?I===1:!1))}async toFileStat(o,a,t,s,e,n){const{providerExtUri:r}=this.getExtUri(o),h={resource:a,name:r.basename(a),isFile:(t.type&d.FileType.File)!=0,isDirectory:(t.type&d.FileType.Directory)!=0,isSymbolicLink:(t.type&d.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean((t.permissions??0)&d.FilePermission.Readonly)||Boolean(o.capabilities&2048),etag:(0,d.etag)({mtime:t.mtime,size:t.size})};if(h.isDirectory&&n(h,s)){try{const p=await o.readdir(a),L=await P.Promises.settled(p.map(async([I,O])=>{try{const N=r.joinPath(a,I),K=e?await o.stat(N):{type:O};return await this.toFileStat(o,N,K,p.length,e,n)}catch(N){return this.logService.trace(N),null}}));h.children=(0,T.coalesce)(L)}catch(p){this.logService.trace(p),h.children=[]}return h}return h}async resolveAll(o){return P.Promises.settled(o.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(o){const a=await this.withProvider(o);try{return!!await a.stat(o)}catch(t){return!1}}async canCreateFile(o,a){try{await this.doValidateCreateFile(o,a)}catch(t){return t}return!0}async doValidateCreateFile(o,a){if(!a?.overwrite&&await this.exists(o))throw new d.FileOperationError((0,u.localize)(3,null,this.resourceForError(o)),3,a)}async createFile(o,a=b.VSBuffer.fromString(""),t){await this.doValidateCreateFile(o,t);const s=await this.writeFile(o,a);return this._onDidRunOperation.fire(new d.FileOperationEvent(o,0,s)),s}async writeFile(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),{providerExtUri:e}=this.getExtUri(s);try{await this.validateWriteFile(s,o,t)||await this.mkdirp(s,e.dirname(o));let r;if((0,d.hasReadWriteCapability)(s)&&!(a instanceof b.VSBuffer))if((0,y.isReadableStream)(a)){const h=await(0,y.peekStream)(a,3);h.ended?r=b.VSBuffer.concat(h.buffer):r=h}else r=(0,y.peekReadable)(a,h=>b.VSBuffer.concat(h),3);else r=a;!(0,d.hasOpenReadWriteCloseCapability)(s)||(0,d.hasReadWriteCapability)(s)&&r instanceof b.VSBuffer?await this.doWriteUnbuffered(s,o,t,r):await this.doWriteBuffered(s,o,t,r instanceof b.VSBuffer?(0,b.bufferToReadable)(r):r)}catch(n){throw new d.FileOperationError((0,u.localize)(4,null,this.resourceForError(o),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),t)}return this.resolve(o,{resolveMetadata:!0})}async validateWriteFile(o,a,t){if(!!t?.unlock&&!(o.capabilities&8192))throw new Error((0,u.localize)(5,null,this.resourceForError(a)));let e;try{e=await o.stat(a)}catch(n){return}if((e.type&d.FileType.Directory)!=0)throw new d.FileOperationError((0,u.localize)(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,e),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==d.ETAG_DISABLED&&typeof e.mtime=="number"&&typeof e.size=="number"&&t.mtime<e.mtime&&t.etag!==(0,d.etag)({mtime:t.mtime,size:e.size}))throw new d.FileOperationError((0,u.localize)(7,null),3,t);return e}async readFile(o,a){const t=await this.withReadProvider(o);return a?.atomic?this.doReadFileAtomic(t,o,a):this.doReadFile(t,o,a)}async doReadFileAtomic(o,a,t){return new Promise((s,e)=>{this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{try{const n=await this.doReadFile(o,a,t);s(n)}catch(n){e(n)}})})}async doReadFile(o,a,t){const s=await this.doReadFileStream(o,a,{...t,preferUnbuffered:!0});return{...s,value:await(0,b.streamToBuffer)(s.value)}}async readFileStream(o,a){const t=await this.withReadProvider(o);return this.doReadFileStream(t,o,a)}async doReadFileStream(o,a,t){const s=new D.CancellationTokenSource,e=this.validateReadFile(a,t).then(r=>r,r=>{throw s.cancel(),r});let n;try{return typeof t?.etag=="string"&&t.etag!==d.ETAG_DISABLED&&await e,!((0,d.hasOpenReadWriteCloseCapability)(o)||(0,d.hasFileReadStreamCapability)(o))||(0,d.hasReadWriteCapability)(o)&&t?.preferUnbuffered?n=this.readFileUnbuffered(o,a,t):(0,d.hasFileReadStreamCapability)(o)?n=this.readFileStreamed(o,a,s.token,t):n=this.readFileBuffered(o,a,s.token,t),{...await e,value:n}}catch(r){n&&await(0,y.consumeStream)(n);const h=(0,u.localize)(8,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(r).toString());throw r instanceof d.NotModifiedSinceFileOperationError?new d.NotModifiedSinceFileOperationError(h,r.stat,t):new d.FileOperationError(h,(0,d.toFileOperationResult)(r),t)}}readFileStreamed(o,a,t,s=Object.create(null)){const e=o.readFileStream(a,s,t);return(0,y.transform)(e,{data:n=>n instanceof b.VSBuffer?n:b.VSBuffer.wrap(n),error:n=>new d.FileOperationError((0,u.localize)(9,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),s)},n=>b.VSBuffer.concat(n))}readFileBuffered(o,a,t,s=Object.create(null)){const e=(0,b.newWriteableBufferStream)();return(0,g.readFileIntoStream)(o,a,e,n=>n,{...s,bufferSize:this.BUFFER_SIZE,errorTransformer:n=>new d.FileOperationError((0,u.localize)(10,null,this.resourceForError(a),(0,d.ensureFileSystemProviderError)(n).toString()),(0,d.toFileOperationResult)(n),s)},t),e}readFileUnbuffered(o,a,t){const s=(0,y.newWriteableStream)(e=>b.VSBuffer.concat(e));return(async()=>{try{let e=await o.readFile(a);typeof t?.position=="number"&&(e=e.slice(t.position)),typeof t?.length=="number"&&(e=e.slice(0,t.length)),this.validateReadFileLimits(a,e.byteLength,t),s.end(b.VSBuffer.wrap(e))}catch(e){s.error(e),s.end()}})(),s}async validateReadFile(o,a){const t=await this.resolve(o,{resolveMetadata:!0});if(t.isDirectory)throw new d.FileOperationError((0,u.localize)(11,null,this.resourceForError(o)),0,a);if(typeof a?.etag=="string"&&a.etag!==d.ETAG_DISABLED&&a.etag===t.etag)throw new d.NotModifiedSinceFileOperationError((0,u.localize)(12,null),t,a);return this.validateReadFileLimits(o,t.size,a),t}validateReadFileLimits(o,a,t){if(t?.limits){let s;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(s=9),typeof t.limits.size=="number"&&a>t.limits.size&&(s=7),typeof s=="number")throw new d.FileOperationError((0,u.localize)(13,null,this.resourceForError(o)),s)}}async canMove(o,a,t){return this.doCanMoveCopy(o,a,"move",t)}async canCopy(o,a,t){return this.doCanMoveCopy(o,a,"copy",t)}async doCanMoveCopy(o,a,t,s){if(o.toString()!==a.toString())try{const e=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o):await this.withReadProvider(o),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(e,o,n,a,t,s)}catch(e){return e}return!0}async move(o,a,t){const s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(s,o,e,a,"move",!!t),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,n==="move"?2:3,r)),r}async copy(o,a,t){const s=await this.withReadProvider(o),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),n=await this.doMoveCopy(s,o,e,a,"copy",!!t),r=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,n==="copy"?3:2,r)),r}async doMoveCopy(o,a,t,s,e,n){if(a.toString()===s.toString())return e;const{exists:r,isSameResourceWithDifferentPathCase:h}=await this.doValidateMoveCopy(o,a,t,s,e,n);if(r&&!h&&n&&await this.del(s,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s)),e==="copy"){if(o===t&&(0,d.hasFileFolderCopyCapability)(o))await o.copy(a,s,{overwrite:n});else{const p=await this.resolve(a);p.isDirectory?await this.doCopyFolder(o,p,t,s):await this.doCopyFile(o,a,t,s)}return e}else return o===t?(await o.rename(a,s,{overwrite:n}),e):(await this.doMoveCopy(o,a,t,s,"copy",n),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(o,a,t,s){if((0,d.hasOpenReadWriteCloseCapability)(o)&&(0,d.hasOpenReadWriteCloseCapability)(t))return this.doPipeBuffered(o,a,t,s);if((0,d.hasOpenReadWriteCloseCapability)(o)&&(0,d.hasReadWriteCapability)(t))return this.doPipeBufferedToUnbuffered(o,a,t,s);if((0,d.hasReadWriteCapability)(o)&&(0,d.hasOpenReadWriteCloseCapability)(t))return this.doPipeUnbufferedToBuffered(o,a,t,s);if((0,d.hasReadWriteCapability)(o)&&(0,d.hasReadWriteCapability)(t))return this.doPipeUnbuffered(o,a,t,s)}async doCopyFolder(o,a,t,s){await t.mkdir(s),Array.isArray(a.children)&&await P.Promises.settled(a.children.map(async e=>{const n=this.getExtUri(t).providerExtUri.joinPath(s,e.name);return e.isDirectory?this.doCopyFolder(o,await this.resolve(e.resource),t,n):this.doCopyFile(o,e.resource,t,n)}))}async doValidateMoveCopy(o,a,t,s,e,n){let r=!1;if(o===t){const{providerExtUri:p,isPathCaseSensitive:L}=this.getExtUri(o);if(L||(r=p.isEqual(a,s)),r&&e==="copy")throw new Error((0,u.localize)(14,null,this.resourceForError(a),this.resourceForError(s)));if(!r&&p.isEqualOrParent(s,a))throw new Error((0,u.localize)(15,null,this.resourceForError(a),this.resourceForError(s)))}const h=await this.exists(s);if(h&&!r){if(!n)throw new d.FileOperationError((0,u.localize)(16,null,this.resourceForError(a),this.resourceForError(s)),4);if(o===t){const{providerExtUri:p}=this.getExtUri(o);if(p.isEqualOrParent(a,s))throw new Error((0,u.localize)(17,null,this.resourceForError(a),this.resourceForError(s)))}}return{exists:h,isSameResourceWithDifferentPathCase:r}}getExtUri(o){const a=this.isPathCaseSensitive(o);return{providerExtUri:a?c.extUri:c.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(o){return!!(o.capabilities&1024)}async createFolder(o){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);await this.mkdirp(a,o);const t=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new d.FileOperationEvent(o,0,t)),t}async mkdirp(o,a){const t=[],{providerExtUri:s}=this.getExtUri(o);for(;!s.isEqual(a,s.dirname(a));)try{if(((await o.stat(a)).type&d.FileType.Directory)==0)throw new Error((0,u.localize)(18,null,this.resourceForError(a)));break}catch(e){if((0,d.toFileSystemProviderErrorCode)(e)!==d.FileSystemProviderErrorCode.FileNotFound)throw e;t.push(s.basename(a)),a=s.dirname(a)}for(let e=t.length-1;e>=0;e--){a=s.joinPath(a,t[e]);try{await o.mkdir(a)}catch(n){if((0,d.toFileSystemProviderErrorCode)(n)!==d.FileSystemProviderErrorCode.FileExists)throw n}}}async canDelete(o,a){try{await this.doValidateDelete(o,a)}catch(t){return t}return!0}async doValidateDelete(o,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(o),o);if(!!a?.useTrash&&!(t.capabilities&4096))throw new Error((0,u.localize)(19,null,this.resourceForError(o)));let e;try{e=await t.stat(o)}catch(r){}if(e)this.throwIfFileIsReadonly(o,e);else throw new d.FileOperationError((0,u.localize)(20,null,this.resourceForError(o)),1);if(!!!a?.recursive){const r=await this.resolve(o);if(r.isDirectory&&Array.isArray(r.children)&&r.children.length>0)throw new Error((0,u.localize)(21,null,this.resourceForError(o)))}return t}async del(o,a){const t=await this.doValidateDelete(o,a),s=!!a?.useTrash,e=!!a?.recursive;await t.delete(o,{recursive:e,useTrash:s}),this._onDidRunOperation.fire(new d.FileOperationEvent(o,1))}onDidChangeFile(o,a){this._onDidChangeFilesRaw.fire({changes:o});let t,s;{for(const e of o)this.watchedResources.has(e.resource)?(t||(t=[]),t.push(e)):(s||(s=[]),s.push(e));t&&this._onDidFilesChange.fire(new d.FileChangesEvent(t,!a))}if(s){const e=a?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!e.work(s)&&Ue.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${s.length}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),e.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${e.pending}, most recent change: ${s[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(o,a={recursive:!1,excludes:[]}){const t=new l.DisposableStore;let s=!1,e=()=>{s=!0};return t.add((0,l.toDisposable)(()=>e())),this.doWatch(o,a).then(n=>{s?(0,l.dispose)(n):e=()=>(0,l.dispose)(n)},n=>this.logService.error(n)),a.recursive||(this.watchedResources.set(o,(this.watchedResources.get(o)??0)+1),t.add((0,l.toDisposable)(()=>{const n=this.watchedResources.get(o);typeof n=="number"&&(n<=1?this.watchedResources.delete(o):this.watchedResources.set(o,n-1))}))),t}async doWatch(o,a){const t=await this.withProvider(o),s=this.toWatchKey(t,o,a);let e=this.activeWatchers.get(s);return e||(e={count:0,disposable:t.watch(o,a)},this.activeWatchers.set(s,e)),e.count+=1,(0,l.toDisposable)(()=>{e&&(e.count--,e.count===0&&((0,l.dispose)(e.disposable),this.activeWatchers.delete(s)))})}toWatchKey(o,a,t){const{providerExtUri:s}=this.getExtUri(o);return[s.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose();for(const[,o]of this.activeWatchers)(0,l.dispose)(o.disposable);this.activeWatchers.clear()}async doWriteBuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(async()=>{const e=await o.open(a,{create:!0,unlock:t?.unlock??!1});try{(0,y.isReadableStream)(s)||(0,y.isReadableBufferedStream)(s)?await this.doWriteStreamBufferedQueued(o,e,s):await this.doWriteReadableBufferedQueued(o,e,s)}catch(n){throw(0,d.ensureFileSystemProviderError)(n)}finally{await o.close(e)}})}async doWriteStreamBufferedQueued(o,a,t){let s=0,e;if((0,y.isReadableBufferedStream)(t)){if(t.buffer.length>0){const n=b.VSBuffer.concat(t.buffer);await this.doWriteBuffer(o,a,n,n.byteLength,s,0),s+=n.byteLength}if(t.ended)return;e=t.stream}else e=t;return new Promise((n,r)=>{(0,y.listenStream)(e,{onData:async h=>{e.pause();try{await this.doWriteBuffer(o,a,h,h.byteLength,s,0)}catch(p){return r(p)}s+=h.byteLength,setTimeout(()=>e.resume())},onError:h=>r(h),onEnd:()=>n()})})}async doWriteReadableBufferedQueued(o,a,t){let s=0,e;for(;(e=t.read())!==null;)await this.doWriteBuffer(o,a,e,e.byteLength,s,0),s+=e.byteLength}async doWriteBuffer(o,a,t,s,e,n){let r=0;for(;r<s;)r+=await o.write(a,e+r,t.buffer,n+r,s-r)}async doWriteUnbuffered(o,a,t,s){return this.writeQueue.queueFor(a,this.getExtUri(o).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(o,a,t,s))}async doWriteUnbufferedQueued(o,a,t,s){let e;s instanceof b.VSBuffer?e=s:(0,y.isReadableStream)(s)?e=await(0,b.streamToBuffer)(s):(0,y.isReadableBufferedStream)(s)?e=await(0,b.bufferedStreamToBuffer)(s):e=(0,b.readableToBuffer)(s),await o.writeFile(a,e.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async doPipeBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(o,a,t,s))}async doPipeBufferedQueued(o,a,t,s){let e,n;try{e=await o.open(a,{create:!1}),n=await t.open(s,{create:!0,unlock:!1});const r=b.VSBuffer.alloc(this.BUFFER_SIZE);let h=0,p=0,L=0;do L=await o.read(e,h,r.buffer,p,r.byteLength-p),await this.doWriteBuffer(t,n,r,L,h,p),h+=L,p+=L,p===r.byteLength&&(p=0);while(L>0)}catch(r){throw(0,d.ensureFileSystemProviderError)(r)}finally{await P.Promises.settled([typeof e=="number"?o.close(e):Promise.resolve(),typeof n=="number"?t.close(n):Promise.resolve()])}}async doPipeUnbuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(o,a,t,s))}async doPipeUnbufferedQueued(o,a,t,s){return t.writeFile(s,await o.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(o,a,t,s){return this.writeQueue.queueFor(s,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(o,a,t,s))}async doPipeUnbufferedToBufferedQueued(o,a,t,s){const e=await t.open(s,{create:!0,unlock:!1});try{const n=await o.readFile(a);await this.doWriteBuffer(t,e,b.VSBuffer.wrap(n),n.byteLength,0,0)}catch(n){throw(0,d.ensureFileSystemProviderError)(n)}finally{await t.close(e)}}async doPipeBufferedToUnbuffered(o,a,t,s){const e=await(0,b.streamToBuffer)(this.readFileBuffered(o,a,D.CancellationToken.None));await this.doWriteUnbuffered(t,s,void 0,e)}throwIfFileSystemIsReadonly(o,a){if(o.capabilities&2048)throw new d.FileOperationError((0,u.localize)(22,null,this.resourceForError(a)),6);return o}throwIfFileIsReadonly(o,a){if((a.permissions??0)&d.FilePermission.Readonly)throw new d.FileOperationError((0,u.localize)(23,null,this.resourceForError(o)),6)}resourceForError(o){return o.scheme===E.Schemas.file?o.fsPath:o.toString(!0)}};S.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},S=ve([se(0,m.ILogService)],S),i.FileService=S}),define(J[103],Q([0,1,48,136,3,17,10,47,6,12,18,38,13,84,16,53,94,95,96,99,27]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d,g,m,S,f,o){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DiskFileSystemProvider=void 0,(()=>{try{(0,P.gracefulify)(T)}catch(t){console.error(`Error enabling graceful-fs: ${(0,o.toErrorMessage)(t)}`)}})();class a extends f.AbstractDiskFileSystemProvider{constructor(s,e){super(s);this.options=e,this.onDidChangeCapabilities=R.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,v.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(s){try{const{stat:e,symbolicLink:n}=await c.SymlinkSupport.stat(this.toFilePath(s));return{type:this.toType(e,n),ctime:e.birthtime.getTime(),mtime:e.mtime.getTime(),size:e.size}}catch(e){throw this.toFileSystemProviderError(e)}}async readdir(s){try{const e=await c.Promises.readdir(this.toFilePath(s),{withFileTypes:!0}),n=[];return await Promise.all(e.map(async r=>{try{let h;r.isSymbolicLink()?h=(await this.stat((0,E.joinPath)(s,r.name))).type:h=this.toType(r),n.push([r.name,h])}catch(h){this.logService.trace(h)}})),n}catch(e){throw this.toFileSystemProviderError(e)}}toType(s,e){let n;return e?.dangling?n=u.FileType.Unknown:s.isFile()?n=u.FileType.File:s.isDirectory()?n=u.FileType.Directory:n=u.FileType.Unknown,e&&(n|=u.FileType.SymbolicLink),n}async readFile(s){try{const e=this.toFilePath(s);return await c.Promises.readFile(e)}catch(e){throw this.toFileSystemProviderError(e)}}readFileStream(s,e,n){const r=(0,C.newWriteableStream)(h=>D.VSBuffer.concat(h.map(p=>D.VSBuffer.wrap(p))).buffer);return(0,d.readFileIntoStream)(this,s,r,h=>h.buffer,{...e,bufferSize:256*1024},n),r}async writeFile(s,e,n){let r;try{const h=this.toFilePath(s);if(!n.create||!n.overwrite){if(await c.Promises.exists(h)){if(!n.overwrite)throw(0,u.createFileSystemProviderError)((0,y.localize)(0,null),u.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,u.createFileSystemProviderError)((0,y.localize)(1,null),u.FileSystemProviderErrorCode.FileNotFound)}r=await this.open(s,{create:!0,unlock:n.unlock}),await this.write(r,0,e,0,e.byteLength)}catch(h){throw await this.toFileSystemProviderWriteError(s,h)}finally{typeof r=="number"&&await this.close(r)}}async open(s,e){try{const n=this.toFilePath(s);if((0,u.isFileOpenForWriteOptions)(e)&&e.unlock)try{const{stat:p}=await c.SymlinkSupport.stat(n);p.mode&128||await c.Promises.chmod(n,p.mode|128)}catch(p){this.logService.trace(p)}let r;if((0,u.isFileOpenForWriteOptions)(e)){if(v.isWindows)try{await c.Promises.truncate(n,0),r="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}r||(r="w")}else r="r";const h=await c.Promises.open(n,r);return this.mapHandleToPos.set(h,0),(0,u.isFileOpenForWriteOptions)(e)&&this.writeHandles.set(h,s),h}catch(n){throw(0,u.isFileOpenForWriteOptions)(e)?await this.toFileSystemProviderWriteError(s,n):this.toFileSystemProviderError(n)}}async close(s){try{if(this.mapHandleToPos.delete(s),this.writeHandles.delete(s)&&this.canFlush)try{await c.Promises.fdatasync(s)}catch(e){this.canFlush=!1,this.logService.error(e)}return await c.Promises.close(s)}catch(e){throw this.toFileSystemProviderError(e)}}async read(s,e,n,r,h){const p=this.normalizePos(s,e);let L=null;try{const I=await c.Promises.read(s,n,r,h,p);return typeof I=="number"?L=I:L=I.bytesRead,L}catch(I){throw this.toFileSystemProviderError(I)}finally{this.updatePos(s,p,L)}}normalizePos(s,e){return e===this.mapHandleToPos.get(s)?null:e}updatePos(s,e,n){const r=this.mapHandleToPos.get(s);typeof r=="number"&&(typeof e=="number"||(typeof n=="number"?this.mapHandleToPos.set(s,r+n):this.mapHandleToPos.delete(s)))}async write(s,e,n,r,h){return(0,b.retry)(()=>this.doWrite(s,e,n,r,h),100,3)}async doWrite(s,e,n,r,h){const p=this.normalizePos(s,e);let L=null;try{const I=await c.Promises.write(s,n,r,h,p);return typeof I=="number"?L=I:L=I.bytesWritten,L}catch(I){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(s),I)}finally{this.updatePos(s,p,L)}}async mkdir(s){try{await c.Promises.mkdir(this.toFilePath(s))}catch(e){throw this.toFileSystemProviderError(e)}}async delete(s,e){try{const n=this.toFilePath(s);await this.doDelete(n,e)}catch(n){throw this.toFileSystemProviderError(n)}}async doDelete(s,e){e.recursive?await c.Promises.rm(s,c.RimRafMode.MOVE):await c.Promises.unlink(s)}async rename(s,e,n){const r=this.toFilePath(s),h=this.toFilePath(e);if(r!==h)try{await this.validateTargetDeleted(s,e,"move",n.overwrite),await c.Promises.move(r,h)}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,y.localize)(2,null,(0,l.basename)(r),(0,l.basename)((0,l.dirname)(h)),p.toString()))),this.toFileSystemProviderError(p)}}async copy(s,e,n){const r=this.toFilePath(s),h=this.toFilePath(e);if(r!==h)try{await this.validateTargetDeleted(s,e,"copy",n.overwrite),await c.Promises.copy(r,h,{preserveSymlinks:!0})}catch(p){throw(p.code==="EINVAL"||p.code==="EBUSY"||p.code==="ENAMETOOLONG")&&(p=new Error((0,y.localize)(3,null,(0,l.basename)(r),(0,l.basename)((0,l.dirname)(h)),p.toString()))),this.toFileSystemProviderError(p)}}async validateTargetDeleted(s,e,n,r){const h=this.toFilePath(s),p=this.toFilePath(e);let L=!1;if(!!(this.capabilities&1024)||(L=(0,w.isEqual)(h,p,!0)),L&&n==="copy")throw(0,u.createFileSystemProviderError)((0,y.localize)(4,null),u.FileSystemProviderErrorCode.FileExists);if(!L&&await c.Promises.exists(p)){if(!r)throw(0,u.createFileSystemProviderError)((0,y.localize)(5,null),u.FileSystemProviderErrorCode.FileExists);await this.delete(e,{recursive:!0,useTrash:!1})}}createRecursiveWatcher(s,e,n){let r,h=!1;return this.options?.watcher?.usePolling?h=!1:h=this.options?.legacyWatcher==="on",h?r=m.FileWatcher:r=S.FileWatcher,new r(p=>s(p),p=>e(p),n,this.options?.watcher)}doWatch(s,e){const n=this.options?.watcher?.usePolling;if(n===!0)for(const r of e)r.pollingInterval=this.options?.watcher?.pollingInterval??5e3;else if(Array.isArray(n))for(const r of e)n.includes(r.path)&&(r.pollingInterval=this.options?.watcher?.pollingInterval??5e3);return super.doWatch(s,e)}createNonRecursiveWatcher(s,e,n,r){return new g.FileWatcher(s,h=>e(h),h=>n(h),r)}toFileSystemProviderError(s){if(s instanceof u.FileSystemProviderError)return s;let e;switch(s.code){case"ENOENT":e=u.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":e=u.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":e=u.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":e=u.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":e=u.FileSystemProviderErrorCode.NoPermissions;break;default:e=u.FileSystemProviderErrorCode.Unknown}return(0,u.createFileSystemProviderError)(s,e)}async toFileSystemProviderWriteError(s,e){let n=this.toFileSystemProviderError(e);if(s&&n.code===u.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await c.SymlinkSupport.stat(this.toFilePath(s));r.mode&128||(n=(0,u.createFileSystemProviderError)(e,u.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.logService.trace(r)}return n}}i.DiskFileSystemProvider=a}),define(J[104],Q([0,1,16,15]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.SpdLogLogger=void 0;async function b(w,l,v,E,C){try{const c=await new Promise((u,d)=>{x(["spdlog"],u,d)});c.setFlushOn(P.LogLevel.Trace);const y=await c.createAsyncRotatingLogger(w,l,v,E);return C&&y.clearFormatters(),y}catch(c){console.error(c)}return null}function D(w,l,v){switch(l){case P.LogLevel.Trace:w.trace(v);break;case P.LogLevel.Debug:w.debug(v);break;case P.LogLevel.Info:w.info(v);break;case P.LogLevel.Warning:w.warn(v);break;case P.LogLevel.Error:w.error(v);break;case P.LogLevel.Critical:w.critical(v);break;default:throw new Error("Invalid log level")}}class R extends P.AbstractMessageLogger{constructor(l,v,E,C,c){super();this.buffer=[],this.setLevel(c),this._loggerCreationPromise=this._createSpdLogLogger(l,v,E,C),this._register(this.onDidChangeLogLevel(y=>{this._logger&&this._logger.setLevel(y)}))}async _createSpdLogLogger(l,v,E,C){const c=E?6:1,y=30/c*T.ByteSize.MB,u=await b(l,v,y,c,C);if(u){this._logger=u,this._logger.setLevel(this.getLevel());for(const{level:d,message:g}of this.buffer)D(this._logger,d,g);this.buffer=[]}}log(l,v){this._logger?D(this._logger,l,v):this.getLevel()<=l&&this.buffer.push({level:l,message:v})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}i.SpdLogLogger=R}),define(J[32],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IProductService=void 0,i.IProductService=(0,T.createDecorator)("productService")}),define(J[29],Q([0,1,56,11]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Registry=void 0;class b{constructor(){this.data=new Map}add(R,w){T.ok(P.isString(R)),T.ok(P.isObject(w)),T.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,w)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}i.Registry=new b}),define(J[105],Q([0,1,10,29]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.Extensions=void 0,i.Extensions={JSONContribution:"base.contributions.json"};function b(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class D{constructor(){this._onDidChangeSchema=new T.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(l,v){this.schemasById[b(l)]=v,this._onDidChangeSchema.fire(l)}notifySchemaChanged(l){this._onDidChangeSchema.fire(l)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new D;P.Registry.add(i.Extensions.JSONContribution,R)}),define(J[35],Q([0,1,19,10,11,73,105,29]),function(x,i,T,P,b,D,R,w){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getScopes=i.validateProperty=i.getDefaultValue=i.keyFromOverrideIdentifiers=i.overrideIdentifiersFromKey=i.OVERRIDE_PROPERTY_REGEX=i.OVERRIDE_PROPERTY_PATTERN=i.resourceLanguageSettingsSchemaId=i.resourceSettings=i.windowSettings=i.machineOverridableSettings=i.machineSettings=i.applicationSettings=i.allSettings=i.ConfigurationScope=i.Extensions=i.EditPresentationTypes=void 0;var l;(function(o){o.Multiline="multilineText",o.Singleline="singlelineText"})(l=i.EditPresentationTypes||(i.EditPresentationTypes={})),i.Extensions={Configuration:"base.contributions.configuration"};var v;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.MACHINE=2]="MACHINE",o[o.WINDOW=3]="WINDOW",o[o.RESOURCE=4]="RESOURCE",o[o.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",o[o.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v=i.ConfigurationScope||(i.ConfigurationScope={})),i.allSettings={properties:{},patternProperties:{}},i.applicationSettings={properties:{},patternProperties:{}},i.machineSettings={properties:{},patternProperties:{}},i.machineOverridableSettings={properties:{},patternProperties:{}},i.windowSettings={properties:{},patternProperties:{}},i.resourceSettings={properties:{},patternProperties:{}},i.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const E=w.Registry.as(R.Extensions.JSONContribution);class C{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:D.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(a,t=!0){this.registerConfigurations([a],t)}registerConfigurations(a,t=!0){const s=this.doRegisterConfigurations(a,t);E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:s})}deregisterConfigurations(a){const t=this.doDeregisterConfigurations(a);E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}updateConfigurations({add:a,remove:t}){const s=[];s.push(...this.doDeregisterConfigurations(t)),s.push(...this.doRegisterConfigurations(a,!1)),E.registerSchema(i.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,T.distinct)(s)})}registerDefaultConfigurations(a){const t=[],s=[];for(const{overrides:e,extensionId:n}of a)for(const r in e)if(t.push(r),i.OVERRIDE_PROPERTY_REGEX.test(r)){const h={...this.configurationDefaultsOverrides.get(r)?.value||{},...e[r]};this.configurationDefaultsOverrides.set(r,{source:n,value:h});const p={type:"object",default:h,description:D.localize(1,null,r),$ref:i.resourceLanguageSettingsSchemaId,defaultDefaultValue:h,source:n};s.push(...u(r)),this.configurationProperties[r]=p,this.defaultLanguageConfigurationOverridesNode.properties[r]=p}else{this.configurationDefaultsOverrides.set(r,{value:e[r],source:n});const h=this.configurationProperties[r];h&&(this.updatePropertyDefaultValue(r,h),this.updateSchema(r,h))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}deregisterDefaultConfigurations(a){const t=[];for(const{overrides:s,extensionId:e}of a)for(const n in s)if(this.configurationDefaultsOverrides.get(n)?.source===e)if(t.push(n),this.configurationDefaultsOverrides.delete(n),i.OVERRIDE_PROPERTY_REGEX.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const r=this.configurationProperties[n];r&&(this.updatePropertyDefaultValue(n,r),this.updateSchema(n,r))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...a){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(a){for(const t of a)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(a,t){const s=[];return a.forEach(e=>{s.push(...this.validateAndRegisterProperties(e,t,e.extensionInfo)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),s}doDeregisterConfigurations(a){const t=[],s=e=>{if(e.properties)for(const n in e.properties)t.push(n),delete this.configurationProperties[n],this.removeFromSchema(n,e.properties[n]);e.allOf&&e.allOf.forEach(n=>s(n))};for(const e of a){s(e);const n=this.configurationContributors.indexOf(e);n!==-1&&this.configurationContributors.splice(n,1)}return t}validateAndRegisterProperties(a,t=!0,s,e=3){e=b.isUndefinedOrNull(a.scope)?e:a.scope;let n=[],r=a.properties;if(r)for(let p in r){if(t&&S(p)){delete r[p];continue}const L=r[p];if(L.source=s?.id,L.defaultDefaultValue=r[p].default,this.updatePropertyDefaultValue(p,L),i.OVERRIDE_PROPERTY_REGEX.test(p)?L.scope=void 0:(L.scope=b.isUndefinedOrNull(L.scope)?e:L.scope,L.restricted=b.isUndefinedOrNull(L.restricted)?!!s?.restrictedConfigurations?.includes(p):L.restricted),r[p].hasOwnProperty("included")&&!r[p].included){this.excludedConfigurationProperties[p]=r[p],delete r[p];continue}else this.configurationProperties[p]=r[p];!r[p].deprecationMessage&&r[p].markdownDeprecationMessage&&(r[p].deprecationMessage=r[p].markdownDeprecationMessage),n.push(p)}let h=a.allOf;if(h)for(let p of h)n.push(...this.validateAndRegisterProperties(p,t,s,e));return n}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(a){const t=s=>{let e=s.properties;if(e)for(const r in e)this.updateSchema(r,e[r]);let n=s.allOf;n&&n.forEach(t)};t(a)}updateSchema(a,t){switch(i.allSettings.properties[a]=t,t.scope){case 1:i.applicationSettings.properties[a]=t;break;case 2:i.machineSettings.properties[a]=t;break;case 6:i.machineOverridableSettings.properties[a]=t;break;case 3:i.windowSettings.properties[a]=t;break;case 4:i.resourceSettings.properties[a]=t;break;case 5:i.resourceSettings.properties[a]=t,this.resourceLanguageSettingsSchema.properties[a]=t;break}}removeFromSchema(a,t){switch(delete i.allSettings.properties[a],t.scope){case 1:delete i.applicationSettings.properties[a];break;case 2:delete i.machineSettings.properties[a];break;case 6:delete i.machineOverridableSettings.properties[a];break;case 3:delete i.windowSettings.properties[a];break;case 4:case 5:delete i.resourceSettings.properties[a],delete this.resourceLanguageSettingsSchema.properties[a];break}}updateOverridePropertyPatternKey(){for(const a of this.overrideIdentifiers.values()){const t=`[${a}]`,s={type:"object",description:D.localize(2,null),errorMessage:D.localize(3,null),$ref:i.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(t,s),i.allSettings.properties[t]=s,i.applicationSettings.properties[t]=s,i.machineSettings.properties[t]=s,i.machineOverridableSettings.properties[t]=s,i.windowSettings.properties[t]=s,i.resourceSettings.properties[t]=s}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const a={type:"object",description:D.localize(4,null),errorMessage:D.localize(5,null),$ref:i.resourceLanguageSettingsSchemaId};i.allSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.applicationSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.machineOverridableSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.windowSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,i.resourceSettings.patternProperties[i.OVERRIDE_PROPERTY_PATTERN]=a,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(a,t){const s=this.configurationDefaultsOverrides.get(a);let e=s?.value,n=s?.source;b.isUndefined(e)&&(e=t.defaultDefaultValue,n=void 0),b.isUndefined(e)&&(e=g(t.type)),t.default=e,t.defaultSource=n}}const c="\\[([^\\]]+)\\]",y=new RegExp(c,"g");i.OVERRIDE_PROPERTY_PATTERN=`^(${c})+$`,i.OVERRIDE_PROPERTY_REGEX=new RegExp(i.OVERRIDE_PROPERTY_PATTERN);function u(o){const a=[];if(i.OVERRIDE_PROPERTY_REGEX.test(o)){let t=y.exec(o);for(;t?.length;){const s=t[1].trim();s&&a.push(s),t=y.exec(o)}}return(0,T.distinct)(a)}i.overrideIdentifiersFromKey=u;function d(o){return o.reduce((a,t)=>`${a}[${t}]`,"")}i.keyFromOverrideIdentifiers=d;function g(o){switch(Array.isArray(o)?o[0]:o){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}i.getDefaultValue=g;const m=new C;w.Registry.add(i.Extensions.Configuration,m);function S(o){return o.trim()?i.OVERRIDE_PROPERTY_REGEX.test(o)?D.localize(7,null,o):m.getConfigurationProperties()[o]!==void 0?D.localize(8,null,o):null:D.localize(6,null)}i.validateProperty=S;function f(){const o=[],a=m.getConfigurationProperties();for(const t of Object.keys(a))o.push([t,a[t].scope]);return o.push(["launch",4]),o.push(["task",4]),o}i.getScopes=f}),define(J[106],Q([0,1,19,10,57,2,101,21,11,8,25,35,29]),function(x,i,T,P,b,D,R,w,l,v,E,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AllKeysConfigurationChangeEvent=i.ConfigurationChangeEvent=i.mergeChanges=i.Configuration=i.UserSettings=i.ConfigurationModelParser=i.DefaultConfigurationModel=i.ConfigurationModel=void 0;class y{constructor(e={},n=[],r=[]){this._contents=e,this._keys=n,this._overrides=r,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,E.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,n){const r=this.getContentsForOverrideIdentifer(n);return r?e?(0,E.getConfigurationValue)(r,e):r:void 0}getKeysForOverrideIdentifier(e){const n=[];for(const r of this.overrides)r.identifiers.includes(e)&&n.push(...r.keys);return T.distinct(n)}getAllOverrideIdentifiers(){const e=[];for(const n of this.overrides)e.push(...n.identifiers);return T.distinct(e)}override(e){let n=this.overrideConfigurations.get(e);return n||(n=this.createOverrideConfigurationModel(e),this.overrideConfigurations.set(e,n)),n}merge(...e){const n=w.deepClone(this.contents),r=w.deepClone(this.overrides),h=[...this.keys];for(const p of e){this.mergeContents(n,p.contents);for(const L of p.overrides){const[I]=r.filter(O=>T.equals(O.identifiers,L.identifiers));I?(this.mergeContents(I.contents,L.contents),I.keys.push(...L.keys),I.keys=T.distinct(I.keys)):r.push(w.deepClone(L))}for(const L of p.keys)h.indexOf(L)===-1&&h.push(L)}return new y(n,h,r)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(e){const n=this.getContentsForOverrideIdentifer(e);if(!n||typeof n!="object"||!Object.keys(n).length)return this;let r={};for(const h of T.distinct([...Object.keys(this.contents),...Object.keys(n)])){let p=this.contents[h],L=n[h];L&&(typeof p=="object"&&typeof L=="object"?(p=w.deepClone(p),this.mergeContents(p,L)):p=L),r[h]=p}return new y(r,this.keys,this.overrides)}mergeContents(e,n){for(const r of Object.keys(n)){if(r in e&&l.isObject(e[r])&&l.isObject(n[r])){this.mergeContents(e[r],n[r]);continue}e[r]=w.deepClone(n[r])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?w.deepFreeze(e):e}getContentsForOverrideIdentifer(e){let n=null,r=null;const h=p=>{p&&(r?this.mergeContents(r,p):r=w.deepClone(p))};for(const p of this.overrides)T.equals(p.identifiers,[e])?n=p.contents:p.identifiers.includes(e)&&h(p.contents);return h(n),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,n){this.addKey(e),(0,E.addToValueTree)(this.contents,e,n,r=>{throw new Error(r)})}removeValue(e){this.removeKey(e)&&(0,E.removeFromValueTree)(this.contents,e)}addKey(e){let n=this.keys.length;for(let r=0;r<n;r++)e.indexOf(this.keys[r])===0&&(n=r);this.keys.splice(n,1,e)}removeKey(e){let n=this.keys.indexOf(e);return n!==-1?(this.keys.splice(n,1),!0):!1}}i.ConfigurationModel=y;class u extends y{constructor(e={}){const n=c.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),r=Object.keys(n),h=Object.create(null),p=[];for(const L in n){const I=e[L],O=I!==void 0?I:n[L].default;(0,E.addToValueTree)(h,L,O,N=>console.error(`Conflict in default settings: ${N}`))}for(const L of Object.keys(h))C.OVERRIDE_PROPERTY_REGEX.test(L)&&p.push({identifiers:(0,C.overrideIdentifiersFromKey)(L),keys:Object.keys(h[L]),contents:(0,E.toValuesTree)(h[L],I=>console.error(`Conflict in default settings file: ${I}`))});super(h,r,p)}}i.DefaultConfigurationModel=u;class d{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,n){if(!l.isUndefinedOrNull(e)){const r=this.doParseContent(e);this.parseRaw(r,n)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,n){this._raw=e;const{contents:r,keys:h,overrides:p,restricted:L}=this.doParseRaw(e,n);this._configurationModel=new y(r,h,p),this._restrictedConfigurations=L||[]}doParseContent(e){let n={},r=null,h=[],p=[],L=[];function I(N){Array.isArray(h)?h.push(N):r!==null&&(h[r]=N)}let O={onObjectBegin:()=>{let N={};I(N),p.push(h),h=N,r=null},onObjectProperty:N=>{r=N},onObjectEnd:()=>{h=p.pop()},onArrayBegin:()=>{let N=[];I(N),p.push(h),h=N,r=null},onArrayEnd:()=>{h=p.pop()},onLiteralValue:I,onError:(N,K,te)=>{L.push({error:N,offset:K,length:te})}};if(e)try{b.visit(e,O),n=h[0]||{}}catch(N){console.error(`Error while parsing settings file ${this._name}: ${N}`),this._parseErrors=[N]}return n}doParseRaw(e,n){const r=c.Registry.as(C.Extensions.Configuration).getConfigurationProperties(),h=this.filter(e,r,!0,n);e=h.raw;const p=(0,E.toValuesTree)(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`)),L=Object.keys(e),I=this.toOverrides(e,O=>console.error(`Conflict in settings file ${this._name}: ${O}`));return{contents:p,keys:L,overrides:I,restricted:h.restricted}}filter(e,n,r,h){if(!h?.scopes&&!h?.skipRestricted)return{raw:e,restricted:[]};const p={},L=[];for(let I in e)if(C.OVERRIDE_PROPERTY_REGEX.test(I)&&r){const O=this.filter(e[I],n,!1,h);p[I]=O.raw,L.push(...O.restricted)}else{const O=n[I],N=O?typeof O.scope!="undefined"?O.scope:3:void 0;O?.restricted&&L.push(I),(N===void 0||h.scopes===void 0||h.scopes.includes(N))&&(h.skipRestricted&&O?.restricted||(p[I]=e[I]))}return{raw:p,restricted:L}}toOverrides(e,n){const r=[];for(const h of Object.keys(e))if(C.OVERRIDE_PROPERTY_REGEX.test(h)){const p={};for(const L in e[h])p[L]=e[h][L];r.push({identifiers:(0,C.overrideIdentifiersFromKey)(h),keys:Object.keys(p),contents:(0,E.toValuesTree)(p,n)})}return r}}i.ConfigurationModelParser=d;class g extends D.Disposable{constructor(e,n,r,h){super();this.userSettingsResource=e,this.scopes=n,this.fileService=h,this._onDidChange=this._register(new P.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new d(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(P.Event.filter(this.fileService.onDidFilesChange,p=>p.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}i.UserSettings=g;class m{constructor(e,n,r=new y,h=new y,p=new R.ResourceMap,L=new y,I=new R.ResourceMap,O=!0){this._defaultConfiguration=e,this._localUserConfiguration=n,this._remoteUserConfiguration=r,this._workspaceConfiguration=h,this._folderConfigurations=p,this._memoryConfiguration=L,this._memoryConfigurationByResource=I,this._freeze=O,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(e,n,r){return this.getConsolidateConfigurationModel(n,r).getValue(e)}updateValue(e,n,r={}){let h;r.resource?(h=this._memoryConfigurationByResource.get(r.resource),h||(h=new y,this._memoryConfigurationByResource.set(r.resource,h))):h=this._memoryConfiguration,n===void 0?h.removeValue(e):h.setValue(e,n),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,n,r){const h=this.getConsolidateConfigurationModel(n,r),p=this.getFolderConfigurationModelForResource(n.resource,r),L=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,I=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),O=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),N=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),K=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),te=r?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,ge=p?n.overrideIdentifier?p.freeze().override(n.overrideIdentifier).getValue(e):p.freeze().getValue(e):void 0,ce=n.overrideIdentifier?L.override(n.overrideIdentifier).getValue(e):L.getValue(e),ie=h.getValue(e),pe=T.distinct(T.flatten(h.overrides.map(V=>V.identifiers))).filter(V=>h.getOverrideValue(e,V)!==void 0);return{defaultValue:I,userValue:O,userLocalValue:N,userRemoteValue:K,workspaceValue:te,workspaceFolderValue:ge,memoryValue:ce,value:ie,default:I!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,user:O!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userLocal:N!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,userRemote:K!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspace:te!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,workspaceFolder:ge!==void 0?{value:p?.freeze().getValue(e),override:n.overrideIdentifier?p?.freeze().getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,memory:ce!==void 0?{value:L.getValue(e),override:n.overrideIdentifier?L.getOverrideValue(e,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:pe.length?pe:void 0}}keys(e){const n=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,n){this._folderConfigurations.set(e,n),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e){const{added:n,updated:r,removed:h,overrides:p}=a(this._defaultConfiguration,e),L=[...n,...r,...h];return L.length&&this.updateDefaultConfiguration(e),{keys:L,overrides:p}}compareAndUpdateLocalUserConfiguration(e){const{added:n,updated:r,removed:h,overrides:p}=a(this.localUserConfiguration,e),L=[...n,...r,...h];return L.length&&this.updateLocalUserConfiguration(e),{keys:L,overrides:p}}compareAndUpdateRemoteUserConfiguration(e){const{added:n,updated:r,removed:h,overrides:p}=a(this.remoteUserConfiguration,e);let L=[...n,...r,...h];return L.length&&this.updateRemoteUserConfiguration(e),{keys:L,overrides:p}}compareAndUpdateWorkspaceConfiguration(e){const{added:n,updated:r,removed:h,overrides:p}=a(this.workspaceConfiguration,e);let L=[...n,...r,...h];return L.length&&this.updateWorkspaceConfiguration(e),{keys:L,overrides:p}}compareAndUpdateFolderConfiguration(e,n){const r=this.folderConfigurations.get(e),{added:h,updated:p,removed:L,overrides:I}=a(r,n);let O=[...h,...p,...L];return(O.length||!r)&&this.updateFolderConfiguration(e,n),{keys:O,overrides:I}}compareAndDeleteFolderConfiguration(e){const n=this.folderConfigurations.get(e);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:r,updated:h,removed:p,overrides:L}=a(n,void 0);return{keys:[...r,...h,...p],overrides:L}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,n){let r=this.getConsolidatedConfigurationModelForResource(e,n);return e.overrideIdentifier?r.override(e.overrideIdentifier):r}getConsolidatedConfigurationModelForResource({resource:e},n){let r=this.getWorkspaceConsolidatedConfiguration();if(n&&e){const h=n.getFolder(e);h&&(r=this.getFolderConsolidatedConfiguration(h.uri)||r);const p=this._memoryConfigurationByResource.get(e);p&&(r=r.merge(p))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let n=this._foldersConsolidatedConfigurations.get(e);if(!n){const r=this.getWorkspaceConsolidatedConfiguration(),h=this._folderConfigurations.get(e);h?(n=r.merge(h),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(e,n)):n=r}return n}getFolderConfigurationModelForResource(e,n){if(n&&e){const r=n.getFolder(e);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,n)=>{const{contents:r,overrides:h,keys:p}=this._folderConfigurations.get(n);return e.push([n,{contents:r,overrides:h,keys:p}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>e.add(n)),this.userConfiguration.freeze().keys.forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(r=>e.add(r))),[...e.values()]}allOverrideIdentifiers(){const e=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>e.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(r=>e.add(r))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(r=>n.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(e).forEach(h=>n.add(h))),[...n.values()]}static parse(e){const n=this.parseConfigurationModel(e.defaults),r=this.parseConfigurationModel(e.user),h=this.parseConfigurationModel(e.workspace),p=e.folders.reduce((L,I)=>(L.set(v.URI.revive(I[0]),this.parseConfigurationModel(I[1])),L),new R.ResourceMap);return new m(n,r,new y,h,p,new y,new R.ResourceMap,!1)}static parseConfigurationModel(e){return new y(e.contents,e.keys,e.overrides).freeze()}}i.Configuration=m;function S(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const e=new Set,n=new Map;for(const h of s)h.keys.forEach(p=>e.add(p)),h.overrides.forEach(([p,L])=>{const I=(0,R.getOrSet)(n,p,new Set);L.forEach(O=>I.add(O))});const r=[];return n.forEach((h,p)=>r.push([p,[...h.values()]])),{keys:[...e.values()],overrides:r}}i.mergeChanges=S;class f{constructor(e,n,r,h){this.change=e,this.previous=n,this.currentConfiguraiton=r,this.currentWorkspace=h,this._previousConfiguration=void 0;const p=new Set;e.keys.forEach(I=>p.add(I)),e.overrides.forEach(([,I])=>I.forEach(O=>p.add(O))),this.affectedKeys=[...p.values()];const L=new y;this.affectedKeys.forEach(I=>L.setValue(I,{})),this.affectedKeysTree=L.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=m.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(n){const r=this.previousConfiguration?this.previousConfiguration.getValue(e,n,this.previous?.workspace):void 0,h=this.currentConfiguraiton.getValue(e,n,this.currentWorkspace);return!w.equals(r,h)}return!0}return!1}doesAffectedKeysTreeContains(e,n){let r=(0,E.toValuesTree)({[n]:!0},()=>{}),h;for(;typeof r=="object"&&(h=Object.keys(r)[0]);){if(e=e[h],!e)return!1;r=r[h]}return!0}}i.ConfigurationChangeEvent=f;class o extends f{constructor(e,n,r,h){super({keys:e.allKeys(),overrides:[]},void 0,e,n);this.source=r,this.sourceConfig=h}}i.AllKeysConfigurationChangeEvent=o;function a(s,e){const{added:n,removed:r,updated:h}=t(e,s),p=[],L=s?.getAllOverrideIdentifiers()||[],I=e?.getAllOverrideIdentifiers()||[];if(e){const O=I.filter(N=>!L.includes(N));for(const N of O)p.push([N,e.getKeysForOverrideIdentifier(N)])}if(s){const O=L.filter(N=>!I.includes(N));for(const N of O)p.push([N,s.getKeysForOverrideIdentifier(N)])}if(e&&s){for(const O of L)if(I.includes(O)){const N=t({contents:s.getOverrideValue(void 0,O)||{},keys:s.getKeysForOverrideIdentifier(O)},{contents:e.getOverrideValue(void 0,O)||{},keys:e.getKeysForOverrideIdentifier(O)});p.push([O,[...N.added,...N.removed,...N.updated]])}}return{added:n,removed:r,updated:h,overrides:p}}function t(s,e){const n=s?e?s.keys.filter(p=>e.keys.indexOf(p)===-1):[...s.keys]:[],r=e?s?e.keys.filter(p=>s.keys.indexOf(p)===-1):[...e.keys]:[],h=[];if(s&&e){for(const p of e.keys)if(s.keys.indexOf(p)!==-1){const L=(0,E.getConfigurationValue)(e.contents,p),I=(0,E.getConfigurationValue)(s.contents,p);w.equals(L,I)||h.push(p)}}return{added:n,removed:r,updated:h}}}),define(J[107],Q([0,1,3,10,2,18,25,106,35,29]),function(x,i,T,P,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ConfigurationService=void 0;class E extends b.Disposable{constructor(c,y){super();this.settingsResource=c,this._onDidChangeConfiguration=this._register(new P.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new w.UserSettings(this.settingsResource,void 0,D.extUriBiasedIgnorePathCase,y)),this.configuration=new w.Configuration(new w.DefaultConfigurationModel,new w.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new T.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(v.Registry.as(l.Extensions.Configuration).onDidUpdateConfiguration(()=>this.onDidDefaultConfigurationChange())),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const c=await this.userConfiguration.loadConfiguration();this.configuration=new w.Configuration(new w.DefaultConfigurationModel,c)}getConfigurationData(){return this.configuration.toData()}getValue(c,y){const u=typeof c=="string"?c:void 0,d=(0,R.isConfigurationOverrides)(c)?c:(0,R.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(u,d,void 0)}updateValue(c,y,u,d){return Promise.reject(new Error("not supported"))}inspect(c){return this.configuration.inspect(c,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const c=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(c)}onDidChangeUserConfiguration(c){const y=this.configuration.toData(),u=this.configuration.compareAndUpdateLocalUserConfiguration(c);this.trigger(u,y,1)}onDidDefaultConfigurationChange(){const c=this.configuration.toData(),y=this.configuration.compareAndUpdateDefaultConfiguration(new w.DefaultConfigurationModel);this.trigger(y,c,6)}trigger(c,y,u){const d=new w.ConfigurationChangeEvent(c,{data:y},this.configuration);d.source=u,d.sourceConfig=this.getTargetConfiguration(u),this._onDidChangeConfiguration.fire(d)}getTargetConfiguration(c){switch(c){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}i.ConfigurationService=E}),define(J[108],Q([0,1,9]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.isVirtualWorkspace=i.getVirtualWorkspaceScheme=i.getVirtualWorkspaceLocation=i.isVirtualResource=i.getRemoteName=i.getRemoteAuthority=void 0;function P(v){return v.scheme===T.Schemas.vscodeRemote?v.authority:void 0}i.getRemoteAuthority=P;function b(v){if(!v)return;const E=v.indexOf("+");return E<0?v:v.substr(0,E)}i.getRemoteName=b;function D(v){return v.scheme!==T.Schemas.file&&v.scheme!==T.Schemas.vscodeRemote}i.isVirtualResource=D;function R(v){if(v.folders.length)return v.folders.every(E=>D(E.uri))?v.folders[0].uri:void 0;if(v.configuration&&D(v.configuration))return v.configuration}i.getVirtualWorkspaceLocation=R;function w(v){return R(v)?.scheme}i.getVirtualWorkspaceScheme=w;function l(v){return R(v)!==void 0}i.isVirtualWorkspace=l}),define(J[42],Q([0,1,26,14,108]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IBuiltinExtensionsScannerService=i.isResolverExtension=i.isAuthenticationProviderExtension=i.isLanguagePackExtension=i.ExtensionIdentifier=i.ExtensionType=i.EXTENSION_CATEGORIES=i.isIExtensionIdentifier=i.getWorkspaceSupportTypeMessage=i.ALL_EXTENSION_KINDS=i.BUILTIN_MANIFEST_CACHE_FILE=i.USER_MANIFEST_CACHE_FILE=i.MANIFEST_CACHE_FOLDER=void 0,i.MANIFEST_CACHE_FOLDER="CachedExtensions",i.USER_MANIFEST_CACHE_FILE="user",i.BUILTIN_MANIFEST_CACHE_FILE="builtin",i.ALL_EXTENSION_KINDS=["ui","workspace","web"];function D(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}i.getWorkspaceSupportTypeMessage=D;function R(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}i.isIExtensionIdentifier=R,i.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var w;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(w=i.ExtensionType||(i.ExtensionType={}));class l{constructor(y){this.value=y,this._lower=y.toLowerCase()}static equals(y,u){if(typeof y=="undefined"||y===null)return typeof u=="undefined"||u===null;if(typeof u=="undefined"||u===null)return!1;if(typeof y=="string"||typeof u=="string"){let d=typeof y=="string"?y:y.value,g=typeof u=="string"?u:u.value;return T.equalsIgnoreCase(d,g)}return y._lower===u._lower}static toKey(y){return typeof y=="string"?y.toLowerCase():y._lower}}i.ExtensionIdentifier=l;function v(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}i.isLanguagePackExtension=v;function E(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}i.isAuthenticationProviderExtension=E;function C(c,y){if(y){const u=`onResolveRemoteAuthority:${(0,b.getRemoteName)(y)}`;return c.activationEvents?.indexOf(u)!==-1}return!1}i.isResolverExtension=C,i.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(J[23],Q([0,1,26,42]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getExtensionDependencies=i.getMaliciousExtensionsSet=i.BetterMergeId=i.getGalleryExtensionTelemetryData=i.getLocalExtensionTelemetryData=i.groupByExtension=i.getGalleryExtensionId=i.adoptToGalleryExtensionId=i.getExtensionId=i.ExtensionIdentifierWithVersion=i.areSameExtensions=void 0;function b(u,d){return u.uuid&&d.uuid?u.uuid===d.uuid:u.id===d.id?!0:(0,T.compareIgnoreCase)(u.id,d.id)===0}i.areSameExtensions=b;class D{constructor(d,g){this.version=g,this.id=d.id,this.uuid=d.uuid}key(){return`${this.id}-${this.version}`}equals(d){return d instanceof D?b(this,d)&&this.version===d.version:!1}}i.ExtensionIdentifierWithVersion=D;function R(u,d){return`${u}.${d}`}i.getExtensionId=R;function w(u){return u.toLocaleLowerCase()}i.adoptToGalleryExtensionId=w;function l(u,d){return w(R(u,d))}i.getGalleryExtensionId=l;function v(u,d){const g=[],m=S=>{for(const f of g)if(f.some(o=>b(d(o),d(S))))return f;return null};for(const S of u){const f=m(S);f?f.push(S):g.push([S])}return g}i.groupByExtension=v;function E(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}i.getLocalExtensionTelemetryData=E;function C(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}i.getGalleryExtensionTelemetryData=C,i.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function c(u){const d=new Set;if(u.malicious)for(const g of u.malicious)d.add(g.id);return d}i.getMaliciousExtensionsSet=c;function y(u,d){const g=[],m=d.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const S=m.shift();if(S&&g.every(f=>!b(f.identifier,{id:S}))){const f=u.filter(o=>b(o.identifier,{id:S}));f.length===1&&(g.push(f[0]),m.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}i.getExtensionDependencies=y}),define(J[109],Q([0,1,24,7,62,9,43,8,77,22,23,42]),function(x,i,T,P,b,D,R,w,l,v,E,C){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementCLIService=i.getIdAndVersion=void 0;const c=S=>(0,l.localize)(0,null,S),y=(0,l.localize)(1,null,"ms-dotnettools.csharp");function u(S,f){return f?`${S.publisher}.${S.name}@${S.version}`:`${S.publisher}.${S.name}`}const d=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function g(S){const f=d.exec(S);return f&&f[1]?[(0,E.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,E.adoptToGalleryExtensionId)(S),void 0]}i.getIdAndVersion=g;let m=class{constructor(f,o){this.extensionManagementService=f,this.extensionGalleryService=o}get location(){}async listExtensions(f,o,a=console){let t=await this.extensionManagementService.getInstalled(1);const s=C.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(o&&o!==""){if(s.indexOf(o.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(n=>n.manifest.categories?n.manifest.categories.map(h=>h.toLowerCase()).indexOf(o.toLowerCase())>-1:!1)}else if(o===""){a.log("Possible Categories: "),s.forEach(n=>{a.log(n)});return}this.location&&a.log((0,l.localize)(2,null,this.location)),t=t.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let e;for(let n of t)e!==n.identifier.id&&(e=n.identifier.id,a.log(u(n.manifest,f)))}async installExtensions(f,o,a,t,s=console){const e=[],n=[];f.length&&s.log(this.location?(0,l.localize)(3,null,this.location):(0,l.localize)(4,null));const r=await this.extensionManagementService.getInstalled(1),h=(I,O)=>{const N=r.find(K=>(0,E.areSameExtensions)(K.identifier,{id:I}));if(N){if(!O&&!t)return s.log((0,l.localize)(5,null,I,N.manifest.version,I)),!1;if(O&&N.manifest.version===O)return s.log((0,l.localize)(6,null,`${I}@${O}`)),!1}return!0},p=[],L=[];for(const I of f)if(I instanceof w.URI)p.push(I);else{const[O,N]=g(I);h(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!1}})}for(const I of o){const[O,N]=g(I);h(O,N)&&L.push({id:O,version:N,installOptions:{...a,isBuiltin:!0}})}if(p.length&&await Promise.all(p.map(async I=>{try{const O=await this.installVSIX(I,{...a,isBuiltin:!1},t,s);O&&n.push(O)}catch(O){s.error(O.message||O.stack||O),e.push(I.toString())}})),L.length){const I=await this.getGalleryExtensions(L);await Promise.all(L.map(async O=>{const N=I.get(O.id.toLowerCase());if(N)try{const K=await this.installFromGallery(O,N,r,t,s);K&&n.push(K)}catch(K){s.error(K.message||K.stack||K),e.push(O.id)}else s.error(`${c(O.version?`${O.id}@${O.version}`:O.id)}
${y}`),e.push(O.id)}))}if(e.length)throw new Error((0,l.localize)(7,null,e.join(", ")))}async installVSIX(f,o,a,t){const s=await this.extensionManagementService.getManifest(f);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,a,t))try{return await this.extensionManagementService.install(f,o),t.log((0,l.localize)(8,null,(0,b.getBaseLabel)(f))),s}catch(n){if((0,P.isPromiseCanceledError)(n))return t.log((0,l.localize)(9,null,(0,b.getBaseLabel)(f))),null;throw n}return null}async getGalleryExtensions(f){const o=new Map,a=await this.extensionGalleryService.getExtensions(f,f.some(t=>t.installOptions.installPreReleaseVersion),T.CancellationToken.None);for(const t of a)o.set(t.identifier.id.toLowerCase(),t);return o}async installFromGallery({id:f,version:o,installOptions:a},t,s,e,n){const r=await this.extensionGalleryService.getManifest(t,T.CancellationToken.None);if(r&&!this.validateExtensionKind(r,n))return null;const h=s.find(p=>(0,E.areSameExtensions)(p.identifier,t.identifier));if(h){if(t.version===h.manifest.version)return n.log((0,l.localize)(10,null,o?`${f}@${o}`:f)),null;n.log((0,l.localize)(11,null,f,t.version))}try{return a.isBuiltin?n.log(o?(0,l.localize)(12,null,f,o):(0,l.localize)(13,null,f)):n.log(o?(0,l.localize)(14,null,f,o):(0,l.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(t,{...a,installGivenVersion:!!o}),n.log((0,l.localize)(16,null,f,t.version)),r}catch(p){if((0,P.isPromiseCanceledError)(p))return n.log((0,l.localize)(17,null,f)),null;throw p}}validateExtensionKind(f,o){return!0}async validateVSIX(f,o,a){const t={id:(0,E.getGalleryExtensionId)(f.publisher,f.name)},e=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,E.areSameExtensions)(t,n.identifier)&&(0,R.gt)(n.manifest.version,f.version));return e&&!o?(a.log((0,l.localize)(18,null,e.identifier.id,e.manifest.version,f.version)),!1):this.validateExtensionKind(f,a)}async uninstallExtensions(f,o,a=console){const t=async e=>{if(e instanceof w.URI){const n=await this.extensionManagementService.getManifest(e);return u(n)}return e},s=[];for(const e of f){const n=await t(e),h=(await this.extensionManagementService.getInstalled()).filter(p=>(0,E.areSameExtensions)(p.identifier,{id:n}));if(!h.length)throw new Error(`${this.notInstalled(n)}
${y}`);if(h.some(p=>p.type===0)){a.log((0,l.localize)(19,null,n));return}if(!o&&h.some(p=>p.isBuiltin)){a.log((0,l.localize)(20,null,n));return}a.log((0,l.localize)(21,null,n));for(const p of h)await this.extensionManagementService.uninstall(p),s.push(p);this.location?a.log((0,l.localize)(22,null,n,this.location)):a.log((0,l.localize)(23,null,n))}}async locateExtension(f,o=console){const a=await this.extensionManagementService.getInstalled();f.forEach(t=>{a.forEach(s=>{if(s.identifier.id===t&&s.location.scheme===D.Schemas.file){o.log(s.location.fsPath);return}})})}notInstalled(f){return this.location?(0,l.localize)(24,null,f,this.location):(0,l.localize)(25,null,f)}};m=ve([se(0,v.IExtensionManagementService),se(1,v.IExtensionGalleryService)],m),i.ExtensionManagementCLIService=m}),define(J[110],Q([0,1,3,7,2,12,18,43,8,31,13,20,22,23,16,15]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsDownloader=void 0;const g=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let m=class extends b.Disposable{constructor(f,o,a,t){super();this.fileService=o,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=l.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,o){await this.cleanUpPromise;const a=this.getName(f),t=(0,R.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const s=(0,R.joinPath)(this.extensionsDownloadDir,`.${(0,v.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(f,s,o);try{await this.rename(s,t,Date.now()+2*60*1e3)}catch(e){try{await this.fileService.del(s)}catch(n){}if(e.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,P.getErrorMessage)(e)}. Deleted the vsix from downloaded location`,s.path),e}}return t}async delete(f){await this.cleanUpPromise,await this.fileService.del(f)}async rename(f,o,a){try{await E.Promises.rename(f.fsPath,o.fsPath)}catch(t){if(D.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${f} to ${o} with 'EPERM' error. Trying again...`),this.rename(f,o,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const o=[],a=[];for(const e of f.children){const n=this.parse(e.name);n&&a.push([n,e])}const t=(0,y.groupByExtension)(a,([e])=>e),s=[];for(const e of t)e.sort((n,r)=>w.rcompare(n[0].version,r[0].version)),o.push(...e.slice(1).map(n=>n[1].resource)),s.push(e[0][1]);s.sort((e,n)=>e.mtime-n.mtime),o.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(e=>e.resource)),await T.Promises.settled(o.map(e=>(this.logService.trace("Deleting vsix from cache",e.path),this.fileService.del(e))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?`${new y.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase()}${f.properties.targetPlatform!=="undefined"?`-${f.properties.targetPlatform}`:""}`:(0,v.generateUuid)()}parse(f){const o=g.exec(f);return o&&o[1]&&o[2]?new y.ExtensionIdentifierWithVersion({id:o[1]},o[2]):null}};m=ve([se(0,C.INativeEnvironmentService),se(1,u.IFileService),se(2,c.IExtensionGalleryService),se(3,d.ILogService)],m),i.ExtensionsDownloader=m}),define(J[111],Q([0,1,2,6,13,42]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsManifestCache=void 0;class R extends T.Disposable{constructor(l,v){super();this.environmentService=l,this.extensionsManifestCache=(0,P.join)(this.environmentService.userDataPath,D.MANIFEST_CACHE_FOLDER,D.USER_MANIFEST_CACHE_FILE),this._register(v.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(v.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(l){l.some(v=>!!v.local)&&this.invalidate()}onDidUnInstallExtension(l){l.error||this.invalidate()}invalidate(){b.Promises.rm(this.extensionsManifestCache,b.RimRafMode.MOVE).then(()=>{},()=>{})}}i.ExtensionsManifestCache=R}),define(J[112],Q([0,1,137,19,3,2,9,6,13,20,22,23,55,15]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.LocalizationsService=void 0;let u=class extends D.Disposable{constructor(m,S,f){super();this.extensionManagementService=m,this.logService=f,this.cache=this._register(new d(S,f)),this.extensionManagementService.registerParticipant({postInstall:async o=>this.postInstallExtension(o),postUninstall:async o=>this.postUninstallExtension(o)})}async getLanguageIds(){const m=await this.cache.getLanguagePacks(),S=["en",...Object.keys(m)];return(0,P.distinct)(S)}async postInstallExtension(m){m&&m.manifest&&m.manifest.contributes&&m.manifest.contributes.localizations&&m.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",m.identifier.id),await this.update())}async postUninstallExtension(m){const S=await this.cache.getLanguagePacks();Object.keys(S).some(f=>S[f]&&S[f].extensions.some(o=>(0,C.areSameExtensions)(o.extensionIdentifier,m.identifier)))&&(this.logService.info("Removing language packs from the extension",m.identifier.id),await this.update())}async update(){const[m,S]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(S);return!(0,P.equals)(Object.keys(m),Object.keys(f))}};u=ve([se(0,E.IExtensionManagementService),se(1,v.INativeEnvironmentService),se(2,y.ILogService)],u),i.LocalizationsService=u;let d=class extends D.Disposable{constructor(m,S){super();this.logService=S,this.languagePacks={},this.languagePacksFilePath=(0,w.join)(m.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new b.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(m){return this.withLanguagePacks(S=>{Object.keys(S).forEach(f=>delete S[f]),this.createLanguagePacksFromExtensions(S,...m)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(m,...S){for(const f of S)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(m,f);Object.keys(m).forEach(f=>this.updateHash(m[f]))}createLanguagePacksFromExtension(m,S){const f=S.identifier,o=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const a of o)if(S.location.scheme===R.Schemas.file&&(0,c.isValidLocalization)(a)){let t=m[a.languageId];t||(t={hash:"",extensions:[],translations:{}},m[a.languageId]=t);let s=t.extensions.filter(e=>(0,C.areSameExtensions)(e.extensionIdentifier,f))[0];s?s.version=S.manifest.version:t.extensions.push({extensionIdentifier:f,version:S.manifest.version});for(const e of a.translations)t.translations[e.id]=(0,w.join)(S.location.fsPath,e.path)}}updateHash(m){if(m){const S=(0,T.createHash)("md5");for(const f of m.extensions)S.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);m.hash=S.digest("hex")}}withLanguagePacks(m=()=>null){return this.languagePacksFileLimiter.queue(()=>{let S=null;return l.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(o){return{}}}).then(f=>(S=m(f),f)).then(f=>{for(const a of Object.keys(f))f[a]||delete f[a];this.languagePacks=f,this.initializedCache=!0;const o=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",o),l.Promises.writeFile(this.languagePacksFilePath,o)}).then(()=>S,f=>this.logService.error(f))})}};d=ve([se(0,v.INativeEnvironmentService),se(1,y.ILogService)],d)}),define(J[44],Q([0,1,17,85,35,14,29]),function(x,i,T,P,b,D,R){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.updateProxyConfigurationsScope=i.asJson=i.asText=i.isSuccess=i.IRequestService=void 0,i.IRequestService=(0,D.createDecorator)("requestService");function w(u){return u.res.statusCode&&u.res.statusCode>=200&&u.res.statusCode<300||u.res.statusCode===1223}i.isSuccess=w;function l(u){return u.res.statusCode===204}async function v(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);return l(u)?null:(await(0,T.streamToBuffer)(u.stream)).toString()}i.asText=v;async function E(u){if(!w(u))throw new Error("Server returned "+u.res.statusCode);if(l(u))return null;const g=(await(0,T.streamToBuffer)(u.stream)).toString();try{return JSON.parse(g)}catch(m){throw m.message+=`:
`+g,m}}i.asJson=E;function C(u){y(u)}i.updateProxyConfigurationsScope=C;let c;function y(u){const d=R.Registry.as(b.Extensions.Configuration),g=c;c={id:"http",order:15,title:(0,P.localize)(0,null),type:"object",scope:u,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,P.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,P.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,P.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,P.localize)(4,null),(0,P.localize)(5,null),(0,P.localize)(6,null),(0,P.localize)(7,null)],default:"override",description:(0,P.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,P.localize)(9,null),restricted:!0}}},d.updateConfigurations({add:[c],remove:g?[g]:[]})}y(2)}),define(J[113],Q([0,1,24,9,16,44]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.DownloadService=void 0;let R=class{constructor(l,v){this.requestService=l,this.fileService=v}async download(l,v,E=T.CancellationToken.None){if(l.scheme===P.Schemas.file||l.scheme===P.Schemas.vscodeRemote){await this.fileService.copy(l,v);return}const C={type:"GET",url:l.toString()},c=await this.requestService.request(C,E);if(c.res.statusCode===200)await this.fileService.writeFile(v,c.stream);else{const y=await(0,D.asText)(c);throw new Error(`Expected 200, got back ${c.res.statusCode} instead.

${y}`)}}};R=ve([se(0,D.IRequestService),se(1,b.IFileService)],R),i.DownloadService=R}),define(J[114],Q([0,1,115,11]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getProxyAgent=void 0;function b(R,w){return R.protocol==="http:"?w.HTTP_PROXY||w.http_proxy||null:R.protocol==="https:"&&(w.HTTPS_PROXY||w.https_proxy||w.HTTP_PROXY||w.http_proxy)||null}async function D(R,w,l={}){const v=(0,T.parse)(R),E=l.proxyUrl||b(v,w);if(!E)return null;const C=(0,T.parse)(E);if(!/^https?:$/.test(C.protocol||""))return null;const c={host:C.hostname||"",port:C.port||(C.protocol==="https"?"443":"80"),auth:C.auth,rejectUnauthorized:(0,P.isBoolean)(l.strictSSL)?l.strictSSL:!0};return v.protocol==="http:"?new(await new Promise((y,u)=>{x(["http-proxy-agent"],y,u)}))(c):new(await new Promise((y,u)=>{x(["https-proxy-agent"],y,u)}))(c)}i.getProxyAgent=D}),define(J[116],Q([0,1,17,31]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getServiceMachineId=void 0;async function b(D,R,w){let l=w&&w.get("storage.serviceMachineId",0)||null;if(l)return l;try{const E=(await R.readFile(D.serviceMachineIdResource)).value.toString();l=(0,P.isUUID)(E)?E:null}catch(v){l=null}if(!l){l=(0,P.generateUuid)();try{await R.writeFile(D.serviceMachineIdResource,T.VSBuffer.fromString(l))}catch(v){}}return w&&w.store("storage.serviceMachineId",l,0,1),l}i.getServiceMachineId=b}),define(J[117],Q([0,1,3,10,2,102,11,66,14]),function(x,i,T,P,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.logStorage=i.InMemoryStorageService=i.AbstractStorageService=i.StorageTarget=i.StorageScope=i.WillSaveStateReason=i.IStorageService=i.IS_NEW_KEY=void 0,i.IS_NEW_KEY="__$__isNewStorageMarker";const v="__$__targetStorageMarker";i.IStorageService=(0,l.createDecorator)("storageService");var E;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(E=i.WillSaveStateReason||(i.WillSaveStateReason={}));var C;(function(g){g[g.GLOBAL=0]="GLOBAL",g[g.WORKSPACE=1]="WORKSPACE"})(C=i.StorageScope||(i.StorageScope={}));var c;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(c=i.StorageTarget||(i.StorageTarget={}));class y extends b.Disposable{constructor(m={flushInterval:y.DEFAULT_FLUSH_INTERVAL}){super();this.options=m,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new T.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new b.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,T.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,b.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,D.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,D.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(m,S){S===v?(m===0?this._globalKeyTargets=void 0:m===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:m})):this._onDidChangeValue.fire({scope:m,key:S,target:this.getKeyTargets(m)[S]})}emitWillSaveState(m){this._onWillSaveState.fire({reason:m})}get(m,S,f){return this.getStorage(S)?.get(m,f)}getBoolean(m,S,f){return this.getStorage(S)?.getBoolean(m,f)}getNumber(m,S,f){return this.getStorage(S)?.getNumber(m,f)}store(m,S,f,o){if((0,R.isUndefinedOrNull)(S)){this.remove(m,f);return}this.withPausedEmitters(()=>{this.updateKeyTarget(m,f,o),this.getStorage(f)?.set(m,S)})}remove(m,S){this.withPausedEmitters(()=>{this.updateKeyTarget(m,S,void 0),this.getStorage(S)?.delete(m)})}withPausedEmitters(m){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{m()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(m,S){const f=[],o=this.getKeyTargets(m);for(const a of Object.keys(o))o[a]===S&&f.push(a);return f}updateKeyTarget(m,S,f){const o=this.getKeyTargets(S);typeof f=="number"?o[m]!==f&&(o[m]=f,this.getStorage(S)?.set(v,JSON.stringify(o))):typeof o[m]=="number"&&(delete o[m],this.getStorage(S)?.set(v,JSON.stringify(o)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(m){return m===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(m){const S=this.get(v,m);if(S)try{return JSON.parse(S)}catch(f){}return Object.create(null)}isNew(m){return this.getBoolean(i.IS_NEW_KEY,m)===!0}async flush(m=E.NONE){this._onWillSaveState.fire({reason:m});const S=this.getStorage(0),f=this.getStorage(1);switch(m){case E.NONE:await T.Promises.settled([S?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve()]);break;case E.SHUTDOWN:await T.Promises.settled([S?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve()]);break}}async logStorage(){const m=this.getStorage(0)?.items??new Map,S=this.getStorage(1)?.items??new Map;return d(m,S,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}i.AbstractStorageService=y,y.DEFAULT_FLUSH_INTERVAL=60*1e3;class u extends y{constructor(){super();this.globalStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new w.Storage(new w.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(m=>this.emitDidChangeValue(1,m))),this._register(this.globalStorage.onDidChangeStorage(m=>this.emitDidChangeValue(0,m)))}getStorage(m){return m===0?this.globalStorage:this.workspaceStorage}getLogDetails(m){return m===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(m){}}i.InMemoryStorageService=u;async function d(g,m,S,f){const o=h=>{try{return JSON.parse(h)}catch(p){return h}},a=new Map,t=new Map;g.forEach((h,p)=>{a.set(p,h),t.set(p,o(h))});const s=new Map,e=new Map;m.forEach((h,p)=>{s.set(p,h),e.set(p,o(h))}),console.group(`Storage: Global (path: ${S})`);let n=[];a.forEach((h,p)=>{n.push({key:p,value:h})}),console.table(n),console.groupEnd(),console.log(t),console.group(`Storage: Workspace (path: ${f})`);let r=[];s.forEach((h,p)=>{r.push({key:p,value:h})}),console.table(r),console.groupEnd(),console.log(e)}i.logStorage=d}),define(J[118],Q([0,1,12,28,8,31]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.verifyMicrosoftInternalDomain=i.resolveCommonProperties=void 0;function R(v){if(T.platform===2&&/^penguin(\.|$)/i.test(v))return"chromebook"}async function w(v,E,C,c,y,u,d,g,m,S){const f=Object.create(null);f["common.machineId"]=d,f.sessionID=(0,D.generateUuid)()+Date.now(),f.commitHash=y,f.version=u,f["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,T.PlatformToString)(T.platform),f["common.nodePlatform"]=P.platform,f["common.nodeArch"]=c,f["common.product"]=S||"desktop";const o=l(g||[]);o&&(f["common.msftInternal"]=o);let a=0;const t=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),T.isLinuxSnap&&(f["common.snap"]="true");const s=R(C);s&&(f["common.platformDetail"]=s);try{const e=await v.readFile(b.URI.file(m));f["common.source"]=e.value.toString().slice(0,30)}catch(e){}return f}i.resolveCommonProperties=w;function l(v){const E=P.env.USERDNSDOMAIN;if(!E)return!1;const C=E.toLowerCase();return v.some(c=>C===c)}i.verifyMicrosoftInternalDomain=l}),define(J[30],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryConfiguration=i.TelemetryLevel=i.TELEMETRY_OLD_SETTING_ID=i.TELEMETRY_SETTING_ID=i.TELEMETRY_SECTION_ID=i.machineIdKey=i.lastSessionDateStorageKey=i.firstSessionDateStorageKey=i.currentSessionDateStorageKey=i.ICustomEndpointTelemetryService=i.ITelemetryService=void 0,i.ITelemetryService=(0,T.createDecorator)("telemetryService"),i.ICustomEndpointTelemetryService=(0,T.createDecorator)("customEndpointTelemetryService"),i.currentSessionDateStorageKey="telemetry.currentSessionDate",i.firstSessionDateStorageKey="telemetry.firstSessionDate",i.lastSessionDateStorageKey="telemetry.lastSessionDate",i.machineIdKey="telemetry.machineId",i.TELEMETRY_SECTION_ID="telemetry",i.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",i.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(D){D[D.NONE=0]="NONE",D[D.CRASH=1]="CRASH",D[D.ERROR=2]="ERROR",D[D.USAGE=3]="USAGE"})(P=i.TelemetryLevel||(i.TelemetryLevel={}));var b;(function(D){D.OFF="off",D.CRASH="crash",D.ERROR="error",D.ON="all"})(b=i.TelemetryConfiguration||(i.TelemetryConfiguration={}))}),define(J[119],Q([0,1,19,3,24,7,10,2,12,8,75,22,23,15,32,30]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AbstractExtensionTask=i.reportTelemetry=i.joinErrors=i.AbstractExtensionManagementService=void 0;let g=class extends w.Disposable{constructor(t,s,e,n){super();this.galleryService=t,this.telemetryService=s,this.logService=e,this.productService=n,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new R.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new R.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new R.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new R.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,w.toDisposable)(()=>{this.installingExtensions.forEach(r=>r.cancel()),this.uninstallingExtensions.forEach(r=>r.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(e=>(0,C.isTargetPlatformCompatible)(e,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{if(!this.galleryService.isEnabled())throw new C.ExtensionManagementError(E.localize(0,null),C.ExtensionManagementErrorCode.Internal);const e=await this.checkAndGetCompatibleVersion(t,!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.installExtension(e.manifest,e.extension,s)}catch(e){throw f(this.telemetryService,"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(t),void 0,e),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(e),S(e)}}async uninstall(t,s={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.unininstallExtension(t,s)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const s=await this.findGalleryExtension(t);if(!s)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(s)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,s,e){if(!v.URI.isUri(s)){let L=this.installingExtensions.get(new c.ExtensionIdentifierWithVersion(s.identifier,s.version).key());if(L)return this.logService.info("Extensions is already requested to install",s.identifier.id),L.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const n=[],r=[],h=this.createInstallExtensionTask(t,s,e);v.URI.isUri(s)||this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(h.identifier,t.version).key(),h),this._onInstallExtension.fire({identifier:h.identifier,source:s}),this.logService.info("Installing extension:",h.identifier.id),n.push({task:h,manifest:t});let p=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",h.identifier.id);else try{const I=await this.getAllDepsAndPackExtensionsToInstall(h.identifier,t,!!e.installOnlyNewlyAddedFromExtensionPack,!!e.installPreReleaseVersion);for(const{gallery:O,manifest:N}of I)if(p=p||!!N.extensionDependencies?.some(K=>(0,c.areSameExtensions)({id:K},h.identifier)),this.installingExtensions.has(new c.ExtensionIdentifierWithVersion(O.identifier,O.version).key()))this.logService.info("Extension is already requested to install",O.identifier.id);else{const K=this.createInstallExtensionTask(N,O,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new c.ExtensionIdentifierWithVersion(K.identifier,N.version).key(),K),this._onInstallExtension.fire({identifier:K.identifier,source:O}),this.logService.info("Installing extension:",K.identifier.id),n.push({task:K,manifest:N})}}catch(I){if(v.URI.isUri(h.source))(0,T.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",h.identifier.id,I.message),(0,T.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",h.identifier.id,I.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",h.identifier.id),I}const L=n.reduce((I,{task:O,manifest:N})=>(I.set(O.identifier.id.toLowerCase(),{task:O,manifest:N}),I),new Map);for(;L.size;){let I;const O=[...L.values()].filter(({manifest:N})=>!N.extensionDependencies?.some(K=>L.has(K.toLowerCase())));O.length?I=L.size===1?O:O.filter(({task:N})=>!(N===h&&!p)):(this.logService.info("Found extensions with circular dependencies",O.map(({task:N})=>N.identifier.id)),I=[...L.values()]),await this.joinAllSettled(I.map(async({task:N})=>{const K=new Date().getTime();try{const te=await N.run();if(await this.joinAllSettled(this.participants.map(ge=>ge.postInstall(te,N.source,e,b.CancellationToken.None))),!v.URI.isUri(N.source)&&(f(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-K,void 0),l.isWeb&&N.operation===1))try{await this.galleryService.reportStatistic(te.manifest.publisher,te.manifest.name,te.manifest.version,"install")}catch(ge){}r.push({local:te,identifier:N.identifier,operation:N.operation,source:N.source})}catch(te){throw v.URI.isUri(N.source)||f(this.telemetryService,N.operation===2?"extensionGallery:update":"extensionGallery:install",(0,c.getGalleryExtensionTelemetryData)(N.source),new Date().getTime()-K,te),this.logService.error("Error while installing the extension:",N.identifier.id),te}finally{L.delete(N.identifier.id.toLowerCase())}}))}return r.forEach(({identifier:I})=>this.logService.info("Extension installed successfully:",I.id)),this._onDidInstallExtensions.fire(r),r.filter(({identifier:I})=>(0,c.areSameExtensions)(I,h.identifier))[0].local}catch(L){if(n.forEach(({task:I})=>I.cancel()),r.length)try{const I=await Promise.allSettled(r.map(({local:O})=>this.createUninstallExtensionTask(O,{versionOnly:!0}).run()));for(let O=0;O<I.length;O++){const N=I[O],{identifier:K}=r[O];N.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",K.id):this.logService.warn("Rollback: Error while uninstalling extension",K.id,(0,D.getErrorMessage)(N.reason))}}catch(I){this.logService.warn("Error while rolling back extensions",(0,D.getErrorMessage)(I),r.map(({identifier:O})=>O.id))}throw this._onDidInstallExtensions.fire(n.map(({task:I})=>({identifier:I.identifier,operation:1,source:I.source}))),L}finally{for(const{task:L,manifest:I}of n)if(!v.URI.isUri(L.source)){const O=new c.ExtensionIdentifierWithVersion(L.identifier,I.version).key();this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(t){const s=[],e=[],n=await Promise.allSettled(t);for(const r of n)r.status==="fulfilled"?s.push(r.value):e.push(r.reason);if(e.length)throw m(e);return s}async getAllDepsAndPackExtensionsToInstall(t,s,e,n){if(!this.galleryService.isEnabled())return[];let r=await this.getInstalled();const h=[t,...r.map(I=>I.identifier)],p=[],L=async(I,O)=>{const N=O.extensionDependencies||[],K=[...N];if(O.extensionPack){const te=e?r.find(ge=>(0,c.areSameExtensions)(ge.identifier,I)):void 0;for(const ge of O.extensionPack)te&&te.manifest.extensionPack&&te.manifest.extensionPack.some(ce=>(0,c.areSameExtensions)({id:ce},{id:ge}))||K.every(ce=>!(0,c.areSameExtensions)({id:ce},{id:ge}))&&K.push(ge)}if(K.length){const te=[...h,...p.map(ce=>ce.gallery.identifier)],ge=K.filter(ce=>te.every(ie=>!(0,c.areSameExtensions)(ie,{id:ce})));if(ge.length){const ce=await this.galleryService.query({names:ge,pageSize:K.length},b.CancellationToken.None);for(const ie of ce.firstPage){if(te.find(B=>(0,c.areSameExtensions)(B,ie.identifier)))continue;const pe=N.some(B=>(0,c.areSameExtensions)({id:B},ie.identifier));let V;try{V=await this.checkAndGetCompatibleVersion(ie,!0,n)}catch(B){if(B instanceof C.ExtensionManagementError&&B.code===C.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!pe){this.logService.info("Skipping the packed extension as it cannot be installed",ie.identifier.id);continue}else throw B}p.push({gallery:V.extension,manifest:V.manifest}),await L(V.extension.identifier,O)}}}};return await L(t,s),r=await this.getInstalled(),p.filter(I=>!r.some(O=>(0,c.areSameExtensions)(O.identifier,I.gallery.identifier)))}async checkAndGetCompatibleVersion(t,s,e){if(await this.isMalicious(t))throw new C.ExtensionManagementError(E.localize(3,null,t.identifier.id),C.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const h=await this.getTargetPlatform();throw new C.ExtensionManagementError(E.localize(4,null,t.identifier.id,this.productService.nameLong,(0,C.TargetPlatformToString)(h)),C.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const n=await this.getCompatibleVersion(t,s,e);if(n){if(e&&t.hasPreReleaseVersion&&!n.properties.isPreReleaseVersion)throw new C.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw new C.ExtensionManagementError(E.localize(6,null,t.identifier.id,this.productService.nameLong,this.productService.version),C.ExtensionManagementErrorCode.Incompatible);const r=await this.galleryService.getManifest(n,b.CancellationToken.None);if(r===null)throw new C.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,C.ExtensionManagementErrorCode.Invalid);if(r.version!==n.version)throw new C.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,C.ExtensionManagementErrorCode.Invalid);return{extension:n,manifest:r}}async getCompatibleVersion(t,s,e){const n=await this.getTargetPlatform();let r=null;return s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==e&&(r=await this.galleryService.getCompatibleExtension(t.identifier,e,n)),!r&&await this.galleryService.isExtensionCompatible(t,e,n)&&(r=t),!r&&s&&(r=await this.galleryService.getCompatibleExtension(t,e,n)),r}async isMalicious(t){const s=await this.getExtensionsControlManifest();return(0,c.getMaliciousExtensionsSet)(s).has(t.identifier.id)}async unininstallExtension(t,s){const e=this.uninstallingExtensions.get(t.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),e.waitUntilTaskIsFinished();const n=(L,I)=>{const O=this.createUninstallExtensionTask(L,I);return this.uninstallingExtensions.set(O.extension.identifier.id.toLowerCase(),O),this.logService.info("Uninstalling extension:",L.identifier.id),this._onUninstallExtension.fire(L.identifier),O},r=(L,I)=>{I?this.logService.error("Failed to uninstall extension:",L.identifier.id,I.message):this.logService.info("Successfully uninstalled extension:",L.identifier.id),f(this.telemetryService,"extensionGallery:uninstall",(0,c.getLocalExtensionTelemetryData)(L),void 0,I),this._onDidUninstallExtension.fire({identifier:L.identifier,error:I?.code})},h=[],p=[];try{h.push(n(t,{}));const L=await this.getInstalled(1);if(s.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",t.identifier.id);else{const I=this.getAllPackExtensionsToUninstall(t,L);for(const O of I)this.uninstallingExtensions.has(O.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",O.identifier.id):h.push(n(O,{}))}s.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",t.identifier.id):this.checkForDependents(h.map(I=>I.extension),L,t),await this.joinAllSettled(h.map(async I=>{try{if(await I.run(),await this.joinAllSettled(this.participants.map(O=>O.postUninstall(I.extension,s,b.CancellationToken.None))),I.extension.identifier.uuid)try{await this.galleryService.reportStatistic(I.extension.manifest.publisher,I.extension.manifest.name,I.extension.manifest.version,"uninstall")}catch(O){}r(I.extension)}catch(O){const N=O instanceof C.ExtensionManagementError?O:new C.ExtensionManagementError((0,D.getErrorMessage)(O),C.ExtensionManagementErrorCode.Internal);throw r(I.extension,N),N}finally{p.push(I)}}))}catch(L){const I=L instanceof C.ExtensionManagementError?L:new C.ExtensionManagementError((0,D.getErrorMessage)(L),C.ExtensionManagementErrorCode.Internal);for(const O of h){try{O.cancel()}catch(N){}p.includes(O)||r(O.extension,I)}throw I}finally{for(const L of h)this.uninstallingExtensions.delete(L.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",L.extension.identifier.id)}}checkForDependents(t,s,e){for(const n of t){const r=this.getDependents(n,s);if(r.length){const h=r.filter(p=>!t.some(L=>(0,c.areSameExtensions)(L.identifier,p.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(n,h,e))}}}getDependentsErrorMessage(t,s,e){return e===t?s.length===1?E.localize(7,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?E.localize(8,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):E.localize(9,null,e.manifest.displayName||e.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?E.localize(10,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?E.localize(11,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):E.localize(12,null,e.manifest.displayName||e.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}getAllPackExtensionsToUninstall(t,s,e=[]){if(e.indexOf(t)!==-1)return[];e.push(t);const n=t.manifest.extensionPack?t.manifest.extensionPack:[];if(n.length){const r=s.filter(p=>!p.isBuiltin&&n.some(L=>(0,c.areSameExtensions)({id:L},p.identifier))),h=[];for(const p of r)h.push(...this.getAllPackExtensionsToUninstall(p,s,e));return[...r,...h]}return[]}getDependents(t,s){return s.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(n=>(0,c.areSameExtensions)({id:n},t.identifier)))}async findGalleryExtension(t){if(t.identifier.uuid){const s=await this.findGalleryExtensionById(t.identifier.uuid);return s||this.findGalleryExtensionByName(t.identifier.id)}return this.findGalleryExtensionByName(t.identifier.id)}async findGalleryExtensionById(t){return(await this.galleryService.query({ids:[t],pageSize:1},b.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(t){return(await this.galleryService.query({names:[t],pageSize:1},b.CancellationToken.None)).firstPage[0]}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch(t){return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[]}}}};g=ve([se(0,C.IExtensionGalleryService),se(1,d.ITelemetryService),se(2,y.ILogService),se(3,u.IProductService)],g),i.AbstractExtensionManagementService=g;function m(a){const t=Array.isArray(a)?a:[a];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((s,e)=>new Error(`${s.message}${s.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}i.joinErrors=m;function S(a){if(a instanceof C.ExtensionManagementError)return a;const t=new C.ExtensionManagementError(a.message,C.ExtensionManagementErrorCode.Internal);return t.stack=a.stack,t}function f(a,t,s,e,n){const r=n?n instanceof C.ExtensionManagementError?n.code:C.ExtensionManagementErrorCode.Internal:void 0;a.publicLogError(t,{...s,success:!n,duration:e,errorcode:r})}i.reportTelemetry=f;class o{constructor(){this.barrier=new P.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,P.createCancelablePromise)(t=>new Promise((s,e)=>{const n=t.onCancellationRequested(()=>{n.dispose(),e((0,D.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}i.AbstractExtensionTask=o}),define(J[36],Q([0,1,21,11,25,30]),function(x,i,T,P,b,D){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.cleanRemoteAuthority=i.validateTelemetryData=i.getTelemetryLevel=i.supportsTelemetry=i.configurationTelemetry=i.NullAppender=i.NullEndpointTelemetryService=i.NullTelemetryService=i.NullTelemetryServiceShape=void 0;class R{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(m,S){return Promise.resolve(void 0)}publicLog2(m,S){return this.publicLog(m,S)}publicLogError(m,S){return Promise.resolve(void 0)}publicLogError2(m,S){return this.publicLogError(m,S)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}i.NullTelemetryServiceShape=R,i.NullTelemetryService=new R;class w{async publicLog(m,S,f){}async publicLogError(m,S,f){}}i.NullEndpointTelemetryService=w,i.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function l(g,m){return m.onDidChangeConfiguration(S=>{S.source!==6&&g.publicLog2("updateConfiguration",{configurationSource:(0,b.ConfigurationTargetToString)(S.source),configurationKeys:u(S.sourceConfig)})})}i.configurationTelemetry=l;function v(g,m){return!(m.disableTelemetry||!g.enableTelemetry)}i.supportsTelemetry=v;function E(g){const m=g.getValue(D.TELEMETRY_SETTING_ID),S=g.getValue("telemetry.enableCrashReporter");if(g.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(m??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}i.getTelemetryLevel=E;function C(g){const m=Object.create(null),S=Object.create(null),f=Object.create(null);y(g,f);for(let o in f){o=o.length>150?o.substr(o.length-149):o;const a=f[o];typeof a=="number"?S[o]=a:typeof a=="boolean"?S[o]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${o} has been trimmed to 8192, the original length is ${a.length}`),m[o]=a.substring(0,8191)):typeof a!="undefined"&&a!==null&&(m[o]=a)}return{properties:m,measurements:S}}i.validateTelemetryData=C;function c(g){if(!g)return"none";let m="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(f=>{g.indexOf(`${f}+`)===0&&(m=f)}),m}i.cleanRemoteAuthority=c;function y(g,m,S=0,f){if(!!g)for(let o of Object.getOwnPropertyNames(g)){const a=g[o],t=f?f+o:o;Array.isArray(a)?m[t]=(0,T.safeStringify)(a):a instanceof Date?m[t]=a.toISOString():(0,P.isObject)(a)?S<2?y(a,m,S+1,t+"."):m[t]=(0,T.safeStringify)(a):m[t]=a}}function u(g){if(!g)return[];const m=[];return d(m,"",g),m}function d(g,m,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(f=>d(g,m?`${m}.${f}`:f,S[f])):g.push(m)}}),define(J[120],Q([0,1,19,24,7,21,12,28,11,8,25,20,22,23,51,16,15,32,44,116,117,30,36]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d,g,m,S,f,o,a,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.resolveMarketplaceHeaders=i.ExtensionGalleryServiceWithNoStorageService=i.ExtensionGalleryService=i.sortExtensionVersions=void 0;const s=R.isWeb?"web":(0,c.getTargetPlatform)(R.platform,w.arch);var e;(function(U){U[U.None=0]="None",U[U.IncludeVersions=1]="IncludeVersions",U[U.IncludeFiles=2]="IncludeFiles",U[U.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",U[U.IncludeSharedAccounts=8]="IncludeSharedAccounts",U[U.IncludeVersionProperties=16]="IncludeVersionProperties",U[U.ExcludeNonValidated=32]="ExcludeNonValidated",U[U.IncludeInstallationTargets=64]="IncludeInstallationTargets",U[U.IncludeAssetUri=128]="IncludeAssetUri",U[U.IncludeStatistics=256]="IncludeStatistics",U[U.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",U[U.Unpublished=4096]="Unpublished"})(e||(e={}));function n(...U){return String(U.reduce((A,q)=>A|q,0))}var r;(function(U){U[U.Tag=1]="Tag",U[U.ExtensionId=4]="ExtensionId",U[U.Category=5]="Category",U[U.ExtensionName=7]="ExtensionName",U[U.Target=8]="Target",U[U.Featured=9]="Featured",U[U.SearchText=10]="SearchText",U[U.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const h={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},p={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},I={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:e.None,criteria:[],assetTypes:[]};class O{constructor(A=I){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,q=this.state.pageSize){return new O({...this.state,pageNumber:A,pageSize:q})}withFilter(A,...q){const W=[...this.state.criteria,...q.length?q.map(Y=>({filterType:A,value:Y})):[{filterType:A}]];return new O({...this.state,criteria:W})}withSortBy(A){return new O({...this.state,sortBy:A})}withSortOrder(A){return new O({...this.state,sortOrder:A})}withFlags(...A){return new O({...this.state,flags:A.reduce((q,W)=>q|W,0)})}withAssetTypes(...A){return new O({...this.state,assetTypes:A})}get raw(){const{criteria:A,pageNumber:q,pageSize:W,sortBy:Y,sortOrder:X,flags:de,assetTypes:fe}=this.state;return{filters:[{criteria:A,pageNumber:q,pageSize:W,sortBy:Y,sortOrder:X}],assetTypes:fe,flags:de}}get searchText(){const A=this.state.criteria.filter(q=>q.filterType===r.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function N(U,A){const q=(U||[]).filter(W=>W.statisticName===A)[0];return q?q.value:0}function K(U){const A="Microsoft.VisualStudio.Code.Translation.";return U.files.filter(W=>W.assetType.indexOf(A)===0).reduce((W,Y)=>{const X=ie(U,Y.assetType);return X&&W.push([Y.assetType.substring(A.length),X]),W},[])}function te(U){if(U.properties){const A=U.properties.filter(Y=>Y.key===h.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=A.filter(Y=>q.test(Y.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return ie(U,h.Repository)}function ge(U){return{uri:`${U.fallbackAssetUri}/${h.VSIX}?redirect=true${U.targetPlatform?`&targetPlatform=${U.targetPlatform}`:""}`,fallbackUri:`${U.fallbackAssetUri}/${h.VSIX}${U.targetPlatform?`?targetPlatform=${U.targetPlatform}`:""}`}}function ce(U){const A=ie(U,h.Icon);if(A)return A;const q=c.DefaultIconPath;return{uri:q,fallbackUri:q}}function ie(U,A){return U.files.filter(W=>W.assetType===A)[0]?{uri:`${U.assetUri}/${A}`,fallbackUri:`${U.fallbackAssetUri}/${A}`}:null}function pe(U,A){const q=U.properties?U.properties.filter(Y=>Y.key===A):[],W=q.length>0&&q[0].value;return W?W.split(",").map(Y=>(0,y.adoptToGalleryExtensionId)(Y)):[]}function V(U){const A=U.properties?U.properties.filter(q=>q.key===p.Engine):[];return A.length>0&&A[0].value||""}function B(U){const A=U.properties?U.properties.filter(q=>q.key===p.PreRelease):[];return A.length>0&&A[0].value==="true"}function ne(U){const A=U.properties?U.properties.filter(W=>W.key===p.LocalizedLanguages):[],q=A.length>0&&A[0].value||"";return q?q.split(","):[]}function M(U){return U.indexOf("preview")!==-1}function k(U){return U.targetPlatform?(0,c.toTargetPlatform)(U.targetPlatform):"undefined"}function j(U){const A=(0,T.distinct)(U.versions.map(k)),q=!!U.tags?.includes(c.WEB_EXTENSION_TAG),W=A.indexOf("web");return q?W===-1&&A.push("web"):W!==-1&&A.splice(W,1),A}function G(U,A){const q=(0,c.getFallbackTargetPlarforms)(A);for(let W=0;W<U.length;W++){const Y=U[W];if(Y.version===U[W-1]?.version){let X=W;const de=k(Y);if(de===A)for(;X>0&&U[X-1].version===Y.version;)X--;else if(q.includes(de))for(;X>0&&U[X-1].version===Y.version&&k(U[X-1])!==A;)X--;X!==W&&(U.splice(W,1),U.splice(X,0,Y))}}return U}i.sortExtensionVersions=G;function ee(U,A,q,W){const Y=U.versions[0],X={manifest:ie(A,h.Manifest),readme:ie(A,h.Details),changelog:ie(A,h.Changelog),license:ie(A,h.License),repository:te(A),download:ge(A),icon:ce(A),coreTranslations:K(A)};return{identifier:{id:(0,y.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},name:U.extensionName,version:A.version,displayName:U.displayName,publisherId:U.publisher.publisherId,publisher:U.publisher.publisherName,publisherDisplayName:U.publisher.displayName,publisherDomain:U.publisher.domain?{link:U.publisher.domain,verified:!!U.publisher.isDomainVerified}:void 0,description:U.shortDescription||"",installCount:N(U.statistics,"install"),rating:N(U.statistics,"averagerating"),ratingCount:N(U.statistics,"ratingcount"),categories:U.categories||[],tags:U.tags||[],releaseDate:Date.parse(U.releaseDate),lastUpdated:Date.parse(U.lastUpdated),allTargetPlatforms:q,assets:X,properties:{dependencies:pe(A,p.Dependency),extensionPack:pe(A,p.ExtensionPack),engine:V(A),localizedLanguages:ne(A),targetPlatform:k(A),isPreReleaseVersion:B(A)},hasPreReleaseVersion:B(Y),preview:M(U.flags),telemetryData:W}}let H=class{constructor(A,q,W,Y,X,de,fe,ue){this.requestService=q,this.logService=W,this.environmentService=Y,this.telemetryService=X,this.fileService=de,this.productService=fe,this.configurationService=ue;const re=fe.extensionsGallery;this.extensionsGalleryUrl=re&&re.serviceUrl,this.extensionsControlUrl=re&&re.controlUrl,this.commonHeadersPromise=ae(fe.version,fe,this.environmentService,this.configurationService,this.fileService,A)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,q,W){const Y=(0,l.isBoolean)(q)?q:!1,X=(0,l.isBoolean)(q)?W:q;let de=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,A.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...A.map(({id:re})=>re.toLowerCase()));A.every(re=>!re.version)&&(de=de.withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties,e.IncludeLatestVersionOnly));const{galleryExtensions:fe}=await this.queryGallery(de,s,P.CancellationToken.None),ue=fe.map(re=>{const ye=(0,y.getGalleryExtensionId)(re.publisher.publisherName,re.extensionName);return{rawGalleryExtension:re,version:A.find(oe=>(0,y.areSameExtensions)(oe,{id:ye}))?.version}});return this.converToGalleryExtensions(ue,Y,s,()=>{},X)}async getCompatibleExtension(A,q,W){const Y=(0,c.isIExtensionIdentifier)(A)?null:A;if(Y){if((0,c.isNotWebExtensionInWebTargetPlatform)(Y.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(Y,q,W))return Y}const{id:X,uuid:de}=Y?Y.identifier:A;let fe=new O().withFlags(e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");de?fe=fe.withFilter(r.ExtensionId,de):fe=fe.withFilter(r.ExtensionName,X);const{galleryExtensions:ue}=await this.queryGallery(fe,W,P.CancellationToken.None),[re]=ue;if(!re||!re.versions.length)return null;const ye=j(re);if((0,c.isNotWebExtensionInWebTargetPlatform)(ye,W))return null;for(let oe of re.versions){if(!V(oe)){const he=await this.getEngine(oe);oe={...oe,properties:[...oe.properties||[],{key:p.Engine,value:he}]}}if(await this.isRawExtensionVersionCompatible(oe,q,ye,W))return ee(re,oe,ye)}return null}async isExtensionCompatible(A,q,W){if(!(0,c.isTargetPlatformCompatible)(A.properties.targetPlatform,A.allTargetPlatforms,W)||!q&&A.properties.isPreReleaseVersion)return!1;let Y=A.properties.engine;if(!Y){const X=await this.getManifest(A,P.CancellationToken.None);if(!X)throw new Error("Manifest was not found");Y=X.engines.vscode}return(0,u.isEngineValid)(Y,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(A,q,W,Y){if(!(0,c.isTargetPlatformCompatible)(k(A),W,Y)||!q&&B(A))return!1;const X=await this.getEngine(A);return(0,u.isEngineValid)(X,this.productService.version,this.productService.date)}async query(A,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let W=A.text||"";const Y=(0,D.getOrDefault)(A,oe=>oe.pageSize,50);let X=new O().withFlags(e.IncludeLatestVersionOnly,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,Y).withFilter(r.Target,"Microsoft.VisualStudio.Code");W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,he,Ce)=>(X=X.withFilter(r.Category,Ce||he),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(oe,he,Ce)=>(X=X.withFilter(r.Tag,Ce||he),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(r.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),X=X.withFilter(r.SearchText,W)),X=X.withSortBy(0)):A.ids?X=X.withFilter(r.ExtensionId,...A.ids):A.names?X=X.withFilter(r.ExtensionName,...A.names):X=X.withSortBy(4),typeof A.sortBy=="number"&&(X=X.withSortBy(A.sortBy)),typeof A.sortOrder=="number"&&(X=X.withSortOrder(A.sortOrder));const{galleryExtensions:de,total:fe}=await this.queryGallery(X,s,q),ue=oe=>({index:(X.pageNumber-1)*X.pageSize+oe,querySource:A.source}),re=await this.converToGalleryExtensions(de.map(oe=>({rawGalleryExtension:oe})),!!A.includePreRelease,s,ue,q),ye=async(oe,he)=>{if(he.isCancellationRequested)throw(0,b.canceled)();const Ce=X.withPage(oe+1),{galleryExtensions:xe}=await this.queryGallery(Ce,s,he);return await this.converToGalleryExtensions(xe.map(Ae=>({rawGalleryExtension:Ae})),!!A.includePreRelease,s,ue,q)};return{firstPage:re,total:fe,pageSize:X.pageSize,getPage:ye}}async converToGalleryExtensions(A,q,W,Y,X){const de=(re,ye)=>{const oe=j(re);let he=re.versions[0];return he=re.versions.find(Ce=>Ce.version===he.version&&(0,c.isTargetPlatformCompatible)(k(Ce),oe,W))||he,!q&&B(he)&&(he=re.versions.find(Ce=>Ce.version!==he.version&&!B(Ce))||he),ee(re,he,oe,Y(ye))},fe=[],ue=new Map;for(let re=0;re<A.length;re++){const{rawGalleryExtension:ye,version:oe}=A[re];if(oe){const he=ye.versions.find(Ce=>Ce.version===oe);he&&fe.push([re,ee(ye,he,j(ye))])}else{const he=de(ye,re);he.properties.isPreReleaseVersion&&!q?ue.set(he.identifier.uuid,re):fe.push([re,he])}}if(ue.size){const re=new O().withFlags(e.IncludeVersions,e.IncludeAssetUri,e.IncludeStatistics,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,ue.size).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionId,...ue.keys()),{galleryExtensions:ye}=await this.queryGallery(re,W,X);if(ye.length!==ue.size)throw new Error("Not all extensions with latest versions are returned");for(const oe of ye){const he=ue.get(oe.extensionId),Ce=de(oe,he);fe.push([he,Ce])}}return fe.sort((re,ye)=>re[0]-ye[0]).map(([,re])=>re)}async queryGallery(A,q,W){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,e.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,n(e.Unpublished));const Y=await this.commonHeadersPromise,X=JSON.stringify(A.raw),de={...Y,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(X.length)},fe=new Date().getTime();let ue,re,ye=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:X,headers:de},W),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ye};const oe=await(0,S.asJson)(ue);if(oe){const he=oe.results[0],Ce=he.extensions;Ce.forEach(Ae=>G(Ae.versions,q));const xe=he.resultMetadata&&he.resultMetadata.filter(Ae=>Ae.metadataType==="ResultCount")[0];return ye=xe&&xe.metadataItems.filter(Ae=>Ae.name==="TotalCount")[0].count||0,{galleryExtensions:Ce,total:ye}}return{galleryExtensions:[],total:ye}}catch(oe){throw re=oe,oe}finally{this.telemetryService.publicLog2("galleryService:query",{...A.telemetryData,requestBodySize:String(X.length),duration:new Date().getTime()-fe,success:!!ue&&(0,S.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:re?(0,b.isPromiseCanceledError)(re)?"canceled":(0,b.getErrorMessage)(re).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ye)})}}async reportStatistic(A,q,W,Y){if(!this.isEnabled())return;const X=R.isWeb?this.api(`/itemName/${A}.${q}/version/${W}/statType/${Y==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${A}/extensions/${q}/${W}/stats?statType=${Y}`),de=R.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:de};try{await this.requestService.request({type:"POST",url:X,headers:ue},P.CancellationToken.None)}catch(re){}}async download(A,q,W){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const Y=(0,y.getGalleryExtensionTelemetryData)(A),X=new Date().getTime(),de=ye=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Y,duration:ye}),fe=W===1?"install":W===2?"update":"",ue=fe?{uri:`${A.assets.download.uri}${v.URI.parse(A.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${A.assets.download.fallbackUri}${v.URI.parse(A.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:A.assets.download,re=await this.getAsset(ue);await this.fileService.writeFile(q,re.stream),de(new Date().getTime()-X)}async getReadme(A,q){if(A.assets.readme){const W=await this.getAsset(A.assets.readme,{},q);return await(0,S.asText)(W)||""}return""}async getManifest(A,q){if(A.assets.manifest){const W=await this.getAsset(A.assets.manifest,{},q),Y=await(0,S.asText)(W);return Y?JSON.parse(Y):null}return null}async getManifestFromRawExtensionVersion(A,q){const W=ie(A,h.Manifest);if(!W)throw new Error("Manifest was not found");const Y={"Accept-Encoding":"gzip"},X=await this.getAsset(W,{headers:Y});return await(0,S.asJson)(X)}async getCoreTranslation(A,q){const W=A.assets.coreTranslations.filter(Y=>Y[0]===q.toUpperCase())[0];if(W){const Y=await this.getAsset(W[1]),X=await(0,S.asText)(Y);return X?JSON.parse(X):null}return null}async getChangelog(A,q){if(A.assets.changelog){const W=await this.getAsset(A.assets.changelog,{},q);return await(0,S.asText)(W)||""}return""}async getAllCompatibleVersions(A,q,W){let Y=new O().withFlags(e.IncludeVersions,e.IncludeCategoryAndTags,e.IncludeFiles,e.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?Y=Y.withFilter(r.ExtensionId,A.identifier.uuid):Y=Y.withFilter(r.ExtensionName,A.identifier.id);const{galleryExtensions:X}=await this.queryGallery(Y,W,P.CancellationToken.None);if(!X.length)return[];const de=j(X[0]);if((0,c.isNotWebExtensionInWebTargetPlatform)(de,W))return[];const fe=[];for(const ue of X[0].versions)try{fe[fe.length-1]?.version!==ue.version&&await this.isRawExtensionVersionCompatible(ue,q,de,W)&&fe.push({version:ue.version,date:ue.lastUpdated,isPreReleaseVersion:B(ue)})}catch(re){}return fe}async getAsset(A,q={},W=P.CancellationToken.None){const Y=await this.commonHeadersPromise,X={type:"GET"},de={...Y,...q.headers||{}};q={...q,...X,headers:de};const fe=A.uri,ue=A.fallbackUri,re={...q,url:fe};try{const ye=await this.requestService.request(re,W);if(ye.res.statusCode===200)return ye;const oe=await(0,S.asText)(ye);throw new Error(`Expected 200, got back ${ye.res.statusCode} instead.

${oe}`)}catch(ye){if((0,b.isPromiseCanceledError)(ye))throw ye;const oe=(0,b.getErrorMessage)(ye);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:fe,message:oe});const he={...q,url:ue};return this.requestService.request(he,W)}}async getEngine(A){let q=V(A);if(!q){const W=await this.getManifestFromRawExtensionVersion(A,P.CancellationToken.None);if(!W)throw new Error("Manifest was not found");q=W.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[]};const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},P.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,S.asJson)(A),W=[],Y={};if(q){for(const X of q.malicious)W.push({id:X});if(q.unsupported)for(const X of Object.keys(q.unsupported)){const de=q.unsupported[X];(0,l.isBoolean)(de)||(Y[X.toLowerCase()]=de.preReleaseExtension)}}return{malicious:W,unsupportedPreReleaseExtensions:Y}}};H=ve([se(1,S.IRequestService),se(2,g.ILogService),se(3,C.IEnvironmentService),se(4,a.ITelemetryService),se(5,d.IFileService),se(6,m.IProductService),se(7,E.IConfigurationService)],H);let Z=class extends H{constructor(A,q,W,Y,X,de,fe,ue){super(A,q,W,Y,X,de,fe,ue)}};Z=ve([se(0,o.IStorageService),se(1,S.IRequestService),se(2,g.ILogService),se(3,C.IEnvironmentService),se(4,a.ITelemetryService),se(5,d.IFileService),se(6,m.IProductService),se(7,E.IConfigurationService)],Z),i.ExtensionGalleryService=Z;let _=class extends H{constructor(A,q,W,Y,X,de,fe){super(void 0,A,q,W,Y,X,de,fe)}};_=ve([se(0,S.IRequestService),se(1,g.ILogService),se(2,C.IEnvironmentService),se(3,a.ITelemetryService),se(4,d.IFileService),se(5,m.IProductService),se(6,E.IConfigurationService)],_),i.ExtensionGalleryServiceWithNoStorageService=_;async function ae(U,A,q,W,Y,X){const de={"X-Market-Client-Id":`VSCode ${U}`,"User-Agent":`VSCode ${U}`},fe=await(0,f.getServiceMachineId)(q,Y,X);return(0,t.supportsTelemetry)(A,q)&&(0,t.getTelemetryLevel)(W)===3&&(de["X-Market-User-Id"]=fe),de}i.resolveMarketplaceHeaders=ae}),define(J[121],Q([0,1,2,21,12,26,86,25,35,122,29,30,36]),function(x,i,T,P,b,D,R,w,l,v,E,C,c){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.TelemetryService=void 0;let y=class{constructor(g,m){this._configurationService=m,this._experimentProperties={},this._disposables=new T.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,D.escapeRegExpCharacters)(S),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(S=>{const f=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!f})})}setExperimentProperty(g,m){this._experimentProperties[g]=m}_updateTelemetryLevel(){this._telemetryLevel=(0,c.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const g=await this._commonProperties;let m=g.sessionID,S=g["common.machineId"],f=g["common.firstSessionDate"],o=g["common.msftInternal"];return{sessionId:m,machineId:S,firstSessionDate:f,msftInternal:o}}dispose(){this._disposables.dispose()}_log(g,m,S,f){return this.telemetryLevel<m?Promise.resolve(void 0):this._commonProperties.then(o=>{S=(0,P.mixin)(S,o),S=(0,P.mixin)(S,this._experimentProperties),S=(0,P.cloneAndChange)(S,a=>{if(typeof a=="string")return this._cleanupInfo(a,f)}),this._appenders.forEach(a=>a.log(g,S))},o=>{console.error(o)})}publicLog(g,m,S){return this._log(g,3,m,S)}publicLog2(g,m,S){return this.publicLog(g,m,S)}publicLogError(g,m){return this.sendErrorTelemetry?this._log(g,2,m,!0):Promise.resolve(void 0)}publicLogError2(g,m){return this.publicLogError(g,m)}_anonymizeFilePaths(g){let m=g;const S=[];for(let t of this._cleanupPatterns)for(;;){const s=t.exec(g);if(!s)break;S.push([s.index,t.lastIndex])}const f=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(m="";;){const t=o.exec(g);if(!t)break;!f.test(t[0])&&S.every(([s,e])=>t.index<s||t.index>=e)&&(m+=g.substring(a,t.index)+"<REDACTED: user-file-path>",a=o.lastIndex)}return a<g.length&&(m+=g.substr(a)),m}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const m=g.toLowerCase(),S=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(m)?"<REDACTED: secret>":S.test(m)?"<REDACTED: email>":g}_cleanupInfo(g,m){let S=g;m&&(S=this._anonymizeFilePaths(S));for(let f of this._cleanupPatterns)S=S.replace(f,"");return S=this._removePropertiesWithPossibleUserInfo(S),S}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",y=ve([se(1,w.IConfigurationService)],y),i.TelemetryService=y;function u(){const d=(0,R.localize)(0,null,v.default.nameLong),g=v.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),m=b.isWeb?"":(0,R.localize)(3,null),S=(0,R.localize)(4,null),f=(0,R.localize)(5,null),o=(0,R.localize)(6,null),a=(0,R.localize)(7,null),t=`
|       | ${S} | ${f} | ${o} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,s=(0,R.localize)(8,null);return`
${d} ${g} ${m}

&nbsp;

${a}
${t}

&nbsp;

${s}
`}E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(9,null),properties:{[C.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:u(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.Registry.as(l.Extensions.Configuration).registerConfiguration({id:C.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[C.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,R.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,R.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${C.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(J[123],Q([0,1,7,21,36]),function(x,i,T,P,b){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.AppInsightsAppender=void 0;async function D(w,l){const v=await new Promise((C,c)=>{x(["applicationinsights"],C,c)});let E;return v.defaultClient?(E=new v.TelemetryClient(w),E.channel.setUseDiskRetryCaching(!0)):(v.setup(w).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),E=v.defaultClient),w.indexOf("AIF-")===0&&(E.config.endpointUrl=l?"https://mobile.events.data.microsoft.com/collect/v1":"https://vortex.data.microsoft.com/collect/v1"),E}class R{constructor(l,v,E,C,c){this._eventPrefix=l,this._defaultData=v,this.testCollector=C,this.mirrored=c,this._defaultData||(this._defaultData=Object.create(null)),typeof E=="function"?this._aiClient=E():this._aiClient=E,this._asyncAIClient=null}_withAIClient(l){if(!!this._aiClient){if(typeof this._aiClient!="string"){l(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient,this.testCollector??!1)),this._asyncAIClient.then(v=>{l(v)},v=>{(0,T.onUnexpectedError)(v),console.error(v)})}}log(l,v){!this._aiClient||(v=(0,P.mixin)(v,this._defaultData),v=(0,b.validateTelemetryData)(v),this.testCollector&&(v.properties["common.useragent"]=this.mirrored?"mirror-collector++":"collector++"),this._withAIClient(E=>E.trackEvent({name:this._eventPrefix+"/"+l,properties:v.properties,measurements:v.measurements})))}flush(){return this._aiClient?new Promise(l=>{this._withAIClient(v=>{v.flush({callback:()=>{this._aiClient=void 0,l(void 0)}})})}):Promise.resolve(void 0)}}i.AppInsightsAppender=R}),define(J[124],Q([0,1,6,13]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buildTelemetryMessage=void 0;async function b(D,R){const w=Object.create(null),l=(E,C)=>{const c=JSON.parse(E);w[C]=c};if(R){const E=[],C=await P.Promises.readdir(R);for(const y of C)try{(await P.Promises.stat((0,T.join)(R,y))).isDirectory()&&E.push(y)}catch{}const c=[];for(const y of E)(await P.Promises.readdir((0,T.join)(R,y))).filter(d=>d==="telemetry.json").length===1&&c.push(y);for(const y of c){const u=(await P.Promises.readFile((0,T.join)(R,y,"telemetry.json"))).toString();l(u,y)}}let v=(await P.Promises.readFile((0,T.join)(D,"telemetry-core.json"))).toString();return l(v,"vscode-core"),v=(await P.Promises.readFile((0,T.join)(D,"telemetry-extensions.json"))).toString(),l(v,"vscode-extensions"),JSON.stringify(w,null,4)}i.buildTelemetryMessage=b}),define(J[37],Q([0,1,14]),function(x,i,T){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.IUriIdentityService=void 0,i.IUriIdentityService=(0,T.createDecorator)("IUriIdentityService")}),define(J[125],Q([0,1,10,2,8,20,23,16,15,37]),function(x,i,T,P,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsWatcher=void 0;let E=class extends P.Disposable{constructor(c,y,u,d,g){super();this.extensionsManagementService=c,this.logService=d,this.uriIdentityService=g,this._onDidChangeExtensionsByAnotherSource=this._register(new T.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(S=>{this.installedExtensions=S.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(c.onInstallExtension(S=>this.onInstallExtension(S))),this._register(c.onDidInstallExtensions(S=>this.onDidInstallExtensions(S))),this._register(c.onDidUninstallExtension(S=>this.onDidUninstallExtension(S)));const m=b.URI.file(u.extensionsPath);this._register(y.watch(m)),this._register(T.Event.filter(y.onDidChangeFilesRaw,S=>S.changes.some(f=>this.doesChangeAffects(f,m)))(()=>this.onDidChange()))}doesChangeAffects(c,y){return this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(c.resource),y)?this.uriIdentityService.extUri.isEqual(c.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!(c.type!==1&&c.type!==2||this.uriIdentityService.extUri.basename(c.resource).startsWith(".")):!1}onInstallExtension(c){this.addInstallingExtension(c.identifier)}onDidInstallExtensions(c){for(const y of c)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(c){c.error||this.removeInstalledExtension(c.identifier)}addInstallingExtension(c){this.removeInstallingExtension(c),this.installingExtensions.push(c)}removeInstallingExtension(c){this.installingExtensions=this.installingExtensions.filter(y=>!(0,R.areSameExtensions)(y,c))}addInstalledExtension(c){this.installedExtensions&&(this.removeInstalledExtension(c),this.installedExtensions.push(c))}removeInstalledExtension(c){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,R.areSameExtensions)(y,c)))}async onDidChange(){if(this.installedExtensions){const c=await this.extensionsManagementService.getInstalled(1),y=c.filter(d=>[...this.installingExtensions,...this.installedExtensions].some(g=>(0,R.areSameExtensions)(g,d.identifier))?!1:d.installedTimestamp&&d.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",d.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",d.identifier.id),!1)),u=this.installedExtensions.filter(d=>this.installingExtensions.some(g=>(0,R.areSameExtensions)(g,d))?!1:c.every(g=>!(0,R.areSameExtensions)(g.identifier,d))?(this.logService.info("Detected extension removed from another source",d.id),!0):!1);this.installedExtensions=c.map(d=>d.identifier),(y.length||u.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:u})}}};E=ve([se(1,w.IFileService),se(2,D.INativeEnvironmentService),se(3,l.ILogService),se(4,v.IUriIdentityService)],E),i.ExtensionsWatcher=E}),define(J[126],Q([0,1,37,91,16,18,59,10,2]),function(x,i,T,P,b,D,R,w,l){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.UriIdentityService=void 0;class v{constructor(c){this.uri=c,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let E=class{constructor(c){this._fileService=c,this._dispooables=new l.DisposableStore,this._limit=2**16;const y=new Map,u=d=>{let g=y.get(d.scheme);return g===void 0&&(g=c.hasProvider(d)&&!this._fileService.hasCapability(d,1024),y.set(d.scheme,g)),g};this._dispooables.add(w.Event.any(c.onDidChangeFileSystemProviderRegistrations,c.onDidChangeFileSystemProviderCapabilities)(d=>{y.delete(d.scheme)})),this.extUri=new D.ExtUri(u),this._canonicalUris=new R.SkipList((d,g)=>this.extUri.compare(d,g,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(c){this._fileService.hasProvider(c)&&(c=(0,D.normalizePath)(c));let y=this._canonicalUris.get(c);return y?y.touch().uri.with({fragment:c.fragment}):(this._canonicalUris.set(c,new v(c)),this._checkTrim(),c)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const c=[...this._canonicalUris.entries()].sort((u,d)=>u[1].touch<d[1].touch?1:u[1].touch>d[1].touch?-1:0);v._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let u=0;u<y;u++)this._canonicalUris.set(c[u][0],c[u][1].touch())}};E=ve([se(0,b.IFileService)],E),i.UriIdentityService=E,(0,P.registerSingleton)(T.IUriIdentityService,E,!0)}),define(J[45],Q([0,1,48,3,6,11,13,72,138,139]),function(x,i,T,P,b,D,R,w,l,v){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.buffer=i.extract=i.zip=i.ExtractError=void 0;class E extends Error{constructor(t,s){let e=s.message;switch(t){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=t,this.cause=s}}i.ExtractError=E;function C(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(s=>t&s).reduce((s,e)=>s+e,t&61440)}function c(a){if(a instanceof E)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new E(t,a)}function y(a,t,s,e,n,r){const h=b.dirname(t),p=b.join(e,h);if(!p.startsWith(e))return Promise.reject(new Error(w.localize(0,null,t)));const L=b.join(e,t);let I;return r.onCancellationRequested(()=>{I&&I.destroy()}),Promise.resolve(R.Promises.mkdir(p,{recursive:!0})).then(()=>new Promise((O,N)=>{if(!r.isCancellationRequested)try{I=(0,T.createWriteStream)(L,{mode:s}),I.once("close",()=>O()),I.once("error",N),a.once("error",N),a.pipe(I)}catch(K){N(K)}}))}function u(a,t,s,e){let n=(0,P.createCancelablePromise)(()=>Promise.resolve()),r=0;return e.onCancellationRequested(()=>{n.cancel(),a.close()}),new Promise((h,p)=>{const L=new P.Sequencer,I=O=>{O.isCancellationRequested||(r++,a.readEntry())};a.once("error",p),a.once("close",()=>n.then(()=>{e.isCancellationRequested||a.entryCount===r?h():p(new E("Incomplete",new Error(w.localize(1,null,r,a.entryCount))))},p)),a.readEntry(),a.on("entry",O=>{if(e.isCancellationRequested)return;if(!s.sourcePathRegex.test(O.fileName)){I(e);return}const N=O.fileName.replace(s.sourcePathRegex,"");if(/\/$/.test(N)){const ge=b.join(t,N);n=(0,P.createCancelablePromise)(ce=>R.Promises.mkdir(ge,{recursive:!0}).then(()=>I(ce)).then(void 0,p));return}const K=g(a,O),te=C(O);n=(0,P.createCancelablePromise)(ge=>L.queue(()=>K.then(ce=>y(ce,N,te,t,s,ge).then(()=>I(ge)))).then(null,p))})})}function d(a,t=!1){return new Promise((s,e)=>{(0,l.open)(a,t?{lazyEntries:!0}:void 0,(n,r)=>{n?e(c(n)):s((0,D.assertIsDefined)(r))})})}function g(a,t){return new Promise((s,e)=>{a.openReadStream(t,(n,r)=>{n?e(c(n)):s((0,D.assertIsDefined)(r))})})}function m(a,t){return new Promise((s,e)=>{const n=new v.ZipFile;t.forEach(h=>{h.contents?n.addBuffer(typeof h.contents=="string"?Buffer.from(h.contents,"utf8"):h.contents,h.path):h.localPath&&n.addFile(h.localPath,h.path)}),n.end();const r=(0,T.createWriteStream)(a);n.outputStream.pipe(r),n.outputStream.once("error",e),r.once("error",e),r.once("finish",()=>s(a))})}i.zip=m;function S(a,t,s={},e){const n=new RegExp(s.sourcePath?`^${s.sourcePath}`:"");let r=d(a,!0);return s.overwrite&&(r=r.then(h=>R.Promises.rm(t).then(()=>h))),r.then(h=>u(h,t,{sourcePathRegex:n},e))}i.extract=S;function f(a,t){return d(a).then(s=>new Promise((e,n)=>{s.on("entry",r=>{r.fileName===t&&g(s,r).then(h=>e(h),h=>n(h))}),s.once("close",()=>n(new Error(w.localize(2,null,t))))}))}function o(a,t){return f(a,t).then(s=>new Promise((e,n)=>{const r=[];s.once("error",n),s.on("data",h=>r.push(h)),s.on("end",()=>e(Buffer.concat(r)))}))}i.buffer=o}),define(J[127],Q([0,1,45,79]),function(x,i,T,P){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.getManifest=void 0;function b(D){return(0,T.buffer)(D,"extension/package.json").then(R=>{try{return JSON.parse(R.toString("utf8"))}catch(w){throw new Error((0,P.localize)(0,null))}})}i.getManifest=b}),define(J[128],Q([0,1,19,3,7,2,9,6,12,18,43,8,31,13,45,80,20,22,23,90,16,15,32]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d,g,m,S,f,o,a,t){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionsScanner=void 0;let s=class extends D.Disposable{constructor(n,r,h,p,L){super();this.beforeRemovingExtension=n,this.fileService=r,this.logService=h,this.environmentService=p,this.productService=L,this._devSystemExtensionsPath=null,this.systemExtensionsPath=p.builtinExtensionsPath,this.extensionsPath=p.extensionsPath,this.uninstalledPath=w.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new P.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(n){const r=[];(n===null||n===0)&&r.push(this.scanSystemExtensions().then(null,h=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(h).message,m.ExtensionManagementErrorCode.Internal)))),(n===null||n===1)&&r.push(this.scanUserExtensions(!0).then(null,h=>Promise.reject(new m.ExtensionManagementError(this.joinErrors(h).message,m.ExtensionManagementErrorCode.Internal))));try{const h=await Promise.all(r);return(0,T.flatten)(h)}catch(h){throw this.joinErrors(h)}}async scanUserExtensions(n){this.logService.trace("Started scanning user extensions");let[r,h]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return h=h.filter(p=>!r[new S.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).key()]),n&&(h=(0,S.groupByExtension)(h,L=>L.identifier).map(L=>L.sort((I,O)=>E.rcompare(I.manifest.version,O.manifest.version))[0])),this.logService.trace("Scanned user extensions:",h.length),h}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(n,r,h,p){const L=n.key(),I=w.join(this.extensionsPath,`.${(0,c.generateUuid)()}`),O=w.join(this.extensionsPath,L);try{await y.Promises.rm(O)}catch(K){try{await y.Promises.rm(O)}catch(te){}throw new m.ExtensionManagementError((0,d.localize)(0,null,O,n.id),m.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(n,r,I,p);let N=await this.scanExtension(C.URI.file(I),1);if(!N)throw new Error((0,d.localize)(1,null,I));await this.storeMetadata(N,{...h,installedTimestamp:Date.now()});try{await this.rename(n,I,O,Date.now()+2*60*1e3),this.logService.info("Renamed to",O)}catch(K){try{await y.Promises.rm(I)}catch(te){}if(K.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",n.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(K)}. Deleted from extracted location`,I),K}try{N=await this.scanExtension(C.URI.file(O),1)}catch(K){}if(N)return N;throw new Error((0,d.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(n,r){return this.setMetadata(n,r),await this.storeMetadata(n,{...r,installedTimestamp:n.installedTimestamp}),n}async storeMetadata(n,r){r.isMachineScoped=r.isMachineScoped||void 0,r.isBuiltin=r.isBuiltin||void 0,r.installedTimestamp=r.installedTimestamp||void 0;const h=w.join(n.location.fsPath,"package.json"),p=await y.Promises.readFile(h,"utf8"),{manifest:L}=await this.parseManifest(p);return L.__metadata=r,await y.Promises.writeFile(h,JSON.stringify(L,null,"	")),n}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...n){const r=n.map(h=>new S.ExtensionIdentifierWithVersion(h.identifier,h.manifest.version));await this.withUninstalledExtensions(h=>{r.forEach(p=>h[p.key()]=!0)})}async setInstalled(n){await this.withUninstalledExtensions(p=>delete p[n.key()]);const h=(await this.scanExtensions(1)).find(p=>new S.ExtensionIdentifierWithVersion(p.identifier,p.manifest.version).equals(n))||null;return h?(await this.storeMetadata(h,{installedTimestamp:Date.now()}),this.scanExtension(h.location,1)):null}async withUninstalledExtensions(n){return this.uninstalledFileLimiter.queue(async()=>{let r;try{r=await y.Promises.readFile(this.uninstalledPath,"utf8")}catch(p){if(p.code!=="ENOENT")throw p}let h={};if(r)try{h=JSON.parse(r)}catch(p){}return n&&(n(h),Object.keys(h).length?await y.Promises.writeFile(this.uninstalledPath,JSON.stringify(h)):await y.Promises.rm(this.uninstalledPath)),h})}async removeExtension(n,r){this.logService.trace(`Deleting ${r} extension from disk`,n.identifier.id,n.location.fsPath),await y.Promises.rm(n.location.fsPath),this.logService.info("Deleted from disk",n.identifier.id,n.location.fsPath)}async removeUninstalledExtension(n){await this.removeExtension(n,"uninstalled"),await this.withUninstalledExtensions(r=>delete r[new S.ExtensionIdentifierWithVersion(n.identifier,n.manifest.version).key()])}async extractAtLocation(n,r,h,p){this.logService.trace(`Started extracting the extension from ${r} to ${h}`);try{await y.Promises.rm(h)}catch(L){throw new m.ExtensionManagementError(this.joinErrors(L).message,m.ExtensionManagementErrorCode.Delete)}try{await(0,u.extract)(r,h,{sourcePath:"extension",overwrite:!0},p),this.logService.info(`Extracted extension to ${h}:`,n.id)}catch(L){try{await y.Promises.rm(h)}catch(O){}let I=m.ExtensionManagementErrorCode.Extract;throw L instanceof u.ExtractError&&(L.type==="CorruptZip"?I=m.ExtensionManagementErrorCode.CorruptZip:L.type==="Incomplete"&&(I=m.ExtensionManagementErrorCode.IncompleteZip)),new m.ExtensionManagementError(L.message,I)}}async rename(n,r,h,p){try{await y.Promises.rename(r,h)}catch(L){if(l.isWindows&&L&&L.code==="EPERM"&&Date.now()<p)return this.logService.info(`Failed renaming ${r} to ${h} with 'EPERM' error. Trying again...`,n.id),this.rename(n,r,h,p);throw new m.ExtensionManagementError(L.message||(0,d.localize)(3,null,r,h),L.code||m.ExtensionManagementErrorCode.Rename)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const n=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return n;const r=this.scanDevSystemExtensions(),[h,p]=await Promise.all([n,r]);return[...h,...p]}async scanExtensionsInDir(n,r){const h=new P.Limiter(10),p=await this.fileService.resolve(C.URI.file(n));return p.children?(await Promise.all(p.children.filter(I=>I.isDirectory).map(I=>h.queue(async()=>r===1&&(0,v.basename)(I.resource).indexOf(".")===0?null:this.scanExtension(I.resource,r))))).filter(I=>I&&I.identifier):[]}async scanExtension(n,r){try{const h=await this.fileService.resolve(n);if(h.children){const{manifest:p,metadata:L}=await this.readManifest(n.fsPath),I=h.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,O=h.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource,N={id:(0,S.getGalleryExtensionId)(p.publisher,p.name)},K={type:r,identifier:N,manifest:p,location:n,readmeUrl:I,changelogUrl:O,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:r===0};return this.setMetadata(K,L),K}}catch(h){r!==0&&this.logService.trace(h)}return null}async scanDefaultSystemExtensions(){const n=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",n.length),n}async scanDevSystemExtensions(){const n=this.getDevSystemExtensionsList();if(n.length){const r=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",r.length),r.filter(h=>n.some(p=>(0,S.areSameExtensions)(h.identifier,{id:p})))}else return[]}setMetadata(n,r){n.publisherDisplayName=r?.publisherDisplayName||null,n.publisherId=r?.publisherId||null,n.identifier.uuid=r?.id,n.isMachineScoped=!!r?.isMachineScoped,n.isPreReleaseVersion=!!r?.isPreReleaseVersion,n.preRelease=!!r?.preRelease,n.isBuiltin=n.type===0||!!r?.isBuiltin,n.installedTimestamp=r?.installedTimestamp}async removeUninstalledExtensions(){const n=await this.getUninstalledExtensions(),r=await this.scanAllUserExtensions(),h=new Set;for(const I of r)n[new S.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]||h.add(I.identifier.id.toLowerCase());const p=(0,S.groupByExtension)(r,I=>I.identifier);await P.Promises.settled(p.map(async I=>{const O=I.sort((N,K)=>E.rcompare(N.manifest.version,K.manifest.version))[0];h.has(O.identifier.id.toLowerCase())||await this.beforeRemovingExtension(O)}));const L=r.filter(I=>n[new S.ExtensionIdentifierWithVersion(I.identifier,I.manifest.version).key()]);await P.Promises.settled(L.map(I=>this.removeUninstalledExtension(I)))}async removeOutdatedExtensions(){const n=await this.scanAllUserExtensions(),r=[],h=(0,S.groupByExtension)(n,p=>p.identifier);r.push(...(0,T.flatten)(h.map(p=>p.sort((L,I)=>E.rcompare(L.manifest.version,I.manifest.version)).slice(1)))),await P.Promises.settled(r.map(p=>this.removeExtension(p,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(n=>n.name)}joinErrors(n){const r=Array.isArray(n)?n:[n];return r.length===1?r[0]instanceof Error?r[0]:new Error(r[0]):r.reduce((h,p)=>new Error(`${h.message}${h.message?",":""}${p instanceof Error?p.message:p}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=w.normalize(w.join(R.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(n){const r=[y.Promises.readFile(w.join(n,"package.json"),"utf8").then(I=>this.parseManifest(I)),y.Promises.readFile(w.join(n,"package.nls.json"),"utf8").then(void 0,I=>I.code!=="ENOENT"?Promise.reject(I):"{}").then(I=>JSON.parse(I))],[{manifest:h,metadata:p},L]=await Promise.all(r);return{manifest:(0,f.localizeManifest)(h,L),metadata:p}}parseManifest(n){return new Promise((r,h)=>{try{const p=JSON.parse(n),L=p.__metadata||null;r({manifest:p,metadata:L})}catch(p){h(new Error((0,d.localize)(4,null)))}})}};s=ve([se(1,o.IFileService),se(2,a.ILogService),se(3,g.INativeEnvironmentService),se(4,t.IProductService)],s),i.ExtensionsScanner=s}),define(J[129],Q([0,1,27,7,9,6,12,28,18,43,8,31,13,45,78,52,20,119,22,23,110,98,127,111,128,125,51,16,14,15,32,30,37]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d,g,m,S,f,o,a,t,s,e,n,r,h,p,L,I,O,N){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.ExtensionManagementService=void 0;let K=class extends m.AbstractExtensionManagementService{constructor(V,B,ne,M,k,j,G,ee,H){super(V,B,ne,ee);this.environmentService=M,this.downloadService=k,this.fileService=G;const Z=this._register(j.createInstance(a.ExtensionsLifecycle));this.extensionsScanner=this._register(j.createInstance(e.ExtensionsScanner,ae=>Z.postUninstall(ae))),this.manifestCache=this._register(new s.ExtensionsManifestCache(M,this)),this.extensionsDownloader=this._register(j.createInstance(o.ExtensionsDownloader));const _=this._register(new n.ExtensionsWatcher(this,G,M,ne,H));this._register(_.onDidChangeExtensionsByAnotherSource(({added:ae,removed:U})=>{ae.length&&this._onDidInstallExtensions.fire(ae.map(A=>({identifier:A.identifier,operation:0,local:A}))),U.forEach(A=>this._onDidUninstallExtension.fire({identifier:A}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(async()=>{const V=await this.isAlpineLinux(),B=(0,S.getTargetPlatform)(V?"alpine":R.platform,w.arch);return this.logService.debug("ExtensionManagementService#TargetPlatform:",B),B})()),this._targetPlatformPromise}async isAlpineLinux(){if(!R.isLinux)return!1;let V;try{V=(await this.fileService.readFile(E.URI.file("/etc/os-release"))).value.toString()}catch(B){try{V=(await this.fileService.readFile(E.URI.file("/usr/lib/os-release"))).value.toString()}catch(ne){this.logService.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(ne))}}return!!V&&(V.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async zip(V){this.logService.trace("ExtensionManagementService#zip",V.identifier.id);const B=await this.collectFiles(V),ne=await(0,y.zip)((0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)()).fsPath,B);return E.URI.file(ne)}async unzip(V){return this.logService.trace("ExtensionManagementService#unzip",V.toString()),(await this.install(V)).identifier}async getManifest(V){const B=await this.downloadVsix(V),ne=D.resolve(B.fsPath);return(0,t.getManifest)(ne)}getInstalled(V=null){return this.extensionsScanner.scanExtensions(V)}async install(V,B={}){this.logService.trace("ExtensionManagementService#install",V.toString());const ne=await this.downloadVsix(V),M=await(0,t.getManifest)(D.resolve(ne.fsPath));if(M.engines&&M.engines.vscode&&!(0,r.isEngineValid)(M.engines.vscode,this.productService.version,this.productService.date))throw new Error(u.localize(0,null,(0,f.getGalleryExtensionId)(M.publisher,M.name),this.productService.version));return this.installExtension(M,ne,B)}async updateMetadata(V,B){return this.logService.trace("ExtensionManagementService#updateMetadata",V.identifier.id),V=await this.extensionsScanner.saveMetadataForLocalExtension(V,{...V.manifest.__metadata||{},...B}),this.manifestCache.invalidate(),V}async updateExtensionScope(V,B){return this.logService.trace("ExtensionManagementService#updateExtensionScope",V.identifier.id),V=await this.extensionsScanner.saveMetadataForLocalExtension(V,{...V.manifest.__metadata||{},isMachineScoped:B}),this.manifestCache.invalidate(),V}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(V){if(V.scheme===b.Schemas.file)return V;const B=(0,l.joinPath)(this.environmentService.tmpDir,(0,C.generateUuid)());return await this.downloadService.download(V,B),B}createInstallExtensionTask(V,B,ne){return E.URI.isUri(B)?new ce(V,B,ne,this.galleryService,this.extensionsScanner,this.logService):new ge(B,ne,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(V,B){return new ie(V,B,this.extensionsScanner)}async collectFiles(V){const B=async M=>{let k=await c.Promises.readdir(M);k=k.map(ee=>D.join(M,ee));const j=await Promise.all(k.map(ee=>c.Promises.stat(ee)));let G=Promise.resolve([]);return j.forEach((ee,H)=>{const Z=k[H];ee.isFile()&&(G=G.then(_=>[..._,Z])),ee.isDirectory()&&(G=G.then(_=>B(Z).then(ae=>[..._,...ae])))}),G};return(await B(V.location.fsPath)).map(M=>({path:`extension/${D.relative(V.location.fsPath,M)}`,localPath:M}))}};K=ve([se(0,S.IExtensionGalleryService),se(1,O.ITelemetryService),se(2,L.ILogService),se(3,g.INativeEnvironmentService),se(4,d.IDownloadService),se(5,p.IInstantiationService),se(6,h.IFileService),se(7,I.IProductService),se(8,N.IUriIdentityService)],K),i.ExtensionManagementService=K;class te extends m.AbstractExtensionTask{constructor(V,B,ne,M){super();this.identifier=V,this.source=B,this.extensionsScanner=ne,this.logService=M,this._operation=1}get operation(){return this._operation}async installExtension(V,B){try{const ne=await this.unsetUninstalledAndGetLocal(V.identifierWithVersion);if(ne)return V.metadata?this.extensionsScanner.saveMetadataForLocalExtension(ne,{...ne.manifest.__metadata||{},...V.metadata}):ne}catch(ne){throw R.isMacintosh?new S.ExtensionManagementError(u.localize(1,null),S.ExtensionManagementErrorCode.Internal):new S.ExtensionManagementError(u.localize(2,null),S.ExtensionManagementErrorCode.Internal)}return this.extract(V,B)}async unsetUninstalledAndGetLocal(V){if(!await this.isUninstalled(V))return null;this.logService.trace("Removing the extension from uninstalled list:",V.id);const ne=await this.extensionsScanner.setInstalled(V);return this.logService.info("Removed the extension from uninstalled list:",V.id),ne}async isUninstalled(V){return!!(await this.extensionsScanner.getUninstalledExtensions())[V.key()]}async extract({zipPath:V,identifierWithVersion:B,metadata:ne},M){let k=await this.extensionsScanner.extractUserExtension(B,V,ne,M);return this.logService.info("Extracting completed.",B.id),k}}class ge extends te{constructor(V,B,ne,M,k){super(V.identifier,V,M,k);this.gallery=V,this.options=B,this.extensionsDownloader=ne}async doRun(V){const ne=(await this.extensionsScanner.scanExtensions(null)).find(k=>(0,f.areSameExtensions)(k.identifier,this.gallery.identifier));ne&&(this._operation=2);const M=await this.downloadInstallableExtension(this.gallery,this._operation);M.metadata.isMachineScoped=this.options.isMachineScoped||ne?.isMachineScoped,M.metadata.isBuiltin=this.options.isBuiltin||ne?.isBuiltin,M.metadata.isPreReleaseVersion=this.gallery.properties.isPreReleaseVersion,M.metadata.preRelease=this.gallery.hasPreReleaseVersion?this.gallery.properties.isPreReleaseVersion:ne?.preRelease;try{const k=await this.installExtension(M,V);return ne&&v.neq(ne.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(ne),k}catch(k){throw await this.deleteDownloadedVSIX(M.zipPath),k}}async deleteDownloadedVSIX(V){try{await this.extensionsDownloader.delete(E.URI.file(V))}catch(B){this.logService.warn("Error while deleting the downloaded vsix",V.toString(),(0,P.getErrorMessage)(B))}}async downloadInstallableExtension(V,B){const ne={id:V.identifier.uuid,publisherId:V.publisherId,publisherDisplayName:V.publisherDisplayName};let M;try{this.logService.trace("Started downloading extension:",V.identifier.id),M=(await this.extensionsDownloader.downloadExtension(V,B)).fsPath,this.logService.info("Downloaded extension:",V.identifier.id,M)}catch(k){throw new S.ExtensionManagementError((0,m.joinErrors)(k).message,S.ExtensionManagementErrorCode.Download)}try{const k=await(0,t.getManifest)(M);return{zipPath:M,identifierWithVersion:new f.ExtensionIdentifierWithVersion(V.identifier,k.version),metadata:ne}}catch(k){throw await this.deleteDownloadedVSIX(M),new S.ExtensionManagementError((0,m.joinErrors)(k).message,S.ExtensionManagementErrorCode.Invalid)}}}class ce extends te{constructor(V,B,ne,M,k,j){super({id:(0,f.getGalleryExtensionId)(V.publisher,V.name)},B,k,j);this.manifest=V,this.location=B,this.options=ne,this.galleryService=M}async doRun(V){const B=new f.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),M=(await this.extensionsScanner.scanExtensions(1)).find(j=>(0,f.areSameExtensions)(this.identifier,j.identifier)),k=await this.getMetadata(this.identifier.id,V);if(k.isMachineScoped=this.options.isMachineScoped||M?.isMachineScoped,k.isBuiltin=this.options.isBuiltin||M?.isBuiltin,M)if(this._operation=2,B.equals(new f.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version)))try{await this.extensionsScanner.removeExtension(M,"existing")}catch(j){throw new Error(u.localize(3,null,this.manifest.displayName||this.manifest.name))}else v.gt(M.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(M);else{const j=await this.unsetUninstalledAndGetLocal(B);if(j)try{await this.extensionsScanner.removeExtension(j,"existing")}catch(G){throw new Error(u.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:D.resolve(this.location.fsPath),identifierWithVersion:B,metadata:k},V)}async getMetadata(V,B){try{const ne=(await this.galleryService.query({names:[V],pageSize:1},B)).firstPage[0];if(ne)return{id:ne.identifier.uuid,publisherDisplayName:ne.publisherDisplayName,publisherId:ne.publisherId}}catch(ne){}return{}}}class ie extends m.AbstractExtensionTask{constructor(V,B,ne){super();this.extension=V,this.options=B,this.extensionsScanner=ne}async doRun(V){const B=[],ne=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const M=new f.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);B.push(...ne.filter(k=>M.equals(new f.ExtensionIdentifierWithVersion(k.identifier,k.manifest.version))))}else B.push(...ne.filter(M=>(0,f.areSameExtensions)(M.identifier,this.extension.identifier)));if(!B.length)throw new Error(u.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...B),this.options.remove)for(const M of B)try{V.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(M)}catch(k){throw new Error(u.localize(6,null,(0,T.toErrorMessage)(k)))}}}}),define(J[130],Q([0,1,115,3,17,7,2,11,25,20,93,15,114,140]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.RequestService=void 0;let u=class extends R.Disposable{constructor(g,m,S){super();this.environmentService=m,this.logService=S,this.configure(g.getValue()),this._register(g.onDidChangeConfiguration(()=>this.configure(g.getValue()),this))}configure(g){this.proxyUrl=g.http&&g.http.proxy,this.strictSSL=!!(g.http&&g.http.proxyStrictSSL),this.authorization=g.http&&g.http.proxyAuthorization}async request(g,m){this.logService.trace("RequestService#request",g.url);const{proxyUrl:S,strictSSL:f}=this;let o;try{o=await(0,E.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(s){this.logService.error("RequestService#request resolving shell environment failed",s)}const a={...process.env,...o},t=g.agent?g.agent:await(0,c.getProxyAgent)(g.url||"",a,{proxyUrl:S,strictSSL:f});return g.agent=t,g.strictSSL=f,this.authorization&&(g.headers={...g.headers||{},"Proxy-Authorization":this.authorization}),this._request(g,m)}async getNodeRequest(g){return((0,T.parse)(g.url).protocol==="https:"?await new Promise((f,o)=>{x(["https"],f,o)}):await new Promise((f,o)=>{x(["http"],f,o)})).request}_request(g,m){return P.Promises.withAsyncBody(async(S,f)=>{let o;const a=(0,T.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await this.getNodeRequest(g),s={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,w.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(s.auth=g.user+":"+g.password),o=t(s,e=>{const n=(0,w.isNumber)(g.followRedirects)?g.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&n>0&&e.headers.location)this._request({...g,url:e.headers.location,followRedirects:n-1},m).then(S,f);else{let r=e;e.headers["content-encoding"]==="gzip"&&(r=e.pipe((0,y.createGunzip)())),S({res:e,stream:(0,b.streamToBufferReadableStream)(r)})}}),o.on("error",f),g.timeout&&o.setTimeout(g.timeout),g.data&&typeof g.data=="string"&&o.write(g.data),o.end(),m.onCancellationRequested(()=>{o.abort(),f((0,D.canceled)())})})}async resolveProxy(g){}};u=ve([se(0,l.IConfigurationService),se(1,v.INativeEnvironmentService),se(2,C.ILogService)],u),i.RequestService=u}),define(J[141],Q([0,1,33,3,17,27,7,2,9,6,28,8,13,25,107,52,113,20,89,120,22,109,129,16,100,103,41,97,54,55,112,15,104,122,32,44,130,118,30,121,36,123,124,37,126]),function(x,i,T,P,b,D,R,w,l,v,E,C,c,y,u,d,g,m,S,f,o,a,t,s,e,n,r,h,p,L,I,O,N,K,te,ge,ce,ie,pe,V,B,ne,M,k,j){"use strict";Object.defineProperty(i,"__esModule",{value:!0}),i.main=void 0;class G extends w.Disposable{constructor(Z){super();this.argv=Z,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[Z,_]=await this.initServices();return Z.invokeFunction(async ae=>{const U=ae.get(O.ILogService),A=ae.get(s.IFileService),q=ae.get(m.INativeEnvironmentService),W=ae.get(o.IExtensionManagementCLIService);U.info("CLI main",this.argv),this.registerErrorHandler(U),await this.doRun(q,W,A),await Promise.all(_.map(Y=>{(0,P.raceTimeout)(Y.flush(),1e3)}))})}async initServices(){const Z=new p.ServiceCollection,_={_serviceBrand:void 0,...K.default};Z.set(te.IProductService,_);const ae=new S.NativeEnvironmentService(this.argv,_);Z.set(m.INativeEnvironmentService,ae),await Promise.all([ae.appSettingsHome.fsPath,ae.extensionsPath].map(fe=>fe?c.Promises.mkdir(fe,{recursive:!0}):void 0));const U=(0,O.getLogLevel)(ae),A=[];A.push(new N.SpdLogLogger("cli",(0,v.join)(ae.logsPath,"cli.log"),!0,!1,U)),U===O.LogLevel.Trace&&A.push(new O.ConsoleLogger(U));const q=this._register(new O.MultiplexLogService(A));Z.set(O.ILogService,q);const W=this._register(new e.FileService(q));Z.set(s.IFileService,W);const Y=this._register(new n.DiskFileSystemProvider(q));W.registerProvider(l.Schemas.file,Y);const X=this._register(new u.ConfigurationService(ae.settingsResource,W));Z.set(y.IConfigurationService,X),await X.initialize(),Z.set(k.IUriIdentityService,new j.UriIdentityService(W)),Z.set(ge.IRequestService,new r.SyncDescriptor(ce.RequestService)),Z.set(d.IDownloadService,new r.SyncDescriptor(g.DownloadService)),Z.set(o.IExtensionManagementService,new r.SyncDescriptor(t.ExtensionManagementService)),Z.set(o.IExtensionGalleryService,new r.SyncDescriptor(f.ExtensionGalleryServiceWithNoStorageService)),Z.set(o.IExtensionManagementCLIService,new r.SyncDescriptor(a.ExtensionManagementCLIService)),Z.set(L.ILocalizationsService,new r.SyncDescriptor(I.LocalizationsService));const de=[];if((0,B.supportsTelemetry)(_,ae)){_.aiConfig&&_.aiConfig.asimovKey&&de.push(new ne.AppInsightsAppender("monacoworkbench",null,_.aiConfig.asimovKey));const{appRoot:fe,extensionsPath:ue,installSourcePath:re}=ae,ye={appenders:de,sendErrorTelemetry:!1,commonProperties:(async()=>{let oe;try{const he=await c.Promises.readFile((0,v.join)(ae.userDataPath,"storage.json"));oe=JSON.parse(he.toString())[pe.machineIdKey]}catch(he){he.code!=="ENOENT"&&q.error(he)}return(0,ie.resolveCommonProperties)(W,(0,T.release)(),(0,T.hostname)(),process.arch,_.commit,_.version,oe,_.msftInternalDomains,re)})(),piiPaths:[fe,ue]};Z.set(pe.ITelemetryService,new r.SyncDescriptor(V.TelemetryService,[ye]))}else Z.set(pe.ITelemetryService,B.NullTelemetryService);return[new h.InstantiationService(Z),de]}registerErrorHandler(Z){(0,R.setUnexpectedErrorHandler)(_=>{const ae=(0,D.toErrorMessage)(_,!0);!ae||Z.error(`[uncaught exception in CLI]: ${ae}`)}),process.on("uncaughtException",_=>(0,R.onUnexpectedError)(_)),process.on("unhandledRejection",_=>(0,R.onUnexpectedError)(_))}async doRun(Z,_,ae){if(this.argv["install-source"])return this.setInstallSource(Z,ae,this.argv["install-source"]);if(this.argv["list-extensions"])return _.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const U={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return _.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],U,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return _.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return _.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(Z.appRoot,Z.extensionsPath))}}asExtensionIdOrVSIX(Z){return Z.map(_=>/\.vsix$/i.test(_)?C.URI.file((0,v.isAbsolute)(_)?_:(0,v.join)((0,E.cwd)(),_)):_)}async setInstallSource(Z,_,ae){await _.writeFile(C.URI.file(Z.installSourcePath),b.VSBuffer.fromString(ae.slice(0,30)))}}async function ee(H){const Z=new G(H);try{await Z.run()}finally{Z.dispose()}}i.main=ee})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/d18d093403b12a65350c58a7b0d5771cc1f42aba/core/vs/code/node/cliProcessMain.js.map
